Package: topdownr
Title: Investigation of Fragmentation Conditions in Top-Down Proteomics
Version: 1.33.0
Authors@R: c(person("Sebastian", "Gibb", role=c("aut", "cre"),
                    email="mail@sebastiangibb.de",
                    comment=c(ORCID="0000-0001-7406-4443")),
             person("Pavel", "Shliaha", role="aut",
                    email="pavels@bmb.sdu.dk",
                    comment=c(ORCID="0000-0003-3092-0724")),
             person(c("Ole", "Nørregaard"), "Jensen", role="aut",
                    email="jenseno@bmb.sdu.dk",
                    comment=c(ORCID="0000-0003-1862-8528")))
Description: The topdownr package allows automatic and systemic investigation
    of fragment conditions. It creates Thermo Orbitrap Fusion Lumos method
    files to test hundreds of fragmentation conditions. Additionally it
    provides functions to analyse and process the generated MS data and
    determine the best conditions to maximise overall fragment coverage.
Depends: R (>= 3.5), methods, BiocGenerics (>= 0.20.0), ProtGenerics
        (>= 1.10.0), Biostrings (>= 2.42.1), S4Vectors (>= 0.12.2)
Imports: grDevices, stats, tools, utils, Biobase, Matrix (>= 1.4-2),
        MSnbase (>= 2.33.5), PSMatch (>= 1.11.4), ggplot2 (>= 2.2.1),
        mzR (>= 2.27.5)
Suggests: topdownrdata (>= 0.2), knitr, rmarkdown, ranger, testthat,
        BiocStyle, xml2
License: GPL (>= 3)
URL: https://codeberg.org/sgibb/topdownr/
BugReports: https://codeberg.org/sgibb/topdownr/issues/
LazyData: true
VignetteBuilder: knitr
Roxygen: list(markdown=TRUE)
RoxygenNote: 7.3.2
biocViews: ImmunoOncology, Infrastructure, Proteomics,
        MassSpectrometry, Coverage
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/topdownr
git_branch: devel
git_last_commit: 3979e4f
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-31
NeedsCompilation: no
Packaged: 2025-11-01 00:40:54 UTC; biocbuild
Author: Sebastian Gibb [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-7406-4443>),
  Pavel Shliaha [aut] (ORCID: <https://orcid.org/0000-0003-3092-0724>),
  Ole Nørregaard Jensen [aut] (ORCID:
    <https://orcid.org/0000-0003-1862-8528>)
Maintainer: Sebastian Gibb <mail@sebastiangibb.de>

## ----environment, echo=FALSE, message=FALSE, warning=FALSE--------------------
library("topdownr")
library("BiocStyle")

## ----citation, echo=FALSE, results="asis"-------------------------------------
ct <- format(citation("topdownr"), "textVersion")
cat(gsub("DOI: *(.*)$", "DOI: [\\1](https://doi.org/\\1)", ct), "\n")

## ----writeMethodXml, eval=FALSE-----------------------------------------------
# library("topdownr")
# 
# ## Create MS1 settings
# ms1 <- expandMs1Conditions(
#     FirstMass=400,
#     LastMass=1200,
#     Microscans=as.integer(10)
# )
# 
# ## Set TargetMass
# targetMz <- cbind(mz=c(560.6, 700.5, 933.7), z=rep(1, 3))
# 
# ## Set common settings
# common <- list(
#     OrbitrapResolution="R120K",
#     IsolationWindow=1,
#     MaxITTimeInMS=200,
#     Microscans=as.integer(40),
#     AgcTarget=c(1e5, 5e5, 1e6)
# )
# 
# ## Create settings for different fragmentation conditions
# cid <- expandTms2Conditions(
#     MassList=targetMz,
#     common,
#     ActivationType="CID",
#     CIDCollisionEnergy=seq(7, 35, 7)
# )
# hcd <- expandTms2Conditions(
#     MassList=targetMz,
#     common,
#     ActivationType="HCD",
#     HCDCollisionEnergy=seq(7, 35, 7)
# )
# etd <- expandTms2Conditions(
#     MassList=targetMz,
#     common,
#     ActivationType="ETD",
#     ETDReactionTime=as.double(1:2)
# )
# etcid <- expandTms2Conditions(
#     MassList=targetMz,
#     common,
#     ActivationType="ETD",
#     ETDReactionTime=as.double(1:2),
#     ETDSupplementalActivation="ETciD",
#     ETDSupplementalActivationEnergy=as.double(1:2)
# )
# uvpd <- expandTms2Conditions(
#     MassList=targetMz,
#     common,
#     ActivationType="UVPD"
# )
# 
# ## Create experiments with all combinations of the above settings
# ## for fragment optimisation
# exps <- createExperimentsFragmentOptimisation(
#     ms1=ms1, cid, hcd, etd, etcid, uvpd,
#     groupBy=c("AgcTarget", "replication"), nMs2perMs1=10, scanDuration=0.5,
#     replications=2, randomise=TRUE
# )
# 
# ## Write experiments to xml files
# writeMethodXmls(exps=exps)
# 
# ## Run XMLMethodChanger
# runXmlMethodChanger(
#     modificationXml=list.files(pattern="^method.*\\.xml$"),
#     templateMeth="TMS2IndependentTemplateForTD.meth",
#     executable="path\\to\\XmlMethodChanger.exe"
# )

## ----ScanHeadsman, eval=FALSE-------------------------------------------------
# runScanHeadsman(
#     path="path\\to\\raw-files",
#     executable="path\\to\\ScanHeadsman.exe"
# )

## ----sessioninfo--------------------------------------------------------------
sessionInfo()

## ----environment, echo=FALSE, message=FALSE, warning=FALSE--------------------
library("topdownr")
library("topdownrdata")
library("ranger")
library("ggplot2")
library("BiocStyle")

## ----citation, echo=FALSE, results="asis"-------------------------------------
ct <- format(citation("topdownr"), "textVersion")
cat(gsub("DOI: *(.*)$", "DOI: [\\1](https://doi.org/\\1)", ct), "\n")

## ----loadPackage--------------------------------------------------------------
library("topdownr")

## ----listFiles, eval=-1, echo=1, comment=NA-----------------------------------
list.files(topdownrdata::topDownDataPath("myoglobin"))
lapply(
    topdownr:::.listTopDownFiles(
        topdownrdata::topDownDataPath("myoglobin")),
    function(x) {
        c(head(
            file.path(
                "...",
                paste(
                    tail(strsplit(dirname(x), "/")[[1L]], 2),
                    collapse=.Platform$file.sep
                ),
                basename(x)
            ),
            2
        ), "...")
    }
)

## ----importFiles, warnings=FALSE----------------------------------------------
## the mass adduct for a proton
H <- 1.0078250321

myoglobin <- readTopDownFiles(
    ## directory path
    path = topdownrdata::topDownDataPath("myoglobin"),
    ## fragmentation types
    type = c("a", "b", "c", "x", "y", "z"),
    ## adducts (add -H/H to c/z and name
    ## them cmH/zpH (c minus H, z plus H)
    adducts = data.frame(
        mass=c(-H, H),
        to=c("c", "z"),
        name=c("cmH", "zpH")),
    ## initiator methionine removal
    modifications = "Met-loss",
    ## don't use neutral loss
    neutralLoss = NULL,
    ## tolerance for fragment matching
    tolerance = 5e-6,
    ## topdownrdata was generate with an older version of topdownr,
    ## the method files were generated with FilterString identification,
    ## use `conditions = "ScanDescription"` (default) for recent data.
    conditions = "FilterString"
)

myoglobin

## ----rowViews-----------------------------------------------------------------
rowViews(myoglobin)

## ----colData------------------------------------------------------------------
conditionData(myoglobin)[, 1:5]

## ----assayData----------------------------------------------------------------
assayData(myoglobin)[206:215, 1:10]

## ----subsetting---------------------------------------------------------------
# select the first 100 fragments
myoglobin[1:100]

# select all "c" fragments
myoglobin["c"]

# select just the 100. "c" fragment
myoglobin["c100"]

# select all "a" and "b" fragments but just the first 100 "c"
myoglobin[c("a", "b", paste0("c", 1:100))]

# select condition/run 1 to 10
myoglobin[, 1:10]

# select all conditions from one file
myoglobin[, myoglobin$File == "myo_1211_ETDReagentTarget_1e+06_1"]

# select all "c" fragments from a single file
myoglobin["c", myoglobin$File == "myo_1211_ETDReagentTarget_1e+06_1"]

## ----plotting, eval=1:2-------------------------------------------------------
# plot a single condition
plot(myoglobin[, "C0707.30_1.0e+05_1.0e+06_10.00_00_28_3"])
# example to plot the first ten conditions into a pdf
# (not evaluated in the vignette)
pdf("topdown-conditions.pdf", paper="a4r", width=12)
plot(myoglobin[, 1:10])
dev.off()

## ----importFiles2, ref.label="import_files", eval=FALSE-----------------------
# NA

## ----filterInjectionTimes-----------------------------------------------------
injTimeBefore <- colData(myoglobin)
injTimeBefore$Status <- "before filtering"

## filtering on max deviation and just keep the
## 2 technical replicates per condition with the
## lowest deviation
myoglobin <- filterInjectionTime(
    myoglobin,
    maxDeviation = log2(3),
    keepTopN = 2
)

myoglobin

injTimeAfter <- colData(myoglobin)
injTimeAfter$Status <- "after filtering"

injTime <- as.data.frame(rbind(injTimeBefore, injTimeAfter))

## use ggplot for visualisation
library("ggplot2")

ggplot(injTime,
    aes(x = as.factor(AgcTarget),
        y = IonInjectionTimeMs,
        group = AgcTarget)) +
    geom_boxplot() +
    facet_grid(Status ~ Mz)

## ----filterCv-----------------------------------------------------------------
myoglobin <- filterCv(myoglobin, threshold=30)
myoglobin

## ----filterIntensity----------------------------------------------------------
myoglobin <- filterIntensity(myoglobin, threshold=0.1)
myoglobin

## ----aggregate----------------------------------------------------------------
myoglobin <- aggregate(myoglobin)
myoglobin

## ----randomForest-------------------------------------------------------------
library("ranger")

## statistics
head(summary(myoglobin))

## number of fragments
nFragments <- summary(myoglobin)$Fragments

## features of interest
foi <- c(
    "AgcTarget",
    "EtdReagentTarget",
    "EtdActivation",
    "CidActivation",
    "HcdActivation",
    "Charge"
)

rfTable <- as.data.frame(colData(myoglobin)[foi])

## set NA to zero
rfTable[is.na(rfTable)] <- 0

rfTable <- as.data.frame(cbind(
    scale(rfTable),
    Fragments = nFragments
))

featureImportance <- ranger(
    Fragments ~ .,
    data = rfTable,
    importance = "impurity"
)$variable.importance

barplot(
    featureImportance/sum(featureImportance),
    cex.names = 0.7
)

## ----coerce2NCBSet------------------------------------------------------------
myoglobinNcb <- as(myoglobin, "NCBSet")
myoglobinNcb

## ----bestConditions-----------------------------------------------------------
bestConditions(myoglobinNcb, n=3)

## ----fragmentationMap---------------------------------------------------------
sel <-
    myoglobinNcb$Mz == 707.3 &
    myoglobinNcb$AgcTarget == 1e6 &
    (myoglobinNcb$EtdReagentTarget == 1e7 &
     !is.na(myoglobinNcb$EtdReagentTarget))

myoglobinNcbSub <- myoglobinNcb[, sel]

fragmentationMap(
    myoglobinNcbSub,
    nCombinations = 10,
    labels = seq_len(ncol(myoglobinNcbSub))
)

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

#' Add log message.
#'
#' @param object `AbstractTopDownSet`
#' @param addDim `logical`, add dimension information
#' @return `AbstractTopDownSet`
#' @noRd
.atdsLogMsg <- function(object, ..., addDim=TRUE) {
    if (!isTRUE(inherits(object, "AbstractTopDownSet"))) {
        stop("'object' has to be an 'AbstractTopDownSet' object.")
    }
    if (addDim) {
        object@processing <- c(
            object@processing,
            .logmsg(..., "; ", .logdim(object), "."))
    } else {
        object@processing <- c(object@processing, .logmsg(...))
    }
    object
}

#' Get fragment types
#'
#' @param object `AbstractTopDownSet`
#' @return `character`
#' @noRd
fragmentType <- function(object) {
    .inheritsAbstractTopDownSet(object)
    elementMetadata(object@rowViews)$type
}

#' Test for AbstractTopDownSetclass
#'
#' @param object object to test
#' @return `TRUE` if object is an AbstractTopDownSet otherwise fails with an
#' error
#' @noRd
.inheritsAbstractTopDownSet <- function(object) {
    if (!isTRUE(inherits(object, "AbstractTopDownSet"))) {
        stop("'object' doesn't inherit 'AbstractTopDownSet'.")
    }
    TRUE
}

#' String with number of fragments and dimension of the assay.
#'
#' @param object `TopDownSet`
#' @return `character`
#' @noRd
.logdim <- function(object) {
    .inheritsAbstractTopDownSet(object)
    sprintf("%d fragments [%d;%d]",
            nnzero(object@assay), nrow(object), ncol(object))
}

#' Validate `AbstractTopDownSet`
#'
#' @param object `AbstractTopDownSet`
#' @return `TRUE` (if valid) else character with msg what was incorrect
#' @noRd
.validateAbstractTopDownSet <- function(object) {
    msg <- character()

    if (nrow(object@assay) != length(object@rowViews)) {
        msg <- c(
            msg,
            "Mismatch between fragment data in 'rowViews' and 'assay'."
        )
    }

    if (any(rownames(object@assay) != names(object@rowViews))) {
        msg <- c(
            msg,
            "Mismatch between fragment names in 'rowViews' and 'assay'."
        )
    }

    if (ncol(object@assay) != nrow(object@colData)) {
        msg <- c(
            msg,
            "Mismatch between condition data in 'colData' and 'assay'."
        )
    }

    if (any(colnames(object@assay) != rownames(object@colData))) {
        msg <- c(
            msg,
            "Mismatch between condition names in 'colData' and 'assay'."
        )
    }

    if (length(msg)) {
        msg
    } else {
        TRUE
    }
}

context("AbstractTopDownSet")

tds <- new("TopDownSet",
           rowViews=FragmentViews("ACE", mass=1:3 * 100,
                                  type=c("c", "c", "x"),
                                  start=1:3, width=c(1:2, 1),
                                  names=c("c1", "c2", "x1")),
           colData=DataFrame(Scan=1:5, File=Rle(c(rep("foo", 3),
                                                  "bar", "bar"))),
           assay=sparseMatrix(i=c(1:2, 1:3, 1, 3, 2),
                              j=rep(1:5, c(2, 3, 1, 1, 1)),
                              x=2:9),
           files=c("bar.experiments.csv", "foo.experiments.csv",
                   "foo.fasta", "bar.mzML", "foo.mzML", "bar.txt", "foo.txt"),
           processing="[2017-07-16 14:00:00] Data created.")

test_that(".atdsLogMsg", {
    expect_error(.atdsLogMsg(1L, "foo"),
                 "has to be an 'AbstractTopDownSet' object")
    expect_equal(gsub("^\\[[^]]+\\] *", "",
                      .atdsLogMsg(tds, "foobar")@processing),
                 c("Data created.", "foobar; 8 fragments [3;5]."))
    expect_equal(gsub("^\\[[^]]+\\] *", "",
                      .atdsLogMsg(tds, "foobar",
                                            addDim=FALSE)@processing),
                 c("Data created.", "foobar"))
})

test_that("combine", {
    tds$Mz <- 100
    tds$AgcTarget <- 1e5
    tds$EtdReagentTarget <- 1e6
    tds$EtdActivation <- tds$CidActivation <- tds$HcdActivation <- NA_real_
    tds$UvpdActivation <- (1:5) * 1000
    tds$IonInjectionTimeMs <- 1:5
    tds@tolerance <- 5e-6
    rownames(tds@assay) <- rownames(tds)
    tds <- updateConditionNames(tds)
    tds1 <- tds2 <- tds
    o <- c(matrix(1:10, nrow=2, byrow=TRUE))
    a <- cbind(tds1@assay, tds2@assay)[, o]
    cd <- .colsToRle(rbind(tds1@colData, tds2@colData)[o, ])
    colnames(a) <- rownames(cd) <- paste0("C", rep((1:5) * 1000, each=2), "_",
                                          rep(1:2, 5))
    tdsr <- new("TopDownSet",
                rowViews=tds@rowViews,
                colData=cd,
                assay=a,
                tolerance=5e-6,
                files=unique(tds1@files, tds2@files),
                processing=c(tds1@processing, tds2@processing,
                             paste("[2017-12-28 15:30:00]",
                                   "Condition names updated based on: Mz,",
                                   "AgcTarget, EtdReagentTarget,",
                                   "EtdActivation, CidActivation,",
                                   "HcdActivation, UvpdActivation. Order of",
                                   "conditions changed. 5 conditions."),
                             paste("[2017-12-28 15:30:01]",
                                   "Recalculate median injection time based",
                                   "on: Mz, AgcTarget."),
                             paste("[2017-12-28 15:30:02]",
                                   "Combined 8 fragments [3;5] and 8 fragments",
                                   "[3;5] into a 16 fragments [3;10]",
                                   "TopDownSet object.")))
    tdsr$MedianIonInjectionTimeMs <- Rle(3, 10)
    expect_equal(combine(tds1, tds2), tdsr)

    tds2@rowViews <- FragmentViews("ACE", mass=1:3*90,
                                   type=c("b", "b", "z"),
                                   start=1:3, width=c(1:2, 1),
                                   names=c("b1", "b2", "z1"))
    rownames(tds2@assay) <- c("b1", "b2", "z1")

    tdsr@rowViews <- FragmentViews("ACE", mass=rep(1:3, each=2) * c(90, 100),
                                   type=c("b", "c", "b", "c", "z", "x"),
                                   start=rep(1:3, each=2),
                                   width=rep(c(1:2, 1), each=2),
                                   names=c("b1", "c1", "b2", "c2", "z1", "x1"))
    tdsr@assay <- sparseMatrix(
        i=c(rep(1:4, each=3), rep(5:6, each=2)),
        j=c(2, 4, 6, 1, 3, 5, 2, 4, 10, 1, 3, 9, 4, 8, 3, 7),
        x=c(rep(c(2, 4, 7), 2), rep(c(3, 5, 9), 2), rep(c(6, 8), 2)),
        dimnames=list(c("b1", "c1", "b2", "c2", "z1", "x1"), colnames(a))
    )
    tdsr@processing[7] <- paste("[2017-12-28 15:30:02]",
                                "Combined 8 fragments [3;5] and 8 fragments",
                                "[3;5] into a 16 fragments [6;10]",
                                "TopDownSet object.")

    expect_equal(combine(tds1, tds2), tdsr)
})

test_that("fragmentTypes", {
    expect_error(fragmentType(1L), "doesn't inherit 'AbstractTopDownSet'")
    expect_equal(fragmentType(tds), factor(c("c", "c", "x")))
})

test_that(".inheritsAbstractTopDownSet", {
    expect_true(.inheritsAbstractTopDownSet(new("TopDownSet")))
    expect_true(.inheritsAbstractTopDownSet(new("NCBSet")))
    expect_error(.inheritsAbstractTopDownSet(1L),
                 "doesn't inherit 'AbstractTopDownSet'")
})

test_that(".logdim", {
    expect_error(.logdim(1L))
    expect_equal(.logdim(new("TopDownSet")), "0 fragments [0;0]")
    expect_equal(.logdim(tds), "8 fragments [3;5]")
})

test_that("updateConditionNames", {
    expect_error(updateConditionNames(tds, "Foo"), "must contain names")
    expect_message(updateConditionNames(tds, c("Foo", "Bar", "File"),
                                        verbose=TRUE),
                   "Foo, Bar is/are not present and ignored.")
    expect_message(updateConditionNames(tds, c("File", "Scan"),
                                        verbose=TRUE),
                   "Order of conditions changed.")
    tdn <- tds[, c(4:5, 1:3)]
    colnames(tdn@assay) <- rownames(tdn@colData) <-
        paste0("C", rep(c("bar", "foo"), 2:3), "_", c(4:5, 1:3))
    tdn$Sample <- 1:5
    tdn@processing <- c("[2017-12-23 19:40:00] Data created.",
                        paste0("[2017-12-23 19:40:01] Condition names updated ",
                               "based on: File, Scan. ",
                               "Order of conditions changed. 5 conditions."))
    expect_equal(updateConditionNames(tds, c("File", "Scan"), verbose=FALSE),
                 tdn)
})

test_that("updateMedianInjectionTime", {
    tdn <- tds
    tdn@colData$IonInjectionTimeMs <- 1:5
    tdn@colData$Mz <- tdn@colData$AgcTarget <- rep(1:2, 3:2)
    expect_error(updateMedianInjectionTime(tdn, 1:10), "data length")
    tdr <- tdn
    tdr@colData$MedianIonInjectionTimeMs <- Rle(rep(c(2, 4.5), 3:2))
    tdr@processing <- c(tdr@processing,
                        paste0("[2017-12-20 21:00:00] ",
                               "Recalculate median injection time ",
                               "based on: Mz, AgcTarget."))
    expect_equal(updateMedianInjectionTime(tdn), tdr)
    tdr@colData$Mz <- tdn@colData$Mz <- 1
    tdr@colData$MedianIonInjectionTimeMs <- Rle(3, 5)
    tdr@processing <- c(tdn@processing,
                        paste0("[2017-12-20 21:00:00] ",
                               "Recalculate median injection time."))
    expect_equal(updateMedianInjectionTime(tdn, by=tdn$Mz), tdr)
})

#' @describeIn TopDownSet Aggregate conditions/runs.
#'
#' Aggregates conditions/runs (columns) in an
#' [TopDownSet-class] object
#' `by` a
#' user-given value (default is the
#' `"Sample"` column of `colData`
#' which has the same value for technical replicates).
#' It combines intensity values and numeric metadata of the grouped
#' conditions/runs (columns) by `mean` and returns a reduced
#' [TopDownSet-class] object.
#'
#' @param x,object `TopDownSet`
#' @param by `list`,
#' grouping variable, in general it refers to technical
#' @param \ldots arguments passed to internal/other methods.
#' replicates (that's why the default is the
#' `"Sample"` column in `colData`).
## @return `TopDownSet`
#' @aliases aggregate,TopDownSet-method
#' @export
setMethod("aggregate", "TopDownSet",
          function(x, by=x$Sample, ...) {
    d0 <- .logdim(x)
    groups <- .groupByLabels(by)

    if (length(groups) != ncol(x)) {
        stop("'by' has to be of the same length as 'ncol(x)'.")
    }
    x@assay <- .rowMeansGroup(x@assay, groups)
    x@colData <- .aggregateDataFrame(
        x@colData, groups, ignoreNumCols=c("Scan", "Condition")
    )

    d1 <- .logdim(x)

    if (validObject(x)) {
        .atdsLogMsg(x, "Aggregated ", d0, " to ", d1, ".", addDim=FALSE)
    }
})

#' @describeIn TopDownSet Combine `TopDownSet` objects.
#'
#' `combine` allows to combine two or more `TopDownSet` objects.
#' Please note that it uses the default
#' `sampleColumns` to define technical replicates (see [readTopDownFiles()]).and
#' the default `by` argument to group ion injection times for the calculation of
#' the median time (see [updateMedianInjectionTime()]). Both could be modified
#' after `combine` by calling [updateConditionNames()] (with modified
#' `sampleColumns` argument) and [updateMedianInjectionTime()] (with modified
#' `by` argument).
#'
## @param x `TopDownSet`
## @param y `TopDownSet`
## @param \ldots
#' @aliases combine,TopDownSet,TopDownSet-method
#' @export
setMethod("combine",
          signature(x="TopDownSet", y="TopDownSet"),
          function(x, y) {

    x <- callNextMethod()

    if (x@tolerance != y@tolerance) {
        warning("Matching tolerance differs, choosing the larger one.")
    }
    x@tolerance <- max(x@tolerance, y@tolerance)

    if (any(x@redundantMatching != y@redundantMatching)) {
        warning(
            "Matching strategies differ, ",
            "keeping the strategy of object 'x'."
        )
    }

    if (validObject(x)) {
        x
    }
})

#' @describeIn TopDownSet Filter by CV.
#'
#' Filtering is done by coefficient of variation across technical replicates
#' (defined by the `by` argument).
#' All fragments below a given `threshold`
#' are removed. The `threshold` is the maximal allowed CV in percent
#' (`sd/mean * 100 < threshold`).
#'
## @param object `TopDownSet`
#' @param threshold `double`, threshold variable.
## @param by `list`, how technical replicates are defined.
## @return `TopDownSet`
#' @aliases filterCv filterCv,TopDownSet-method
#' @export
setMethod("filterCv", "TopDownSet",
          function(object, threshold, by=object$Sample, ...) {
    if (!is.numeric(threshold) || !length(threshold) == 1L) {
        stop("'threshold' has to be a 'numeric' of length one.")
    }

    if (threshold < 0) {
        stop("'threshold' has to be greater than 0.")
    }

    n0 <- nnzero(object@assay)

    group <- .groupByLabels(by)
    mm <- .createMaskMatrix(group)
    cvs <- tcrossprod(.rowCvsGroup(object@assay, group, na.rm=TRUE), mm)
    object@assay[Matrix::which(cvs * 100L > threshold)] <- 0L
    object@assay <- drop0(object@assay, is.Csparse=TRUE)

    n1 <- nnzero(object@assay)
    if (n0 - n1) {
        object <- .atdsLogMsg(
            object, n0 - n1, " fragments with CV > ", threshold, "% filtered"
        )

    }
    if (validObject(object)) {
        object
    }
})

#' @describeIn TopDownSet Filter by ion injection time.
#'
#' Filtering is done by maximal allowed deviation and just the technical
#' `keepTopN` replicates with the lowest deviation from the median ion
#' injection time are kept.
#'
## @param object `TopDownSet`
#' @param maxDeviation `double`,
#' maximal allowed deviation in the `log2`
#' injection time in ms in comparison to the median ion injection time.
#' @param keepTopN `integer`, how many technical replicates should be kept?
## @param by `list`, how technical replicates are defined.
## @return `TopDownSet`
#' @aliases filterInjectionTime filterInjectionTime,TopDownSet-method
#' @export
setMethod("filterInjectionTime", "TopDownSet",
          function(object, maxDeviation=log2(3), keepTopN=2,
                   by=object$Sample, ...) {
    if (!is.numeric(maxDeviation) || !length(maxDeviation) == 1L) {
        stop("'maxDeviation' has to be a 'numeric' of length one.")
    }

    if (maxDeviation < 0) {
        stop("'maxDeviation' has to be greater than 0.")
    }

    lr <- as.vector(
        abs(log2(object$IonInjectionTimeMs / object$MedianIonInjectionTimeMs))
    )

    i <- intersect(
        which(lr <= maxDeviation), .topIdx(-lr, .groupByLabels(by), n=keepTopN)
    )

    if (length(i) && length(i) != ncol(object)) {
        n0 <- ncol(object)
        object <- object[, i]
        n1 <- ncol(object)
        nd <- n0 - n1
        object <- .atdsLogMsg(
            object, n0 - n1, " scan", if (nd > 1L) { "s" },
            " filtered with injection time deviation >= ",
            maxDeviation, " or rank >= ", keepTopN + 1L
        )
    }
    if (validObject(object)) {
        object
    }
})

#' @describeIn TopDownSet Filter by intensity.
#'
#' Filtering is done by removing all fragments that are below a given
#' (absolute/relative) intensity `threshold`.
#
## @param object `TopDownSet`
## @param threshold `double`, remove fragments with intensity below
## `threshold`.
#' @param relative `logical`,
#' if relative is `TRUE` all fragments with
#' intensity below `threshold * max(intensity)`
#' per fragment are removed,
#' otherwise all fragments below `threshold` are removed.
## @return `TopDownSet`
#' @aliases filterIntensity filterIntensity,TopDownSet-method
#' @export
setMethod("filterIntensity", "TopDownSet",
          function(object, threshold, relative=TRUE, ...) {
    if (!is.numeric(threshold) || !length(threshold) == 1L) {
        stop("'threshold' has to be a 'numeric' of length one.")
    }

    n0 <- nnzero(object@assay)

    if (relative) {
        if (1L < threshold || threshold < 0L) {
            stop("'threshold has to be between 0 and 1.")
        }
        object@assay <- .drop0rowLt(
            object@assay, tol=.rowMax(object@assay) * threshold
        )
    } else {
        object@assay <- drop0(
            object@assay,
            tol=threshold - 10L * .Machine$double.eps,
            is.Csparse=TRUE
        )
    }
    n1 <- nnzero(object@assay)
    if (n0 - n1) {
        object <- .atdsLogMsg(
            object, n0 - n1, " intensity values < ", threshold,
            if (relative) { " (relative)" }, " filtered"
        )
    }
    if (validObject(object)) {
        object
    }
})

#' @describeIn TopDownSet Filter by non-replicated fragments.
#'
#' Filtering is done by removing all fragments that don't replicate across
#' technical replicates.
#'
## @param object `TopDownSet`
#' @param minN `numeric`,
#' if less than `minN` of a fragment are found across
#' technical replicates it is removed.
## @param by `list`, how technical replicates are defined.
## @return `TopDownSet`
#' @aliases filterNonReplicatedFragments
#' filterNonReplicatedFragments,TopDownSet-method
#' @export
setMethod("filterNonReplicatedFragments", "TopDownSet",
          function(object, minN=2, by=object$Sample, ...) {
    if (!is.numeric(minN) || !length(minN) == 1L) {
        stop("'minN' has to be a 'numeric' of length one.")
    }
    minN <- as.integer(minN)

    n0 <- nnzero(object@assay)

    object@assay <- .drop0rowReplicates(
        object@assay, .groupByLabels(by), minN=minN
    )
    n1 <- nnzero(object@assay)

    if (n0 - n1) {
        object <- .atdsLogMsg(
            object, n0 - n1, " intensity values of fragments replicated < ",
            minN, " times filtered"
        )
    }
    if (validObject(object)) {
        object
    }
})

#' @describeIn TopDownSet Normalise.
#'
#' Applies *T*otal *I*on *C*urrent normalisation to a
#' [TopDownSet-class] object.
#' The normalisation ist done per scans/conditions (column-wise normalisation).
#'
## @param object `TopDownSet`
#' @param method `character`,
#' normalisation method, currently just `"TIC"`
#' for *T*otal *I*on *C*urrent
#' normalisation of the scans/conditions (column-wise normalisation)
#' is supported.
## @return `TopDownSet`
#' @aliases normalize,TopDownSet-method
#' @export
setMethod("normalize", "TopDownSet",
          function(object, method="TIC", ...) {
    method <- match.arg(method)

    if (method == "TIC") {
        object@assay <- .normaliseCols(
            object@assay, scale=object$TotIonCurrent
        )
        .atdsLogMsg(object, "Intensity values normalized to TIC.", addDim=FALSE)
    }
})

#' @describeIn TopDownSet Plotting.
#'
#' Plots an [TopDownSet-class] object. The function returns a `list`
#' of `ggplot` objects (one item per condtion).
#' Use `pdf` or another non-interactive device to plot the list of `ggplot`
#' objects (see example section).
#'
## @param x `TopDownSet`
#' @param y `missing`, not used.
#' @param verbose `logical`, verbose output?
#' @examples
#' \dontrun{
#' # plot a single condition
#' # pseudo-code (replace topdownset with your object)
#' plot(topdownset[,1])
#'
#' # plot the whole object
#' pdf("topdown-spectra.pdf", paper="a4r", width=12)
#' # pseudo-code (replace topdownset with your object)
#' plot(topdownset)
#' dev.off()
#' }
setMethod("plot", signature(x="TopDownSet", y="missing"),
          function(x, y, ..., verbose=interactive()) {

    if (verbose) {
        pb <- txtProgressBar(0L, ncol(x), style=3L)
    }

    l <- vector(mode="list", length=ncol(x))
    for (i in seq(along=l)) {
        l[[i]] <- .plot(x[, i])

        if (verbose) {
            setTxtProgressBar(pb, i)
        }
    }

    if (verbose) {
        close(pb)
    }
    l
})

#' @rdname TopDownSet-class
#' @aliases show,TopDownSet-method
#' @export
setMethod("show", "TopDownSet", function(object) {
    callNextMethod()

    if (length(object@rowViews)) {
        cat("- - - Fragment data - - -\n")
        cat("Number of theoretical fragments:", length(object@rowViews), "\n")
        fragments <- fragmentType(object)
        cat0("Theoretical fragment types (", nlevels(fragments), "): ",
            paste0(.hft(levels(fragments), n=5), collapse=", "), "\n")
        mass <- range(mz(object@rowViews))
        cat(sprintf(
            "Theoretical mass range: [%.2f;%.2f]\n", mass[1L], mass[2L])
        )
    }

    if (nrow(object@colData)) {
        cat("- - - Condition data - - -\n")
        cat("Number of conditions:", length(unique(object$Sample)), "\n")
        cat("Number of scans:", nrow(object@colData), "\n")
        cat0("Condition variables (", ncol(object@colData), "): ",
            paste0(.hft(colnames(object@colData), n=2), collapse=", "), "\n")
    }

    if (all(dim(object))) {
        cat("- - - Intensity data - - -\n")
        cat(sprintf(
            "Size of array: %dx%d (%.2f%% != 0)\n",
            nrow(object@assay), ncol(object@assay),
            nnzero(object@assay) / length(object@assay) * 100L)
        )
        if (length(object@assay@x)) {
            intensity <- range(object@assay@x)
        } else {
            intensity <- c(-NA, NA)
        }
        cat("Number of matched fragments:", nnzero(object@assay), "\n")
        cat(sprintf(
            "Intensity range: [%.2f;%.2f]\n", intensity[1L], intensity[2L])
        )
    }

    if (length(object@processing)) {
        cat("- - - Processing information - - -\n")
        cat(paste0(object@processing, collapse="\n"), "\n")
    }

    invisible(NULL)
})

#' @describeIn TopDownSet Summary statistics.
#'
#' Returns a `matrix`
#' with some statistics: number of fragments,
#' total/min/first quartile/median/mean/third quartile/maximum of
#' intensity values.
#'
## @param object `TopDownSet`
#' @param what `character`,
#' specifies whether `"conditions"` (columns; default)
#' or `"fragments"` (rows) should be summarized.
#' @aliases summary,TopDownSet-method
#' @export
setMethod("summary", "TopDownSet",
          function(object, what=c("conditions", "fragments"), ...) {
    what <- if (match.arg(what) == "conditions") { "columns" } else { "rows" }
    callNextMethod(object=object, what=what)
})

#' @rdname TopDownSet-class
#' @name coerce,TopDownSet,MSnSet-method
#' @section Coercion:
#'
#' `as(object, "MSnSet"): Coerce an [TopDownSet-class] object into an
#' [MSnbase::MSnSet-class] object.
setAs("TopDownSet", "MSnSet", function(from) {
    processing <- new(
        "MSnProcess",
        processing=from@processing,
        files=from@files
    )

    msnset <- new(
        "MSnSet",
        exprs=as.matrix(from@assay),
        phenoData=as(as(from@colData, "data.frame"), "AnnotatedDataFrame"),
        featureData=as(as(from@rowViews, "data.frame"), "AnnotatedDataFrame"),
        processingData=processing
    )

    ## processingData are overwritten by ctor
    msnset@processingData <- processing

    if (validObject(msnset)) {
        msnset
    }
})

#' @rdname TopDownSet-class
#' @name coerce,TopDownSet,NCBSet-method
#' @section Coercion:
#'
#' `as(object, "NCBSet"): Coerce an [TopDownSet-class] object into an
#' [NCBSet-class] object.
setAs("TopDownSet", "NCBSet", function(from) {
    assay <- .ncbMap(from)
    ncb <- new(
        "NCBSet",
        rowViews=Views(
            subject(from@rowViews),
            start=1L, width=seq_len(nrow(assay)
        ),
        names=rownames(assay)),
        colData=from@colData,
        assay=assay,
        files=from@files,
        processing=from@processing
    )
    colData(ncb)$AssignedIntensity <- Matrix::colSums(from@assay)
    .atdsLogMsg(ncb, "Coerced TopDownSet into an NCBSet object")
})

#' Validate `NCBSet`
#'
#' @param object `NCBSet`
#' @return `TRUE` (if valid) else character with msg what was incorrect
#' @noRd
.validateNCBSet <- function(object) {
    msg <- character()

    if (!all(object@assay@x %in% as.double(0:3))) {
        msg <- c(msg, "'assay' contains invalid values.")
    }

    if (length(msg)) {
        msg
    } else {
        TRUE
    }
}

#' List TopDown files
#'
#' List all TopDown files:
#'  - .fasta (peptide sequence)
#'  - .mzML (spectra)
#'  - .experiments.csv (fragmentation conditions)
#'  - .txt (header information)
#'
#' @param path file path
#' @param pattern filename pattern
#' @return list (splitted by file extension) with file path
#' @noRd
.listTopDownFiles <- function(path, pattern=".*") {
    files <- list.files(
        path,
        pattern=paste0(pattern, "(", .topDownFileExtRx("cfmt"), ")"),
        recursive=TRUE,
        full.names=TRUE
    )
    l <- split(normalizePath(files), .fileExt(files))
    n <- lengths(l)

    ext <- c("csv", "fasta", "mzML", "txt")

    if (!length(n) || any(!ext %in% names(l))) {
        stop(
            "Could not find any ",
            paste0(ext[!ext %in% names(l)], collapse=", "), " files!"
        )
    }

    if (n["fasta"] > 1L) {
        stop("More than one fasta file found. Consider the 'pattern' argument.")
    }

    if (!all(n["csv"] == n[!grepl("fasta", names(n))])) {
        nd <- n[!grepl("fasta", names(n))]
        stop(
            "There have to be the same number of csv, mzML and txt files. ",
            "Found: ", paste0(names(nd), "=", nd, collapse=", ")
        )
    }
    l
}

#' Read ScanHeadMans method (experiments.csv) output.
#'
#' 1 row per condition
#'
#' @param file character, filename
#' @param verbose logical, verbose output?
#' @return data.frame
#' @noRd
.readExperimentCsv <- function(file, verbose=interactive()) {
    if (.fileExt(file) != "csv")
        stop("'file' has to be a csv file with the extension '.csv'")
    d <- read.csv(file, na.strings=c("NA", "N/A"), stringsAsFactors=FALSE)
    colnames(d) <- .camelCase(colnames(d))

    .msg(verbose,
        "Reading ", nrow(d), " experiment conditions from file ", basename(file)
    )

    ## drop MS1
    d <- d[d$MsLevel == 2L, ]

    d$Condition <- seq_len(nrow(d))
    d$Mz <- .targetedMassListToMz(d$TargetedMassList)
    d$File <- gsub(.topDownFileExtRx("csv"), "", basename(file))
    d
}

#' Read fasta file.
#'
#' Stupid fasta reader, ignores comments, and keeps just the first sequence.
#'
#' @param file character, filename
#' @param verbose logical, verbose output?
#' @return character
#' @noRd
.readFasta <- function(file, verbose=interactive()) {
    aa <- readAAStringSet(file, nrec=1L, use.names=FALSE)[[1L]]
    .msg(verbose, "Reading sequence from fasta file ", basename(file))
    if (!length(aa)) {
        stop("No sequence found.")
    }
    aa
}

#' Read ScanHeadMans header (txt) output.
#'
#' 1 row per scan (could have more rows than experiments.csv, because multiple
#' scans per condition are possible).
#'
#' @param file `character`, filename
#' @param conditions `character`/`numeric`, how to create condition IDs.
#' Conditions could be read from `"ScanDescription"`, calculated on
#' `"FilterString"` or by a given number of conditions.
#' @param verbose `logical`, verbose output?
#' @return data.frame
#' @noRd
.readScanHeadsTable <- function(file, conditions="ScanDescription",
                                verbose=interactive()) {
    if (.fileExt(file) != "txt")
        stop("'file' has to be a txt file with the extension '.txt'")
    d <- read.csv(
        file,
        na.strings=c("NA", "N/A"), stringsAsFactors=FALSE, strip.white=TRUE
    )
    colnames(d) <- .camelCase(colnames(d))

    .msg(verbose,
        "Reading ", nrow(d), " header information from file ", basename(file)
    )

    ## drop MS1
    d <- d[d$MsOrder == 2L, ]

    if (is.character(conditions)) {
        ## maybe more will follow
        conditions <- match.arg(conditions, c("ScanDescription", "FilterString"))

        if (conditions == "FilterString") {
            ## Somehow the FilterString doesn't always contains the right mass
            ## label and we have to correct them.
            ## See also:
            ## - https://codeberg.org/sgibb/topdownr/issues/25
            fixedFilterStrings <- .fixFilterString(d$FilterString)
            if (nFixed <- sum(fixedFilterStrings != d$FilterString)) {
                warning(
                    nFixed, " FilterString entries modified because of ",
                    "duplicated ID for different conditions.",
                    immediate.=verbose
                )
            }
            d$FilterString <- fixedFilterStrings
            d$Condition <- as.integer(.filterStringToId(d$FilterString))

            ## Sometimes skips happen and the ID is not the same as in the
            ## FilterString (happens often in the missing_scans files)
            ## See also:
            ## - https://codeberg.org/sgibb/topdownr/issues/14
            if (is.unsorted(d$Condition)) {
                warning(
                    "ID in FilterString are not sorted in ascending order. ",
                    "Introduce own condition ID via 'cumsum'.",
                    immediate.=verbose
                )
                d$Condition <- cumsum(
                    c(TRUE, d$FilterString[-1L] != d$FilterString[-nrow(d)])
                )
            }
        } else if (conditions == "ScanDescription") {
            d$Condition <- match(d$ScanDescription, unique(d$ScanDescription))
        }
    } else if (is.numeric(conditions) && length(conditions) == 1L) {
        d$Condition <- rep_len(seq_len(conditions), nrow(d))
    } else {
        stop("'conditions' has to be a 'character' or 'numeric' of length one.")
    }

    activation <- c("ETD", "CID", "HCD", "UVPD")
    activationColumns <- .camelCase(paste0(activation, "Activation"))
    d[, activationColumns] <- NA_real_

    for (i in seq_along(activation)) {
        ## first activation
        sel <- d$Activation1 == activation[i]
        if (sum(sel)) {
            d[sel, activationColumns[i]] <- d$Energy1[sel]
        }
        ## second activation
        if (activation[i] %in% c("CID", "HCD") &&
            "Activation2" %in% names(d)) {
            sel <- d$Activation2 == activation[i]
            sel[is.na(sel)] <- FALSE
            if (sum(sel)) {
                d[sel, activationColumns[i]] <- d$Energy2[sel]
            }
        }
    }

    d$Activation <- .fragmentationMethod(d[, activationColumns])

    d$File <- gsub(.topDownFileExtRx("txt"), "", basename(file))
    d
}

#' Translate scan headsman rt to mzml scan numbers
#'
#' @param file character, filename
#' @param rt numeric
#' @param verbose logical, verbose output?
#' @return numeric
#' @noRd
.rtToScanId <- function(file, rt, verbose=interactive()) {
    .msg(verbose, "Reading scan information from file ", basename(file))

    fh <- openMSfile(file)
    on.exit(close(fh))

    hd <- header(fh)
    ## TODO: replace by MsCoreUtils::closest, because it is maintained and this
    ## function name is misleading
    i <- .matchFragments(
        rt * 60, hd$retentionTime, tolerance=1e3,
        redundantIonMatch="closest", redundantFragmentMatch="closest"
    )
    .translateThermoIdToScanId(hd$spectrumId[i])
}

#' Read MS2 Spectra (mzML)
#'
#' @param file character, filename
#' @param fmass double, fragment mass
#' @param \ldots further arguments passed to .matchFragments
#' @param verbose logical, verbose output?
#' @return list (with data.frame for header and sparseMatrix with intensity
#' values)
#' @noRd
.readMzMl <- function(file, scans, fmass, ..., verbose=interactive()) {
    .msg(verbose,
        "Reading spectra information from file ", basename(file),
        appendLF=FALSE
    )

    fh <- openMSfile(file)
    on.exit(close(fh))

    hd <- header(fh)
    hd$Scan <- .translateThermoIdToScanId(hd$spectrumId)
    i <- which(hd$msLevel == 2L & hd$Scan %in% scans)
    hd <- hd[i, , drop=FALSE]
    hd$acquisitionNum <- NULL
    colnames(hd)[grepl("seqNum", colnames(hd), fixed=TRUE)] <- "SpectrumIndex"
    hd$File <- gsub(.topDownFileExtRx("mzml"), "", basename(file))
    colnames(hd) <- .camelCase(colnames(hd))

    ## depending on the used processing software the header column totIonCurrent
    ## doesn't take deisotoping and charge state reduction into account; so we
    ## calculate TIC for our own here
    hd$TotIonCurrent <- NA_real_

    nr <- nrow(hd)
    m <- Matrix(0L, nrow=length(fmass), ncol=nr, sparse=TRUE)

    for (j in seq_along(i)) {
        pks <- peaks(fh, i[j])
        k <- .matchFragments(pks[, 1L], fmass, ...)
        notNA <- !is.na(k)
        if (sum(notNA)) {
            m[k[notNA], j] <- pks[notNA, 2L]
            hd[j, "TotIonCurrent"] <- sum(pks[, 2L])
        }
    }

    .msg(verbose,
        sprintf(" (%02.1f%%)", round(nnzero(m) / sum(hd$PeaksCount) * 100, 1L))
    )

    list(hd=hd, m=m)
}

#' Read single (complete) MS2 Spectrum (mzML)
#'
#' @param file `character`, filename
#' @param i `integer`, scan idx (in file)
#' @return `matrix` (`mzR::peaks`)
#' @noRd
.readSpectrum <- function(file, i) {
    fh <- openMSfile(file)
    on.exit(close(fh))

    if (i <= 0L || i > runInfo(fh)$scanCount) {
        stop("Invalid spectrum index. It has to be 1:",
             runInfo(fh)$scanCount, ".")
    }
    peaks(fh, i)
}

#' Merge ScanCondition and HeaderInformation
#'
#' @param sc data.frame, scan conditions
#' @param hi data.frame, header information
#' @return data.frame
#' @noRd
.mergeScanConditionAndHeaderInformation <- function(sc, hi) {
    if (!is(sc, "data.frame") || !is(hi, "data.frame"))
        stop("'sc' and 'hi' have to be of class 'data.frame'.")
    d <- merge(
        sc, hi,
        by=c("File", "Condition"),
        suffixes=c(".ScanCondition", ".HeaderInformation")
    )
    naSACe <- is.na(d$SupplementalActivationCe)
    naCid <- is.na(d$CidActivation)
    naHcd <- is.na(d$HcdActivation)
    if (any(d$SupplementalActivationCe[!naSACe] != d$Energy2[!naSACe]) ||
        any(d$SupplementalActivationCe[!(naSACe | naCid)] !=
            d$CidActivation[!(naSACe | naCid)]) ||
        any(d$SupplementalActivationCe[!(naSACe | naHcd)] !=
            d$HcdActivation[!(naSACe | naHcd)])) {
        stop("Merging of header and method information failed. ",
             "Differences in 'SupplementalActivationCe', 'Energy2', ",
             "'CidActivation' and/or 'HcdActivation' found.")
    }
    d
}

#' Merge spectra and ScanConditions/HeaderInformation (into featureData slot)
#'
#' @param mzml data.frame, header from mzML files
#' @param scdm data.frame, header from ScanHeadsman
#' @return merged data.frame
#' @noRd
.mergeSpectraAndHeaderInformation <- function(mzml, scdm) {
    d <- merge(
        mzml, scdm, sort=FALSE,
        by=c("File", "Scan"),
        suffixes=c(".SpectraInformation", ".HeaderInformation")
    )
    if (!.isEqual(d$RetentionTime, d$RtMin * 60, tolerance=1e-3)) {
        stop("The retention times from header and spectra files differ.")
    }
    d
}

context("import")

test_that(".listTopDownFiles", {
    fns <- tempfile(pattern=c("fileA_", "fileB_"))
    fasta <- tempfile(pattern="fileA_", fileext=".fasta")
    fns <- paste(rep(fns, each=3), c("experiments.csv", "mzML", "txt"),
                 sep=".")
    file.create(c(fasta, fns))
    fns <- normalizePath(fns)
    fasta <- normalizePath(fasta)
    r <- split(fns, c("csv", "mzML", "txt"))
    r$fasta <- fasta
    r <- r[order(names(r))]
    expect_equal(.listTopDownFiles(tempdir()), r)
    expect_equal(.listTopDownFiles(tempdir(), pattern="^fileA_.*"),
                 lapply(r, "[", 1L))
    expect_error(.listTopDownFiles(tempdir(), pattern="^fileB_.*"),
                 "Could not find any fasta files")
    expect_error(.listTopDownFiles(tempdir(), pattern="^fileC_.*"),
                 "Could not find any csv, fasta, mzML, txt files")
    fasta2 <- tempfile(pattern="fileB_", fileext=".fasta")
    file.create(fasta2)
    expect_error(.listTopDownFiles(tempdir()),
                 "More than one fasta file")
    fns2 <- tempfile("fileA_")
    fns2 <- paste(fns2, c("mzML", "txt"), sep=".")
    file.create(fns2)
    expect_error(.listTopDownFiles(tempdir(), pattern="^fileA_.*"),
                 paste0("There have to be the same number .*",
                        "Found: csv=1, mzML=2, txt=2", collapse=""))
    unlink(c(fasta, fasta2, fns, fns2))
})

test_that(".readExperimentCsv", {
    fn <- paste0(tempfile(), ".experiments.csv")
    d <- data.frame(MSLevel=c(1, 2, 2),
                    NaColumn=c("", "N/A", "NA"),
                    TargetedMassList=paste0("(mz=933.100", 1:3, " z=2 name=)"),
                    stringsAsFactors=FALSE)
    write.csv(d, file=fn, row.names=FALSE)
    expect_message(e <- .readExperimentCsv(fn, verbose=TRUE),
                   "Reading 3 experiment conditions from file")
    expect_equal(colnames(e),
                 c("MsLevel", "NaColumn", "TargetedMassList", "Condition",
                   "Mz", "File"))
    expect_equal(e$MsLevel, rep(2, 2))
    expect_equal(e$NaColumn, rep(NA, 2))
    expect_equal(e$Condition, 1:2)
    expect_equal(e$Mz, rep(933.1, 2))
    expect_equal(e$File, rep(gsub("\\.experiments.csv", "", basename(fn)), 2))
    unlink(fn)
})

test_that(".readFasta", {
    fn <- paste0(tempfile(), ".fasta")
    writeLines(c("> FOOBAR", "Sequence"), fn)
    expect_message(s <- .readFasta(fn, verbose=TRUE),
                   "Reading sequence from fasta file")
    expect_equal(s, AAString("Sequence"))
    writeLines(c("> FOOBAR", "> Sequence"), fn)
    expect_error(.readFasta(fn), "No sequence found")
    unlink(fn)
})

test_that(".readScanHeadsTable", {
    fn <- paste0(tempfile(), ".txt")
    d <- data.frame(MSOrder=c(1, 2, 2, 2, 2),
                    FilterString=c("ms2 100.0001@etd", "ms2 100.0001@hcd",
                                   "ms2 100.0001@hcd", "ms2 100.0007@cid",
                                   "ms2 100.0009@hcd"),
                    Activation1=c("ETD", "ETD", "ETD", "HCD", "CID"),
                    Activation2=c(NA, "HCD", "HCD", "CID", "HCD"),
                    Energy1=c(10, 50, 50, NA, 20),
                    Energy2=c(NA, 30, 30, 20, 10),
                    stringsAsFactors=FALSE)
    write.csv(d, file=fn, row.names=FALSE)
    on.exit(unlink(fn))
    expect_message(h <- .readScanHeadsTable(fn, conditions="FilterString",
                                            verbose=TRUE),
                   "Reading 5 header information from file")
    expect_equal(colnames(h),
                 c("MsOrder", "FilterString", "Activation1", "Activation2",
                   "Energy1", "Energy2", "Condition",
                   "EtdActivation", "CidActivation", "HcdActivation",
                   "UvpdActivation", "Activation", "File"))
    expect_equal(h$MsOrder, rep(2, 4))
    expect_equal(h$EtdActivation, c(50, 50, NA, NA))
    expect_equal(h$CidActivation, c(NA, NA, 20, 20))
    expect_equal(h$HcdActivation, c(30, 30, NA, 10))
    expect_equal(h$Condition, c(1, 1, 7, 9))
    expect_equal(h$File, rep(gsub("\\.txt$", "", basename(fn)), 4))

    ## .fixFilterString needed
    d <- data.frame(MSOrder=c(1, 2, 2, 2, 2),
                    FilterString=c("ms2 100.0001@etd", "ms2 100.0001@hcd",
                                   "ms2 100.0001@hcd", "ms2 100.0001@cid",
                                   "ms2 100.0003@hcd"),
                    Activation1=c("ETD", "ETD", "ETD", "HCD", "CID"),
                    Activation2=c(NA, "HCD", "HCD", "CID", "HCD"),
                    Energy1=c(10, 50, 50, NA, 20),
                    Energy2=c(NA, 30, 30, 20, 10),
                    stringsAsFactors=FALSE)
    write.csv(d, file=fn, row.names=FALSE)
    expect_warning(h <- .readScanHeadsTable(fn, conditions="FilterString",
                                            verbose=TRUE),
                   "1 FilterString entries modified")
    expect_equal(h$Condition, c(1, 1:3))

    ## .fixFilterString needed;
    ## https://github.com/sgibb/topdownr/issues/25
    d <- data.frame(MSOrder=c(1, 2, 2, 2, 2),
                    FilterString=c("ms2 100.0001@etd", "ms2 100.0001@hcd",
                                   "ms2 100.0001@hcd", "ms2 100.0001@cid",
                                   "ms2 100.0003@hcd"),
                    Activation1=c("ETD", "ETD", "ETD", "HCD", "CID"),
                    Activation2=c(NA, "HCD", "HCD", "CID", "HCD"),
                    Energy1=c(10, 50, 50, NA, 20),
                    Energy2=c(NA, 30, 30, 20, 10),
                    stringsAsFactors=FALSE)
    write.csv(d, file=fn, row.names=FALSE)
    expect_warning(h <- .readScanHeadsTable(fn, conditions="FilterString",
                                            verbose=TRUE),
                   "1 FilterString entries modified")
    expect_equal(h$Condition, c(1, 1:3))

    ## duplicated IDs in different order (missing scans files)
    ## https://github.com/sgibb/topdownr/issues/14
    d <- data.frame(MSOrder=c(1, 2, 2, 2, 2),
                    FilterString=c("ms2 100.0001@etd", "ms2 100.0001@hcd",
                                   "ms2 100.0001@hcd", "ms2 100.0007@cid",
                                   "ms2 100.0001@hcd"),
                    Activation1=c("ETD", "ETD", "ETD", "HCD", "CID"),
                    Activation2=c(NA, "HCD", "HCD", "CID", "HCD"),
                    Energy1=c(10, 50, 50, NA, 20),
                    Energy2=c(NA, 30, 30, 20, 10),
                    ScanDescription=paste0("C0", c(1, 1:4)),
                    stringsAsFactors=FALSE)
    write.csv(d, file=fn, row.names=FALSE)
    expect_warning(h <- .readScanHeadsTable(fn, conditions="FilterString",
                                            verbose=FALSE),
                   "not sorted in ascending order")
    expect_equal(h$Condition, c(1, 1:3))

    ## test conditions argument
    expect_error(.readScanHeadsTable(
                    fn, conditions="FOO", verbose=FALSE),
                 "should be one of .*FilterString.*")
    expect_error(.readScanHeadsTable(
        fn, conditions=TRUE, verbose=FALSE),
                 "'conditions' has to be a 'character' or 'numeric'")
    expect_error(.readScanHeadsTable(
        fn, conditions=1:2, verbose=FALSE),
                 "'conditions' has to be a 'character' or 'numeric'")
    expect_warning(h <- .readScanHeadsTable(
                        fn, conditions="FilterString", verbose=FALSE),
                   "not sorted in ascending order")
    expect_equal(h$Condition, c(1, 1:3))
    expect_equal(.readScanHeadsTable(
        fn, conditions="ScanDescription", verbose=FALSE)$Condition, 1:4)
    expect_equal(.readScanHeadsTable(
        fn, conditions=4, verbose=FALSE)$Condition, 1:4)
    expect_equal(.readScanHeadsTable(
        fn, conditions=2, verbose=FALSE)$Condition, c(1:2, 1:2))
})

test_that(".readSpectrum", {
    expect_error(.readSpectrum(tempfile()), "File .* not found")

    skip_if_not_installed("topdownrdata", "0.2")
    f <- file.path(topdownrdata::topDownDataPath("myoglobin"),
                   "mzml", "myo_1211_ETDReagentTarget_1e6_1.mzML.gz")
    expect_error(.readSpectrum(f, 0L), "Invalid .* 1:351")
    expect_error(.readSpectrum(f, 1e3L), "Invalid .* 1:351")
    expect_equal(.readSpectrum(f, 1L),
                 matrix(
                    c(16941.06087, 18979506.00),
                    nrow=1, dimnames = list(c(), c("mz", "intensity"))
                 )
    )
})

test_that(".mergeScanConditionAndHeaderInformation", {
    sc <- data.frame(FOO=1:3, Condition=c(1:2, 1), Both=1,
                     File=c("foo", "foo", "bar"),
                     CidActivation=1:3,
                     HcdActivation=NA,
                     Energy2=1:3)
    hi <- data.frame(BAR=1:5, Condition=c(1, 1, 2, 2, 1), Both=2,
                     File=c("bar", "bar", "bar", "foo", "foo"),
                     SupplementalActivationCe=c(3, 3, 3, 2:1))
    r <- data.frame(File=rep(c("bar", "foo"), each=2),
                    Condition=c(1, 1, 1, 2), FOO=c(3, 3, 1, 2),
                    Both.ScanCondition=c(1, 1, 1, 1),
                    CidActivation=c(3, 3, 1:2),
                    HcdActivation=NA,
                    Energy2=c(3, 3, 1:2),
                    BAR=c(1:2, 5:4),
                    Both.HeaderInformation=2,
                    SupplementalActivationCe=c(3, 3, 1, 2))
    expect_equal(.mergeScanConditionAndHeaderInformation(sc, hi), r)
    sc$CidActivation <- 0
    sc$HcdActivation <- 11:13
    expect_error(.mergeScanConditionAndHeaderInformation(sc, hi),
                 "Merging of header and method information failed")
})

test_that(".mergeSpectraAndHeaderInformation", {
    fd <- data.frame(x=1:2, Scan=1:2, File="foo", spectrum=1:2, z=1:2,
                     RetentionTime=1:2)
    hi <- data.frame(File="foo", Scan=1:2, y=3:4, z=3:4, RtMin=1:2,
                     stringsAsFactors=FALSE)

    expect_error(.mergeSpectraAndHeaderInformation(fd, hi),
                 "The retention times .* differ.")
    fd$RetentionTime <- (1:2) * 60
    r <- fd
    r$Scan <- 1:2
    r$y <- 3:4
    r$z.SpectraInformation <- r$z
    r$z.HeaderInformation <- 3:4
    r$RtMin <- 1:2
    r <- r[, c("File", "Scan", "x", "spectrum",
               "z.SpectraInformation", "RetentionTime",
               "y", "z.HeaderInformation", "RtMin")]
    expect_equal(.mergeSpectraAndHeaderInformation(fd, hi), r)
})

#' Similar to Matrix::cbind but creates missing rows (based on rownames)
#' @param ... `Matrix` objects
#' @noRd
.cbind <- function(...) {
    l <- list(...)

    if (length(l) == 1L) {
        l <- l[[1L]]
    }

    if (any(!.vapply1l(l, function(ll)inherits(ll, "Matrix"))))
        stop(
            "Could not 'cbind' because not all list members are of ",
            "class 'Matrix'."
    )
    nms <- lapply(l, rownames)
    if (!all(lengths(nms)))
        stop("Not all matrices have rownames.")
    allrn <- unique(unlist(nms))

    for (i in seq_along(l)) {
        diffrn <- setdiff(allrn, nms[[i]])
        if (length(diffrn)) {
            l[[i]] <- rbind(
                l[[i]],
                sparseMatrix(
                    i={}, j={},
                    dims=c(length(diffrn), ncol(l[[i]])),
                    dimnames=list(diffrn, colnames(l[[i]]))
                )
            )
        }
        l[[i]] <- l[[i]][allrn,]
    }
    do.call(cbind, l)
}

#' Column index
#'
#' @param x `dgCMatrix`
#' @return `numeric`, column index
#' @noRd
.col <- function(x) {
    if (!is(x, "CsparseMatrix"))
        stop("'x' is not of class 'CsparseMatrix'.")
    dp <- diff(x@p)
    rep(seq_along(dp), dp)
}

#' Count nonzero values in columns
#'
#' @param x `dgCMatrix`
#' @return `numeric`
#' @noRd
.colCounts <- function(x) {
    tabulate(.col(x), ncol(x))
}

#' colSums groupwise, similar to rowsum but for sparceMatrices
#'
#' @param x `Matrix`
#' @param group `character`/`numeric`, group identifier
#' @return `sparseMatrix`
#' @noRd
.colSumsGroup <- function(x, group) {
    if (!is(x, "Matrix"))
        stop("'x' is not of class 'Matrix'.")
    if (nrow(x) != length(group))
        stop("Length of 'group' doesn't match number of rows.")
    crossprod(.createMaskMatrix(group), x)
}

#' Count NCB fragments
#'
#' @param x `dgCMatrix`
#' @return `integer`, number of fragments per column
#' @noRd
.countFragments <- function(x) {
    if (!is(x, "dgCMatrix"))
        stop("'x' is not of class 'dgCMatrix'.")
    if (any(x@x > 3L))
        stop("Unknown fragment id.")
    i <- x@x > 1L
    x@x[i] <- x@x[i] - 1L
    Matrix::colSums(x)
}

#' mask matrix for matrix multiplication in .rowMeansGroup
#'
#' @param x `character`/`numeric`, group identifier
#' @return `sparseMatrix` with group masked
#' @noRd
.createMaskMatrix <- function(x) {
    if (!is.numeric(x)) {
        x <- match(x, unique(x))
    }
    sparseMatrix(i=seq_along(x), j=x, x=1L)
}

#' Cumulative combination of conditions
#'
#' Used for visualization in the `fragmentationMap`
#'
#' @param x `dgCMatrix`
#' @return `dgCMatrix`
#' @noRd
.cumComb <- function(x) {
    if (!is(x, "dgCMatrix") && !is.matrix(x))
        stop("'x' is not of class 'dgCMatrix'.")
    m <- x
    x1 <- x == 1L
    x2 <- x == 2L
    ## use for loop instead of apply because the latter returns a vector instead
    ## of a matrix for a one-column input matrix (vs a matrix for a multi-column
    ## input, as.matrix/t just do different things for vectors/matrices).
    for (i in seq_len(nrow(x))) {
        m[i, ] <- cummax(x1[i, ]) + cummax(x2[i, ]) * 2L
    }
    m[x == 3L] <- 3L
    for (i in seq_len(nrow(m))) {
        m[i, ] <- cummax(m[i, ])
    }
    drop0(m)
}

#' convert sparseMatrix to data.frame (for ggplot2)
#'
#' @param x `dgCMatrix`
#' @return `data.frame`
#' @noRd
.dgCMatrix2data.frame <- function(x) {
    data.frame(row=.row(x), col=.col(x), x=x@x, stringsAsFactors=FALSE)
}

#' drop0 but row-wise with length(tol) == nrow(x)
#'
#' @param x `dgCMatrix`
#' @param tol `sparseVector`/`double`, length==nrow(x), less than
#' @return `dgCMatrix`
#' @noRd
.drop0rowLe <- function(x, tol) {
    if (!is(x, "dgCMatrix"))
        stop("'x' is not of class 'dgCMatrix'.")
    if (nrow(x) != length(tol))
        stop("Number of rows in 'x' doesn't match length of 'tol'.")
    x@x[x@x <= as.vector(tol)[.row(x)]] <- 0L
    drop0(x, tol=0L, is.Csparse=TRUE)
}

.drop0rowLt <- function(x, tol) {
    if (!is(x, "dgCMatrix"))
        stop("'x' is not of class 'dgCMatrix'.")
    if (nrow(x) != length(tol))
        stop("Number of rows in 'x' doesn't match length of 'tol'.")
    x@x[x@x < as.vector(tol)[.row(x)]] <- 0L
    drop0(x, tol=0L, is.Csparse=TRUE)
}

#' drop0 but just row-wise groups with fewer than minN entries per group
#'
#' @param x `dgCMatrix`
#' @param group `character`/`numeric`, group identifier
#' @param minN `integer`, minimal number of group members > 0
#' @return `dgCMatrix`
#' @noRd
.drop0rowReplicates <- function(x, group, minN) {
    if (!is(x, "dgCMatrix"))
        stop("'x' is not of class 'dgCMatrix'.")
    if (ncol(x) != length(group))
        stop("Number of columns in 'x' doesn't match length of 'group'.")
    if (!is.integer(minN) || length(minN) != 1L)
        stop("'minN' has to be an integer of length one.")
    m <- .createMaskMatrix(group)
    l <- x
    l@x[] <- 1L
    l <- tcrossprod(l %*% m, # identical to .rowSumsGroup
                    m)
    l@x[l@x < minN] <- 0L
    l <- drop0(l, tol=0L, is.Csparse=TRUE)
    l@x[] <- 1L
    x * l
}

#' drop0 but for `NA`
#'
#' @param x `dgCMatrix`
#' @return `dgCMatrix`
#' @noRd
.dropNA <- function(x) {
    if (!is(x, "dgCMatrix"))
        stop("'x' is not of class 'dgCMatrix'.")
    x@x[is.na(x@x)] <- 0L
    drop0(x, tol=0L, is.Csparse=TRUE)
}

#' normalise (col-wise scale)
#'
#' @param x `dgCMatrix`
#' @param scale `double`, scale variable
#' @return `dgCMatrix`
#' @noRd
.normaliseCols <- function(x, scale=.rowMax(t(x))) {
    t(.normaliseRows(t(x), scale=scale))
}

#' normalise (row-wise scale)
#'
#' @param x `dgCMatrix`
#' @param scale `double`, scale variable
#' @return `dgCMatrix`
#' @noRd
.normaliseRows <- function(x, scale=.rowMax(x)) {
    if (!is(x, "dgCMatrix"))
        stop("'x' is not of class 'dgCMatrix'.")
    if ((!is.numeric(scale) && !is(scale, "sparseVector")) ||
        (length(scale) != 1L && length(scale) != nrow(x)))
        stop(
            "'scale' has to be a 'numeric' or 'sparseVector' which length ",
            "matches the number of rows in 'x'"
        )
    x@x <- x@x / scale[.row(x)]
    x
}

#' Row index
#'
#' @param x `dgCMatrix`
#' @return `numeric`, row index
#' @noRd
.row <- function(x) {
    if (!is(x, "CsparseMatrix"))
        stop("'x' is not of class 'CsparseMatrix'.")
    x@i + 1L
}

#' Count nonzero values in rows
#'
#' @param x `dgCMatrix`
#' @return `numeric`
#' @noRd
.rowCounts <- function(x) {
    tabulate(.row(x), nbins=nrow(x))
}

#' rowCvs groupwise, similar to rowsum but for sparceMatrices
#'
#' @param x `Matrix`
#' @param group `integer`/`character` group identifier
#' @param na.rm `logical`, should `NA`s removed?
#' @return `sparseMatrix`
#' @noRd
.rowCvsGroup <- function(x, group, na.rm=TRUE) {
    y <- .rowSdsGroup(x, group, na.rm)
    i <- Matrix::which(y != 0L)
    m <- .rowMeansGroup(x, group, na.rm)
    y@x <- y@x / m[i]
    y
}

#' rowMax row-wise maximum, similar to apply(x, 1, max) but faster on
#' sparseMatrix
#'
#' @param x `dgCMatrix`
#' @param na.rm `logical`, should `NA`s removed?
#' @return `sparseVector`
#' @noRd
.rowMax <- function(x, na.rm=TRUE) {
    if (!is(x, "dgCMatrix"))
        stop("'x' is not of class 'dgCMatrix'.")
    sparseVector(
        .vapply1d(split(x@x, .row(x)), max, na.rm=na.rm),
        i=sort.int(unique(.row(x))), length=nrow(x)
    )
}

#' rowMeans groupwise, similar to rowsum but for sparceMatrices
#'
#' @param x `Matrix`
#' @param group `integer`/`character` group identifier
#' @param na.rm `logical`, should `NA`s removed?
#' @return `sparseMatrix`
#' @noRd
.rowMeansGroup <- function(x, group, na.rm=TRUE) {
    if (!is(x, "Matrix"))
        stop("'x' is not of class 'Matrix'.")
    if (ncol(x) != length(group))
        stop("Number of columns in 'x' doesn't match length of 'group'.")
    if (na.rm) {
        x <- .dropNA(x)
    }
    mm <- .createMaskMatrix(group)
    m <- x %*% mm
    m@x <- m@x / ((x != 0L) %*% mm)@x
    m
}

#' rowSds groupwise, similar to rowsum but for sparceMatrices
#'
#' @param x `Matrix`
#' @param group `integer`/`character` group identifier
#' @param na.rm `logical`, should `NA`s removed?
#' @return `sparseMatrix`
#' @noRd
.rowSdsGroup <- function(x, group, na.rm=TRUE) {
    if (!is(x, "Matrix"))
        stop("'x' is not of class 'Matrix'.")
    if (ncol(x) != length(group))
        stop("Number of columns in 'x' doesn't match length of 'group'.")

    if (na.rm) {
        nna <- .dropNA(x)
    } else {
        nna <- x
    }
    nna@x[] <- 1L
    nna <- .rowSumsGroup(nna, group=group, na.rm=na.rm)
    nna@x[nna@x < 2L] <- NA_real_ # return NA if n < 2 (similar to sd)
    var <- .rowMeansGroup(x * x, group=group, na.rm=na.rm) -
        .rowMeansGroup(x, group=group, na.rm=na.rm)^2L
    nna1 <- nna
    nna1@x <- nna1@x - 1L
    var@x <- (var * nna)@x / nna1@x
    # we want a sparse matrix; NA == missing, we dropNA
    .dropNA(sqrt(var))
}

#' rowSums groupwise, similar to rowsum but for sparceMatrices
#'
#' @param x `Matrix`
#' @param group `integer`/`character` group identifier
#' @param na.rm `logical`, should `NA`s removed?
#' @return `sparseMatrix`
#' @noRd
.rowSumsGroup <- function(x, group, na.rm=TRUE) {
    if (!is(x, "Matrix"))
        stop("'x' is not of class 'Matrix'.")
    if (ncol(x) != length(group))
        stop("Number of columns in 'x' doesn't match length of 'group'.")
    if (na.rm) {
        x <- .dropNA(x)
    }
    x %*% .createMaskMatrix(group)
}

#' summary
#'
#' @param x `Matrix`
#' @param what `character`, "rows"/"columns"
#' @param na.rm `logical`, should NA removed?
#' @return `data.frame`
#' @noRd
.summary <- function(x, what=c("rows", "columns"), na.rm=TRUE) {

    if (match.arg(what) == "columns") {
        x <- t(x)
    }

    i <- sort.int(unique(.row(x)))
    qq <- matrix(0, nrow=5L, ncol=nrow(x))
    qq[, i] <- vapply(
        X=split(x@x, .row(x)), FUN=quantile, FUN.VALUE=double(5L),
        probs=seq(0, 1, 0.25), na.rm=na.rm, USE.NAMES=FALSE
    )

    data.frame(
        Fragments=.rowCounts(x),
        Total=Matrix::rowSums(x, na.rm=na.rm),
        Min=qq[1L, ],
        Q1=qq[2L, ],
        Median=qq[3L, ],
        Mean=Matrix::rowMeans(x, na.rm=na.rm),
        Q3=qq[4L, ],
        Max=qq[5L, ]
    )
}

context("Matrix")

m <- sparseMatrix(i=rep(1:4, each=5), j=rep(1:10, 2), x=1:20)

test_that(".cbind", {
    expect_error(.cbind(m, matrix(1:10, ncol=2)), "of class 'Matrix'")
    expect_error(.cbind(m, m), "rownames")
    m1 <- sparseMatrix(i=1:4, j=1:4, x=1:4,
                       dimnames=list(LETTERS[1:4], NULL))
    expect_equal(.cbind(m1, m1), cbind(m1, m1))
    m2 <- sparseMatrix(i=1:4, j=1:4, x=c(1:2, 5:6),
                       dimnames=list(LETTERS[c(1:2, 5:6)], NULL))
    mr <- sparseMatrix(i=c(1:4, 1:2, 5:6), j=1:8, x=c(1:4, 1:2, 5:6),
                       dimnames=list(LETTERS[1:6], NULL))
    expect_equal(.cbind(m1, m2), mr)
})

test_that(".col", {
    expect_error(.col(matrix(1:10, ncol=2)), "of class 'CsparseMatrix'")
    expect_equal(.col(m), rep(1:10, each=2))
})

test_that(".colCounts", {
    expect_error(.colCounts(matrix(1:10, ncol=2)), "of class 'CsparseMatrix'")
    expect_equal(.colCounts(m), rep(2, 10))
})

test_that(".colSumsGroup", {
    r <- sparseMatrix(i=rep(1:2, each=5),
                      j=1:10,
                      x=seq(12, 30, by=2))
    r2 <- sparseMatrix(i=rep(1:2, 2),
                       j=1:4,
                       x=c(15, 40, 65, 90))
    expect_error(
        .colSumsGroup(matrix(1:10, ncol=2), group=1:2), "of class 'Matrix'"
    )
    expect_error(.colSumsGroup(m, group=1:2), "Length")
    expect_equal(.colSumsGroup(m, group=rep(1:2, 2)), r)
    expect_equal(.colSumsGroup(t(m), group=rep(1:2, each=5)), r2)
})

test_that(".countFragments", {
    expect_error(.countFragments(matrix(1:10, ncol=2)), "class 'dgCMatrix'")
    expect_error(.countFragments(m))
    expect_equal(.countFragments(drop0(m %% 4)), rep(c(3, 1), 5))
})

test_that(".createMaskMatrix", {
    r1 <- sparseMatrix(i=1:10, j=rep(1:5, 2), x=1)
    r2 <- sparseMatrix(i=1:10, j=rep(1:2, each=5), x=1)
    expect_equal(.createMaskMatrix(rep(1:5, 2)), r1)
    expect_equal(.createMaskMatrix(rep(letters[1:5], 2)), r1)
    expect_equal(.createMaskMatrix(rep(1:2, each=5)), r2)
})

test_that(".cumComb", {
    a <- sparseMatrix(i=rep(1:3, 3:1),
                      j=c(1:2, 4, 3:4, 1),
                      x=c(1, 2, 2, 3, 1, 2))
    r <- sparseMatrix(i=rep(1:3, c(4, 2, 4)),
                      j=c(1:4, 3:4, 1:4),
                      x=rep(c(1, 3, 2), c(1, 5, 4)))
    a2 <- sparseMatrix(i=c(1:3),
                       j=rep(1, 3),
                       x=c(1, 2, 3))
    expect_error(.cumComb(1:10), "is not of class 'dgCMatrix'")
    expect_equal(.cumComb(a), r)
    expect_equal(.cumComb(a2), a2)
})

test_that(".dgCMatrix2data.frame", {
    d <- data.frame(row=c(rep(c(1, 3), 5), rep(c(2, 4), 5)),
                    col=rep(1:10, each=2), x=rep(1:10, each=2) + c(0, 10),
                    stringsAsFactors=FALSE)
    expect_error(.dgCMatrix2data.frame(matrix(1:10, nrow=2)))
    expect_equal(.dgCMatrix2data.frame(m), d)
})

test_that(".drop0rowLe/Lt", {
    r1 <- sparseMatrix(i=rep(1:4, each=3), j=rep(c(3:5, 8:10), 2),
                       x=c(3:5, 8:10, 13:15, 18:20))
    r2 <- sparseMatrix(i=1:10, j=rep(3:4, each=5), x=11:20)
    expect_error(.drop0rowLe(matrix(1:10, ncol=2), 1))
    expect_error(.drop0rowLt(matrix(1:10, ncol=2), 1))
    expect_error(.drop0rowLe(m, 1))
    expect_error(.drop0rowLt(m, 1))
    expect_equal(.drop0rowLe(m, c(2, 7, 12, 17)), r1)
    expect_equal(.drop0rowLt(m, c(3, 8, 13, 18)), r1)
    expect_equal(.drop0rowLe(t(m), 1:10), r2)
    expect_equal(.drop0rowLt(t(m), 2:11), r2)
})

test_that(".drop0rowReplicates", {
    group <- rep(1:5, each=2)
    expect_error(.drop0rowReplicates(matrix(1:10, ncol=2), 1))
    expect_error(.drop0rowReplicates(m, 1))
    expect_error(.drop0rowReplicates(m, group, 1.5))
    expect_error(.drop0rowReplicates(m, group, 1L:2L))
    expect_equal(.drop0rowReplicates(m, group, minN=1L), m)
    expect_equal(.drop0rowReplicates(m, group, minN=2L),
                 sparseMatrix(i=rep(1:4, each=4),
                              j=rep(c(1:4, 7:10), 2),
                              x=c(1:4, 7:10, 11:14, 17:20)))
    expect_equal(.drop0rowReplicates(m, group, minN=3L),
                 Matrix(0L, nrow=4, ncol=10, sparse=TRUE))

    expect_equal(.drop0rowReplicates(
                    sparseMatrix(i=c(1:2, 1:3, 1, 3, 2),
                                 j=rep(1:5, c(2, 3, 1, 1, 1)),
                                 x=2:9),
                    rep(1:2, 3:2), 2L),
                 sparseMatrix(i=c(1:2, 1:2, 1),
                              j=rep(1:3, c(2, 2, 1)),
                              x=c(2:5, 7), dims=c(3, 5)))
})

test_that(".dropNA", {
    r <- sparseMatrix(i=rep(1:4, each=3), j=rep(c(3:5, 8:10), 2),
                      x=c(3:5, 8:10, 13:15, 18:20))
    n <- m
    n[cbind(rep(1:4, each=2), rep(c(1:2, 6:7), 2))] <- NA
    expect_error(.dropNA(matrix(1:10, ncol=2)))
    expect_equal(.dropNA(m), m)
    expect_equal(.dropNA(n), r)
})

test_that(".normaliseCols", {
    expect_error(.normaliseCols(matrix(1:10, nrow=2)))
    expect_error(.normaliseCols(m, "A"))
    expect_error(.normaliseCols(m, 1:2))
    expect_equal(.normaliseCols(m),
                 as((scale(m, center=FALSE, scale=11:20)),
                    "dgCMatrix"))
    expect_equal(.normaliseCols(m, 11:20),
                 as((scale(m, center=FALSE, scale=11:20)),
                    "dgCMatrix"))
})

test_that(".normaliseRows", {
    .as.dgCM <- function(from)
        as(as(as(from, "dMatrix"), "generalMatrix"), "CsparseMatrix")
    expect_error(.normaliseRows(matrix(1:10, nrow=2)))
    expect_error(.normaliseRows(m, "A"))
    expect_error(.normaliseRows(m, 1:2))
    expect_equal(
        .normaliseRows(m),
        .as.dgCM((t(scale(t(m), center=FALSE, scale=c(5, 10, 15, 20)))))
    )
    expect_equal(
        .normaliseRows(m, 1:4),
        .as.dgCM((t(scale(t(m), center=FALSE, scale=1:4))))
    )
})

test_that(".row", {
    expect_error(.row(matrix(1:10, ncol=2)))
    expect_equal(.row(m), c(rep(c(1, 3), 5), rep(c(2, 4), 5)))
})

test_that(".rowCounts", {
    expect_error(.rowCounts(matrix(1:10, ncol=2)))
    expect_equal(.rowCounts(m), rep(5, 4))
})

test_that(".rowCvsGroup", {
    .rowcvs <- function(x, group, na.rm=TRUE) {
        l <- lapply(split(1L:ncol(x), group), function(i) {
            apply(x[, i, drop=FALSE], 1, function(xx) {
                      sd(xx, na.rm=na.rm) / mean(xx, na.rm=na.rm)
            })
        })
        do.call(cbind, l)
    }
    bm <- as.matrix(m)
    bm[bm == 0L] <- NA
    group <- rep(1:5, each=2)
    bmr <- .rowcvs(bm, group)
    dimnames(bmr) <- NULL
    mr <- as.matrix(.rowCvsGroup(m, group))
    mr[mr == 0L] <- NA
    dimnames(mr) <- NULL
    expect_equal(bmr, mr)

    n <- m
    n[cbind(c(1, 3, 3, 2, 2), c(1, 1, 2, 7, 8))] <- NA
    bn <- as.matrix(n)
    bn[bn == 0L] <- NA
    group <- rep(1:2, each=5)
    bnr <- .rowcvs(bn, group, na.rm=FALSE)
    dimnames(bnr) <- NULL
    nr <- as.matrix(.rowCvsGroup(n, group, na.rm=FALSE))
    nr[nr == 0L] <- NA
    dimnames(nr) <- NULL
    expect_equal(bnr, nr)

    bnr <- .rowcvs(bn, group, na.rm=TRUE)
    dimnames(bnr) <- NULL
    nr <- as.matrix(.rowCvsGroup(n, group, na.rm=TRUE))
    nr[nr == 0L] <- NA
    dimnames(nr) <- NULL
    expect_equal(bnr, nr)
})

test_that(".rowMax", {
    expect_error(.rowMax(matrix(1:10, ncol=2)))
    expect_equal(.rowMax(m), sparseVector(c(5, 10, 15, 20), 1:4, 4))
    expect_equal(as.vector(.rowMax(m)), c(5, 10, 15, 20))
    expect_equal(as.vector(.rowMax(t(m))), 11:20)

    ## na.rm
    n <- m
    n[cbind(c(1, 3, 3, 2, 2), c(1, 1, 2, 7, 8))] <- NA
    expect_equal(as.vector(.rowMax(n, na.rm=FALSE)),
                           c(rep(NA, 3), 20))
    expect_equal(as.vector(.rowMax(n, na.rm=TRUE)), c(5, 10, 15, 20))
})

test_that(".rowMeansGroup", {
    r <- sparseMatrix(i=1:4,
                      j=c(1, 2, 1, 2),
                      x=c(3, 8, 13, 18))
    r2 <- sparseMatrix(i=1:10,
                       j=rep(1:2, each=5),
                       x=6:15)
    expect_error(.rowMeansGroup(matrix(1:10, ncol=2), group=1:2))
    expect_error(.rowMeansGroup(m, group=1:2))
    expect_equal(.rowMeansGroup(m, group=rep(1:2, each=5)), r)
    expect_equal(.rowMeansGroup(t(m), group=rep(1:2, 2)), r2)

    ## na.rm
    n <- m
    n[cbind(c(1, 3, 3, 2, 2), c(1, 1, 2, 7, 8))] <- NA
    r[cbind(1:3, c(1, 2, 1))] <- NA
    expect_equal(.rowMeansGroup(n, group=rep(1:2, each=5),
                                          na.rm=FALSE), r)
    r[cbind(1:3, c(1, 2, 1))] <- c(14/4, 25/3, 14)
    expect_equal(.rowMeansGroup(n, group=rep(1:2, each=5),
                                          na.rm=TRUE), r)
})

test_that(".rowSdsGroup", {
    .rowsds <- function(x, group, na.rm=TRUE) {
        l <- lapply(split(1L:ncol(x), group), function(i) {
            apply(x[, i, drop=FALSE], 1, sd, na.rm=na.rm)
        })
        do.call(cbind, l)
    }
    bm <- as.matrix(m)
    bm[bm == 0L] <- NA
    group <- rep(1:5, each=2)
    bmr <- .rowsds(bm, group)
    dimnames(bmr) <- NULL
    mr <- as.matrix(.rowSdsGroup(m, group))
    mr[mr == 0L] <- NA
    dimnames(mr) <- NULL
    expect_equal(bmr, mr)

    n <- m
    n[cbind(c(1, 3, 3, 2, 2), c(1, 1, 2, 7, 8))] <- NA
    bn <- as.matrix(n)
    bn[bn == 0L] <- NA
    group <- rep(1:2, each=5)
    bnr <- .rowsds(bn, group, na.rm=FALSE)
    dimnames(bnr) <- NULL
    nr <- as.matrix(.rowSdsGroup(n, group, na.rm=FALSE))
    nr[nr == 0L] <- NA
    dimnames(nr) <- NULL
    expect_equal(bnr, nr)

    bnr <- .rowsds(bn, group, na.rm=TRUE)
    dimnames(bnr) <- NULL
    nr <- as.matrix(.rowSdsGroup(n, group, na.rm=TRUE))
    nr[nr == 0L] <- NA
    dimnames(nr) <- NULL
    expect_equal(bnr, nr)
})

test_that(".rowSumsGroup", {
    r <- sparseMatrix(i=rep(1:4, each=3),
                      j=rep(c(1:3, 3:5), 2),
                      x=c(3, 7, 5, 6, 15, 19, 23, 27, 15, 16, 35, 39))
    expect_error(.rowSumsGroup(matrix(1:10, ncol=2), group=1:2))
    expect_error(.rowSumsGroup(m, group=1:2))
    expect_equal(.rowSumsGroup(m, group=rep(1:5, each=2)), r)
    expect_equal(t(.rowSumsGroup(t(m), group=rep(1:2, 2))),
                 .colSumsGroup(m, group=rep(1:2, 2)))

    ## na.rm
    n <- m
    n[cbind(c(1, 3, 3, 2, 2), c(1, 1, 2, 7, 8))] <- NA
    r[cbind(c(1, 3, 2), c(1, 1, 4))] <- NA
    expect_equal(.rowSumsGroup(n, group=rep(1:5, each=2),
                                         na.rm=FALSE), r)
    r[cbind(c(1, 3, 2), c(1, 1, 4))] <- c(2, 0, 0)
    r <- drop0(r)
    expect_equal(.rowSumsGroup(n, group=rep(1:5, each=2),
                                         na.rm=TRUE), r)
})

test_that(".summary", {
    mr <- seq(1, 20, by=5)
    dr <- data.frame(Fragments=5, Total=c(15, 40, 65, 90),
                     Min=mr, Q1=mr + 1, Median=mr + 2, Mean=(mr + 2)/2,
                     Q3=mr + 3, Max=mr + 4)
    mc <- 1:10
    dc <- data.frame(Fragments=2, Total=mc * 2 + 10,
                     Min=mc, Q1=mc + 2.5, Median=mc + 5, Mean=(mc + 5)/2,
                     Q3=mc + 7.5, Max=mc + 10)
    expect_equal(.summary(m), dr)
    expect_equal(.summary(m, "row"), dr)
    expect_equal(.summary(m, "col"), dc)
})

#' aggregate data.frame (combine numeric columns by fun, and take the
#' first row for non-numeric columns
#'
#' @param x `data.frame`
#' @param f `character`, grouping value
#' @param ignoreNumCols `character`, column names that won't be aggregated by
#' fun
#' @param fun `function`, aggregation function
#' @return `data.frame`
#' @noRd
.aggregateDataFrame <- function(x, f, ignoreNumCols=character(),
                                fun=mean, na.rm=TRUE) {
    fun <- match.fun(fun)

    cn <- colnames(x)

    isNumCol <- .isNumCol(x) & !cn %in% ignoreNumCols

    nonNum <- x[!duplicated(f), !isNumCol, drop=FALSE]
    rn <- rownames(nonNum)
    num <- aggregate(
        x[, isNumCol, drop=FALSE], by=list(f), FUN=fun, na.rm=na.rm, drop=FALSE
    )
    ## resort (aggregate turns "by" into a factor (locale depended sorting))
    num <- num[match(unique(f), num[["Group.1"]]),, drop=FALSE]
    x <- .colsToRle(cbind(nonNum, num)[, cn])
    rownames(x) <- rn
    x
}

#' Convert DataFrame columns to logical
#'
#' @param x `DataFrame`
#' @return `DataFrame`
#' @noRd
.colsToLogical <- function(x) {
    toConvert <- .isCharacterCol(x)
    x[toConvert] <- lapply(x[toConvert], .characterToLogical)
    x
}

#' Convert DataFrame columns to Rle
#'
#' @param x `DataFrame`
#' @return `DataFrame`
#' @noRd
.colsToRle <- function(x) {
    r <- lapply(x, Rle)
    toConvert <- .vapply1l(r, function(rr)length(rr) >= 2L * nrun(rr))
    x[toConvert] <- r[toConvert]
    x
}

#' droplevels for Rle/factor columns
#'
#' @param x `DataFrame`
#' @return `DataFrame`
#' @noRd
.droplevels <- function(x) {
    isFactorColumn <- .vapply1l(x, function(column) {
        is.factor(column) || (is(column, "Rle") && is.factor(runValue(column)))
    })
    x[isFactorColumn] <- droplevels(x[isFactorColumn])
    x
}

#' Drop NA only columns (all rows are NA)
#'
#' @param x `data.frame`/`DataFrame`
#' @return x, without columns that are NA
#' @noRd
.dropNaColumns <- function(x) {
    keep <- !.vapply1l(x, function(xx)all(is.na(xx)))
    x[, keep, drop=FALSE]
}

#' Drop non informative columns (all rows are identical)
#'
#' @param x `data.frame`/`DataFrame`
#' @param keep `character` column names that should never be dropped.
#' @return x, without columns that are identical
#' @noRd
.dropNonInformativeColumns <- function(x, keep="Mz") {
    keep <- !.vapply1l(x, .allIdentical) | colnames(x) %in% keep
    x[, keep, drop=FALSE]
}

#' Test for character columns
#'
#' @param x `data.frame`
#' @return `logical`
#' @noRd
.isCharacterCol <- function(x) {
    .vapply1l(x, function(column) {
        is.character(column) ||
            (is(column, "Rle") && is.character(runValue(column)))
    })
}

#' Test for numeric columns
#'
#' @param x `data.frame`
#' @return `logical`
#' @noRd
.isNumCol <- function(x) {
    .vapply1l(x, function(column) {
        is.numeric(column) ||
            (is(column, "Rle") && is.numeric(runValue(column)))
    })
}

#' Make row.names
#'
#' @param x `data.frame`
#' @return `character`
#' @noRd
.makeRowNames <- function(x, prefix="C") {
    if (!is.data.frame(x) && !inherits(x, "DataFrame"))
        stop("'x' has to be a 'data.frame' or 'DataFrame'")
    x <- .dropNonInformativeColumns(x, keep=character())

    if (ncol(x)) {
        isNumCol <- .isNumCol(x)
        x[isNumCol] <- lapply(x[isNumCol], .formatNumbers, na2zero=TRUE)
        .makeNames(.groupByLabels(x, sep="_"), prefix=prefix, sep="_")
    } else {
        paste0("C", .formatNumbers(seq_len(nrow(x))))
    }
}

#' Order data.frame by multiple columns given as character vector
#'
#' @param x `data.frame`
#' @param cols `character`, column names
#' @return `integer`
#' @noRd
.orderByColumns <- function(x, cols) {
    if (!is.data.frame(x) && !inherits(x, "DataFrame"))
        stop("'x' has to be a 'data.frame' or 'DataFrame'")
    if (!all(cols %in% colnames(x)))
        stop("Some 'cols' are not valid column names of 'x'")
    do.call(order, x[cols])
}

#' Combine data.frames rowwise, similar to base::rbind but creates missing
#' columns
#'
#' @param ... `data.frame`s
#' @noRd
.rbind <- function(...) {
    l <- list(...)

    if (length(l) == 1L) {
        l <- l[[1L]]
    }

    ## do nothing for a single data.frame
    if (is.data.frame(l) || inherits(l, "DFrame")) {
        return(l)
    }

    if (
        any(!.vapply1l(l, function(ll) {
            is.data.frame(ll) || inherits(ll, "DFrame")
        }))
    )
        stop("One or more elments of 'l' are not a 'data.frame' or 'DFrame'")

    ## If `l` contains `data.frame` and `DataFrame`, and the first is a
    ## `data.frame` the following error is thrown:
    ## Error in rep(xi, length.out = nvar) :
    ##  attempt to replicate an object of type 'S4'
    if (any(.vapply1l(l, inherits, "DFrame"))) {
        l <- lapply(l, as, "DataFrame")
    }

    nms <- lapply(l, names)
    allcn <- unique(unlist(nms))

    for (i in seq_along(l)) {
        diffcn <- setdiff(allcn, nms[[i]])
        if (length(diffcn)) {
            l[[i]][, diffcn] <- NA
        }
        ## rbind,DataFrame-method doesn't sort columns and will throw an error
        ## about non-matching names
        l[[i]] <- l[[i]][allcn]
    }
    do.call(rbind, l)
}

context("data.frame")

test_that(".aggregateDataFrame", {
    d <- data.frame(id=1:4, col1=1:4, col2=5:8, col3=LETTERS[1:4],
                    stringsAsFactors=FALSE, row.names=letters[1:4])
    r <- data.frame(id=c(1, 3), col1=c(1.5, 3.5), col2=c(5.5, 7.5),
                    col3=LETTERS[c(1, 3)],
                    stringsAsFactors=FALSE, row.names=letters[c(1, 3)])
    expect_equal(.aggregateDataFrame(d, rep(1:2, each=2),
                                               ignoreNumCols="id"), r)
    expect_equal(.aggregateDataFrame(d, rep(c(10, 2), each=2),
                                               ignoreNumCols="id"), r)
})

test_that(".colsToLogical", {
    d <- DataFrame(a=1:10, b=rep(c("On", "Off"), 5), c=rep(c("foo", "bar"), 5))
    d1 <- DataFrame(
        a=1:10, b=Rle(rep(c("On", "Off"), 5)), c=rep(c("foo", "bar"), 5)
    )
    r <- DataFrame(a=1:10, b=rep(c(TRUE, FALSE), 5), c=rep(c("foo", "bar"), 5))
    expect_equal(.colsToLogical(d), r)
    expect_equal(.colsToLogical(d1), r)
    expect_equal(.colsToLogical(d[, 1, drop=FALSE]), d[, 1, drop=FALSE])
})

test_that(".colsToRle", {
    d <- DataFrame(a=1:10, b=rep(1, 10), c=rep(c("foo", "bar"), each=5))
    r <- DataFrame(a=1:10, b=Rle(rep(1, 10)),
                   c=Rle(rep(c("foo", "bar"), each=5)))
    expect_equal(.colsToRle(d), r)
    expect_equal(.colsToLogical(d[, 1, drop=FALSE]), d[, 1, drop=FALSE])
})

test_that(".droplevels", {
    d <- DataFrame(a=1:10, b=factor(rep(1, 10)),
                   c=Rle(rep(c("foo", "bar"), each=5)),
                   d=Rle(factor(rep(c("foo", "bar"), each=5))),
                   e=factor(rep(1:2, each=5)))
    r <- DataFrame(a=1:5, b=factor(rep(1, 5)),
                   c=Rle(rep("foo", 5)),
                   d=Rle(factor(rep("foo", 5))),
                   e=factor(rep(1, 5)))
    expect_equal(.droplevels(d[1:5,]), r)
})

test_that(".dropNaColumns", {
    d <- DataFrame(a=1:10, b=NA, c=Rle(rep(c("foo", "bar"), each=5)))
    r <- DataFrame(a=1:10, c=Rle(rep(c("foo", "bar"), each=5)))
    expect_equal(.dropNaColumns(d), r)
})

test_that(".dropNonInformativeColumns", {
    d <- DataFrame(a=1:10, b=factor(rep(1, 10)),
                   c=Rle(rep(c("foo", "bar"), each=5)),
                   d=Rle(rep("foo", 10)))
    r <- DataFrame(a=1:10,
                   c=Rle(rep(c("foo", "bar"), each=5)))
    r2 <- DataFrame(a=1:10,
                    c=Rle(rep(c("foo", "bar"), each=5)),
                    d=Rle(rep("foo", 10)))
    expect_equal(.dropNonInformativeColumns(d), r)
    expect_equal(.dropNonInformativeColumns(d, keep="d"), r2)
})

test_that(".isCharacterCol", {
    d <- DataFrame(a=LETTERS[1:10], b=factor(rep(1, 10)),
                   c=Rle(rep(c("foo", "bar"), each=5)),
                   d=Rle(rep(1:2, each=5)))
    expect_equal(.isCharacterCol(d), c(TRUE, FALSE, TRUE, FALSE))
})

test_that(".isNumCol", {
    d <- DataFrame(a=1:10, b=factor(rep(1, 10)),
                   c=Rle(rep(c("foo", "bar"), each=5)),
                   d=Rle(rep(1:2, each=5)))
    expect_equal(.isNumCol(d), c(TRUE, FALSE, FALSE, TRUE))
})

test_that(".makeRowNames", {
    d <- data.frame(a=c(1e5, 1e6, 1e7, NA), b=letters[1:4], c=8:11)
    expect_error(.makeRowNames(1:3))
    expect_equal(.makeRowNames(d),
                 c("C1.0e+05_a_08", "C1.0e+06_b_09",
                   "C1.0e+07_c_10", "C0.0e+00_d_11"))
    expect_equal(.makeRowNames(DataFrame(d[, "b", drop=FALSE])),
                 paste0("C", letters[1:4]))
    expect_equal(.makeRowNames(data.frame(a=LETTERS[1:3])),
                 paste0("C", LETTERS[1:3]))
    expect_equal(.makeRowNames(data.frame(a=1:3)),
                 paste0("C", 1:3))
    expect_equal(.makeRowNames(
            data.frame(a=rep(1e5, 4), b=letters[1:4], c=8:11)
        ), c("Ca_08", "Cb_09", "Cc_10", "Cd_11")
    )
    expect_equal(.makeRowNames(data.frame(a=rep(1e5, 10), b="a", c=8)),
                 sprintf("C%02d", 1:10))
})

test_that(".orderByColumns", {
    d <- DataFrame(a=10:1, b=c(1:3, 7:1),
                   c=Rle(rep(c("foo", "bar"), each=5)),
                   d=Rle(rep("foo", 10)))
    expect_error(.orderByColumns(1:10))
    expect_error(.orderByColumns(d, c("foo", "bar")))
    expect_equal(.orderByColumns(d, c("c", "a")), 10:1)
})

test_that(".rbind", {
    l <- rep(c(TRUE, FALSE), 3:2)
    x <- data.frame(a=1:5, b=letters[1:5], c=l, stringsAsFactors=FALSE)
    r <- data.frame(a=1:9, b=letters[1:9], c=c(l, rep(NA, 4)),
                    stringsAsFactors=FALSE)
    y <- list(
        data.frame(a=6:9, b=letters[6:9], stringsAsFactors=FALSE),
        data.frame(a=6:9, c=TRUE, stringsAsFactors=FALSE),
        data.frame(b=letters[6:9], c=TRUE, stringsAsFactors=FALSE),
        data.frame(b=letters[6:9], c=TRUE, d=LETTERS[1:4],
                   stringsAsFactors=FALSE),
        DataFrame(a0=6:9, a=6:9, a1=6:9, c=TRUE)
    )
    r <- list(
        data.frame(a=1:9, b=letters[1:9], c=c(l, rep(NA, 4)),
                   stringsAsFactors=FALSE),
        data.frame(a=1:9, b=c(letters[1:5], rep(NA_character_, 4)),
                   c=c(l, rep(TRUE, 4)), stringsAsFactors=FALSE),
        data.frame(a=c(1:5, rep(NA_real_, 4)), b=letters[1:9],
                   c=c(l, rep(TRUE, 4)), stringsAsFactors=FALSE),
        data.frame(a=c(1:5, rep(NA_real_, 4)), b=letters[1:9],
                   c=c(l, rep(TRUE, 4)),
                   d=c(rep(NA_character_, 5), LETTERS[1:4]),
                   stringsAsFactors=FALSE),
        DataFrame(a=1:9,
                  b=c(letters[1:5], rep(NA_character_, 4)),
                  c=c(l, rep(TRUE, 4)),
                  a0=c(rep(NA_real_, 5), 6:9),
                  a1=c(rep(NA_real_, 5), 6:9))
    )
    expect_error(.rbind(1:10, x))
    expect_error(.rbind(x, 1:10))
    for (i in seq_along(y)) {
        expect_equal(.rbind(x, y[[i]]), r[[i]])
    }
    expect_equal(.rbind(x), x)
    expect_equal(.rbind(list(x, x, y[[1]])),
                 .rbind(x, x, y[[1]]))
})

#' @describeIn FragmentViews-class Constructor
#'
#' In general it is not necessary to call the constructor manually. See
#' [readTopDownFiles()] instead.
#'
#' @param sequence `character`/
#' [Biostrings::AAString-class],
#' complete protein/peptide sequence.
#' @param mass `double`,
#' mass of the fragments, same length as `start`/`end`/`width`.
#' @param type `character`,
#' type of the fragments, same length as `start`/`end`/width`.
#' @param z `integer`,
#' charge of the fragments,
#' length one or same length as `start`/`end`/width`.
#' @param start `integer`,
#' start positions of the fragments. At least two of
#' `start`/`end`/width` has to be given.
#' @param end `integer`,
#' end positions of the fragments. At least two of
#' `start`/`end`/width` has to be given.
#' @param width `integer`,
#' width positions of the fragments. At least two of
#' `start`/`end`/width` has to be given.
#' @param names `character`,
#' names of the fragments, same length as `start`/`end`/width`.
#' @param metadata `list`, metadata like modifications.
#' @return An [FragmentViews-class] object.
#' @export
FragmentViews <- function(sequence, mass, type, z=1L,
                          start=NULL, end=NULL, width=NULL, names=NULL,
                          metadata=list()) {
    v <- Views(
        AAString(sequence),
        start=start, end=end, width=width,
        names=names
    )
    d <- DataFrame(mass=mass,
                   type=factor(type, levels=sort(unique(type))),
                   z=Rle(z))
    elementMetadata(v) <- d
    metadata(v) <- metadata
    new("FragmentViews", v[order(d$mass)])
}

#' Validate FragmentViews
#'
#' @param object FragmentViews
#' @return `TRUE` (if valid) else `character` with msg what was incorrect
#' @noRd
.validateFragmentViews <- function(object) {
    msg <- character()

    cols <- c("mass", "type", "z")
    if (!all(cols %in% colnames(elementMetadata(object)))) {
        sel <- !cols %in% colnames(elementMetadata(object))
        msg <- c(msg, paste(paste0("'", cols[sel], "'", collapse=", "),
                            if (sum(sel) == 1L) { "is" } else { "are" },
                            "missing."))
    }

    mass <- elementMetadata(object)[, "mass", drop=TRUE]

    if (!is.double(mass)) {
        msg <- c(msg, "'mass' has to be of type double.")
    }

    if (is.unsorted(mass)) {
        msg <- c(msg, "'mass' has to be sorted.")
    }

    if (length(msg)) {
        msg
    } else {
        TRUE
    }
}

context("FragmentViews")

fv <- FragmentViews("AACE", start=1, end=1:3, names=paste0("b", 1:3),
                    mass=c(114.054951, 185.092061, 345.122711),
                    type=rep("b", 3), z=rep(1, 3),
                    metadata=list(modifications=c("Carbamidomethyl",
                                                  "Acetyl", "Met-loss"),
                                  mass=473.158029))

test_that("combine", {
    fve <- FragmentViews("BCE", start=1, end=1:2, names=paste0("b", 1:2),
                         mass=as.double(1:2), type=rep("b", 2), z=rep(1, 2))
    expect_error(combine(fv, fve), ".*subject.* must be identical")
    fve@subject <- AAString("AACE")
    expect_error(combine(fv, fve), ".*mass.* must be identical")
    fve@metadata <- list(mass=3.5)
    expect_error(combine(fv, fve), ".*mass.* must be identical")
    fve@metadata <- list(mass=473.158029)
    expect_error(combine(fv, fve), ".*modifications.* must be identical")
    fve@metadata <- list(mass=473.158029, modifications="Acetyl")
    expect_error(combine(fv, fve), ".*modifications.* must be identical")
    fv2 <- FragmentViews("AACE", start=4:2, end=4, names=paste0("y", 1:3),
                         mass=c(148.060431, 308.091085, 379.128195),
                         type=rep("y", 3), z=rep(1, 3),
                         metadata=list(modifications=c("Carbamidomethyl",
                                                       "Acetyl", "Met-loss"),
                         mass=473.158029))
    fvc <- FragmentViews("AACE",
                         start=c(1, 4, 1, 3, 1, 2),
                         width=rep(1:3, each=2),
                         names=paste0(c("b", "y"), rep(1:3, each=2)),
                         mass=c(114.054951, 148.060431, 185.092061,
                                308.091085, 345.122711, 379.128195),
                         type=rep(c("b", "y"), 3), z=rep(1, 6),
                         metadata=list(modifications=c("Carbamidomethyl",
                                                       "Acetyl", "Met-loss"),
                         mass=473.158029))
    expect_equal(combine(fv, fv2), fvc)
    expect_equal(combine(fv, fv), fv)
})

test_that("constructor", {
    expect_error(.calculateFragments("AACE", modifications="FOO"))
    expect_equal(.calculateFragments("MAACE", type="b"), fv)

    ## default: Acetylation, Carboxyamidomethylation and Met-loss
    expect_equal(.calculateFragments("MAACE", type="b"),
                 fv)

    ## Acetylation but no Carboxyamidomethylation/Met-loss
    fv2 <- fv
    fv2@metadata$mass <- fv@metadata$mass - 57.021464
    fv2@elementMetadata$mass[3] <- fv@elementMetadata$mass[3] - 57.021464
    fv2@metadata$modifications <- c("Acetyl")
    expect_equal(.calculateFragments("AACE", type="b",
                                               modifications="Acetyl"),
                 fv2)
    ## just Met-loss without Acetylation
    fv3 <- fv
    fv3@metadata$mass <- fv@metadata$mass - 57.021464 - 42.010565
    fv3@elementMetadata$mass <- fv@elementMetadata$mass - 42.010565
    fv3@elementMetadata$mass[3] <- fv3@elementMetadata$mass[3] - 57.021464
    fv3@metadata$modifications <- c("Met-loss")
    expect_equal(.calculateFragments("MAACE", type="b",
                                               modifications="Met-loss"),
                 fv3)
    ## no modification
    fv4 <- fv
    fv4@elementMetadata$mass <- fv@elementMetadata$mass - 42.010565
    fv4@elementMetadata$mass[3] <- fv4@elementMetadata$mass[3] - 57.021464
    fv4@metadata <- list(modifications=NULL,
                         mass=fv@metadata$mass - 57.021464 - 42.010565)
    expect_equal(.calculateFragments("AACE", type="b",
                                               modifications=NULL), fv4)
})

test_that("mz", {
    expect_equal(mz(fv), c(114.054951, 185.092061, 345.122711))
})

test_that("show", {
    expect_output(show(fv),
                  paste(c("FragmentViews on a 4-letter sequence:",
                          "  AACE",
                          "Mass:",
                          "  473.158029",
                          "Modifications:",
                          "  Carbamidomethyl",
                          "  Acetyl",
                          "  Met-loss",
                          "Views:",
                          "    start end width   mass name type z *",
                          "\\[1\\]     1   1     1 114\\.05 b1   b    1 \\[A\\] *",
                          "\\[2\\]     1   2     2 185\\.09 b2   b    1 \\[AA\\] *",
                          "\\[3\\]     1   3     3 345\\.12 b3   b    1 \\[AAC\\]"),
                        collapse="\n"))
    fv@metadata <- list()
    expect_output(show(fv),
                  paste(c("FragmentViews on a 4-letter sequence:",
                          "  AACE",
                          "Views:",
                          "    start end width   mass name type z *",
                          "\\[1\\]     1   1     1 114\\.05 b1   b    1 \\[A\\] *",
                          "\\[2\\]     1   2     2 185\\.09 b2   b    1 \\[AA\\] *",
                          "\\[3\\]     1   3     3 345\\.12 b3   b    1 \\[AAC\\]"),
                        collapse="\n"))
})

test_that("validity", {
    expect_true(validObject(fv))
    d <- elementMetadata(fv)
    elementMetadata(fv) <- NULL
    expect_error(validObject(fv), "'mass', 'type', 'z' are missing")
    elementMetadata(fv) <- d
    elementMetadata(fv)$z <- NULL
    expect_error(validObject(fv), "'z' is missing")
    elementMetadata(fv) <- d
    elementMetadata(fv)$mass <- 1L:3L
    expect_error(validObject(fv), "'mass' has to be of type double")
    elementMetadata(fv) <- d
    elementMetadata(fv)$mass <- as.double(3:1)
    expect_error(validObject(fv), "'mass' has to be sorted")
})

test_that("as(\"data.frame\")", {
    expect_equal(as(fv, "data.frame"),
                 data.frame(fragment=c("A", "AA", "AAC"),
                            start=1,
                            end=1:3,
                            width=1:3,
                            name=paste0("b", 1:3),
                            type=factor(rep("b", 3)),
                            mass=c(114.054951, 185.092061, 345.122711),
                            z=1,
                            row.names=paste0("b", 1:3)))
})

#' Test whether all values in a vector are identical
#' (all(x[1] == x) is slower than unique)
#'
#' @param x vector
#' @return `logical`, TRUE/FALSE
#' @noRd
.allIdentical <- function(x) {
    isTRUE(length(unique(x)) == 1L)
}

#' Create camelCase names.
#'
#' @param x `character`
#' @return `character`
#' @noRd
.camelCase <- function(x) {
    ## convert dots from `make.names` to space
    x <- gsub("\\.+", " ", x)
    ## remove all the other punctiation like (, ), /
    x <- gsub("[[:punct:]]+", "", x)
    ## split AGCTarget to AGC Target and/or
    ## SupplementalActivationCE to Supplemental Activation CE
    x <- gsub("([A-Z]+)(?=([a-z]|[0-9]|[A-Z]$))", " \\1", x, perl=TRUE)
    ## Don't allow UPVDTime but
    ## don't split TIC/ETD to single letters (that's why [^ ])
    x <- gsub("(?<=[^ ][A-Z])([A-Z])(?=[a-z])", " \\1", x, perl=TRUE)
    ## just capitalize the first letter in a word
    x <- gsub("(?<=\\b)([a-z])", "\\U\\1", tolower(x), perl=TRUE)
    ## remove whitespace
    x <- gsub(" ", "", x)
    x
}

#' cat0, cat with sep="", similar to paste0
#'
#' @param \ldots arguments passed to cat
#' @noRd
cat0 <- function(...) {
    cat(..., sep="", append=TRUE)
}

#' Convert character with On/Off, True/False to logical
#'
#' @param x `character`
#' @param na.strings `character`
#' @return `logical`/`character`
#' @noRd
.characterToLogical <- function(x, na.strings=c("NA", "N/A")) {
    if ((!is.character(x) && !is(x, "Rle")) ||
        (is(x, "Rle") && !is.character(runValue(x))))
        stop("'x' has to be a 'character'.")
    y <- gsub("^[[:space:]]*on[[:space:]]*$", "TRUE", decode(x),
              ignore.case=TRUE)
    y <- gsub("^[[:space:]]*off[[:space:]]*$", "FALSE", y, ignore.case=TRUE)

    l <- as.logical(y)

    if (all(
        grepl(paste0(na.strings, collapse="|"), y) | is.na(y) == is.na(l))
    ) l else x
}

#' file extension
#'
#' @param x `character`, file path
#' @param compression `logical`, if TRUE gz, bz2, xz is removed
#' @return `character`
#' @noRd
.fileExt <- function(x, compression=TRUE) {
    if (compression)
        x <- sub("[.](gz|bz2|xz|zip)$", "", x)
    file_ext(x)
}

#' The ScanHeadsman output for the header information contains a column
#' FilterString with the format "FTMS + p NSI Full ms2 [0-9]+\.[0-9]+@hcd35.00
#' [xxx-yyy]". This function converts this format to the ID stored in the mass
#' label.
#'
#' @param x `character`
#' @return `double`
#' @noRd
.filterStringToId <- function(x) {
    if (!is.character(x))
        stop("'x' has to be a 'character'.")
    .massLabelToId(gsub("^.*ms2 ([^@]+)\\@.*$", "\\1", x))
}

#' Ensure unique, increasing ids in FilterStrings
#'
#' The ScanHeadsman output contains some FilterStrings that have wrong IDs (the
#' id from the previous or next run), e.g.:
#'
#' FTMS + p NSI Full ms2 1162.0007@cid28.00 [100.0000-2000.0000]
#' FTMS + p NSI Full ms2 1162.0009@hcd28.00 [100.0000-2000.0000]
#' FTMS + p NSI Full ms2 1162.0009@hcd28.00 [100.0000-2000.0000]
#' FTMS + p NSI Full ms2 1162.0009@cid35.00 [100.0000-2000.0000]
#'
#' pavel-shliaha finds out, that the skip is never larger than 1, never more
#' than 1 in a row and both is possible 1, 2, 2, 4 and 1, 3, 3, 4.
#'
#' In general it seems that the fix is as easy as ensuring that the FilterString
#' ids following a sequence (with some drop-outs).
#'
#' See the following issues for details:
#' - https://codeberg.org/sgibb/topdownr/issues/14
#' - https://codeberg.org/sgibb/topdownr/issues/25
#'
#' TODO: replace this with a better approach if we understand why some ID are
#' skipped.
#'
#' @param x `character`, FilterString
#' @return `character`, fixed FilterString with equal length as `x`
#' @noRd
.fixFilterString <- function(x) {
    ufs <- unique(x)
    ids <- .filterStringToId(ufs)
    pos <- regexpr("[0-9]{3}@", ufs)
    i <- match(x, ufs)
    substr(x, pos[i], pos[i] + 3L) <-
        sprintf("%03d@", .fixFilterStringId(ids))[i]
    x
}

#' Workhorse function of .fixFilterString
#'
#' There are two patterns possible: 1, 2, 2, 4 and 1, 3, 3, 4
#'
#' @param x `numeric`, id
#' @return `numeric`, fixed id
#' @noRd
.fixFilterStringId <- function(x) {
    d <- diff(x)
    ## 1, 2, 2, 4: d == d(1, 0, 2)
    l <- c(FALSE, d == 0L & c(d[-1L], Inf) == 2L)
    x[l] <- x[l] + 1L
    ## 1, 3, 3, 4: d == d(2, 0, 1)
    l <- c(FALSE, d == 2L & c(d[-1L], Inf) == 0L)
    x[l] <- x[l] - 1L
    ## edge case: 2, 2, 3, 4
    if (all(d[1L:2L] == c(0L, 1L))) {
        x[1L] <- x[1L] - 1L
    }
    ## edge case: 1, 2, 3, 3
    if (all(d[length(d) - 0L:1L] == c(0L, 1L))) {
        x[length(x)] <- x[length(x)] + 1L
    }
    x
}

#' Flat nested lists to unnested one
#'
#' @param x `list`
#' @return `list`
#' @noRd
.flatten <- function(x) {
    .is.list <- function(x)inherits(x, "list")
    while(any(.vapply1l(x, .is.list))) {
        x <- unlist(
            lapply(x, function(y) { if (.is.list(y)) { y } else { list(y) } }),
            recursive=FALSE
        )
    }
    x
}

#' Convert number to string and prepend zeros
#'
#' @param x `double`
#' @param asInteger `logical`
#' @param nScientific `numeric`
#' @param na2zero `logical`
#' @return `character`
#' @noRd
.formatNumbers <- function(x, asInteger=NA_integer_, nScientific=5L, na2zero=FALSE) {
    ## sprintf("%02.2f", Rle(c(1.2, 2.2), 2:3)) == "01" instead c("1.20", "1.20",
    ## "2.20", "2.20", "2.20"); so we need to decode
    x <- decode(x)
    n <- .ndigits(max(abs(x), 0, na.rm=TRUE))
    na <- is.na(x)

    if (isTRUE(any(x < 0L))) {
        n <- n + 1
    }

    if (na2zero) {
        x[na] <- 0
    }

    asInteger <- isTRUE(asInteger) ||
        (is.na(asInteger) &&
         all(abs(x[!na] - as.integer(x[!na])) < .Machine$double.eps))

    if (asInteger && n <= nScientific) {
        sprintf(paste0("%0", n, "d"), as.integer(x))
    } else if (asInteger && n > nScientific) {
        sprintf(paste0("%.1e"), as.integer(x))
    } else {
        # + 3L = 2 place after the decimal point + the point itself
        sprintf(paste0("%0", n + 3L, ".2f"), x)
    }
}

#' Get fragmentation method from {ETD,CID,HCD}Activation
#'
#' @param x `data.frame`/`matrix`, 3 columns (ETD,CID,HCD)
#' @return `character`, fragmentation method
#' @noRd
.fragmentationMethod <- function(x) {
    methods <- c(
        "None", "ETD", "CID", "ETcid", "HCD", "EThcd", "CID/HCD",
        "ETD/CID/HCD", "UVPD", rep(NA_character_, 6), "All"
    )
    v <- c(EtdActivation=1L, CidActivation=2L, HcdActivation=4L,
           UvpdActivation=8L)
    if (!all(colnames(x) %in% names(v)))
        stop("Unknown activation in 'x'")
    x <- x[, names(v)]
    apply(x, 1L, function(i)methods[sum(v[as.logical(i)], na.rm=TRUE) + 1L])
}

#' Split list/data.frame
#'
#' @param x `data.frame`, e.g. from .ms2Experiments
#' @param cols `character`, colnames used to split
#' @return `list`
#' @noRd
.groupBy <- function(x, cols) {
    split(x, .groupByLabels(x, cols))
}

#' Create group labels from data.frame columns
#'
#' @param x `data.frame`, or `DataFrame` e.g. from .ms2Experiments
#' @param cols `character`, colnames used to split
#' @param sep `character`, separator
#' @return `list`
#' @noRd
.groupByLabels <- function(x, cols=names(x), sep=":") {
    x <- as.data.frame(x)
    if (any(!cols %in% colnames(x))) {
        stop("All 'cols' have to be valid column names of 'x'.")
    }
    if (length(cols) > 1L) {
        ## `interaction` doesn't handle NA values, so use `paste` instead
        do.call(paste, c(x[, cols], sep=sep))
    } else {
        as.character(x[, cols])
    }
}

#' Create group id
#'
#' @param x `data.frame`
#' @param cols `character`, colnames used for grouping
#' @return `integer`
#' @noRd
.groupId <- function(x, cols) {
    if (!is.data.frame(x) && !inherits(x, "DataFrame"))
        stop("'x' has to be a 'data.frame' or 'DataFrame'")
    groups <- .groupByLabels(x, cols)
    ugroups <- unique(groups)
    match(groups, ugroups)
}

#' head/fill/tail of vector elements (e.g. for printing)
#'
#' @param x vector
#' @param fill `character`, or NULL
#' @param n `integer`
#' @return vector, `c(head(x, n), fill, tail(x, n))`
#' @noRd
.hft <- function(x, fill="...", n=3) {
    if (length(x) <= 2 * n) {
        x
    } else {
        c(head(x, n), fill, tail(x, n))
    }
}

#' Test for numeric similarity/equality (similar to all.equal)
#'
#' @param x `numeric`
#' @param y `numeric`
#' @param tolerance `double`
#' @return TRUE/FALSE
#' @noRd
.isEqual <- function(x, y, tolerance=1e-3) {
    if (!is.numeric(x) || !is.numeric(y))
        stop("Both 'x' and 'y' have to be 'numeric'")
    if (length(x) != length(y) && length(x) != 1L && length(y) != 1L)
        stop("Both 'x' and 'y' have to have the same length or length of one.")
    isTRUE(all(abs(y - x) < tolerance))
}

#' Add log message.
#'
#' @param ... arguments passed to `paste0`
#' @return msg with date string added
#' @noRd
.logmsg <- function(...) {
    paste0("[", format(Sys.time(), "%Y-%m-%d %H:%M:%S"), "] ", ...)
}

#' Make names (similar to base::make.names but start appending with 1)
#'
#' @param x `character` (or must be convertable to `character`)
#' @param prefix `character`, prefix
#' @param sep `character`, separator
#' @return `character`
#' @noRd
.makeNames <- function(x, prefix, sep=":") {
    x <- as.character(x)
    if (!missing(prefix)) {
        x <- paste0(prefix, x)
    }
    ave(x, x, FUN=function(xx) {
        if (length(xx) == 1L) {
            xx
        } else {
            sprintf(
                paste0("%s", sep, "%0", .ndigits(length(xx)), "d"),
                xx, seq_along(xx)
            )
        }
    })
}

#' Create mass label
#'
#' Identifying the experiments by the running time/order is complicated.
#' Sometimes the instrument records a new run with the same settings which moves
#' all indicies. Same is true for the start times.
#'
#' We modify the target mass slightly by rounding to one decimal place and use
#' the second to fourth (default) to encode the id. Subsequently it is possible
#' to find the results by their individual mass.
#'
#' @param x `double`, original mass
#' @param id `double`, run id
#' @param divisor `double`, divisor (determines which decimal place)
#' @return `double`, mass label (id encoded in the second to fourth decimal
#' place)
#' @seealso [.massLabelToId()]
#' @noRd
.massLabel <- function(x, id, divisor=10000L) {
    if (any(log10(divisor) <= log10(id) + 1L)) {
        stop("'divisor' has to be at least two digits more than 'id'")
    }
    round(x, 1L) + id / divisor
}

#' Extract ID from mass labels
#'
#' @param x `character`, mass label
#' @param idDigits `integer`, number of digits behind the decimal place that
#' store id information (not mass information) from the last one (e.g. 3 if
#' the id is 123 and the mz is 900.0123)
#' @seealso [.massLabel()]
#' @noRd
.massLabelToId <- function(x, idDigits=3L) {
    # was the following before, but results in round errors ("7" becomes 6L)
    # x <- as.double(x)
    # as.integer((x - round(x, 1L)) * multiplicator)
    n <- nchar(x)
    as.integer(substring(x, n - idDigits + 1L, n))
}

#' verbose output
#'
#' @param \ldots arguments passed to `message`
#' @noRd
.msg <- function(verbose, ...) {
    if (verbose) {
        message(...)
    }
}

#' number of digits
#'
#' @param x `double`
#' @return `integer`
#' @noRd
.ndigits <- function(x) {
    x <- x[!is.na(x)]
    if (!length(x) || all(x == 0L)) {
        1L
    } else {
        trunc(log10(abs(x)) + 1L)
    }
}

#' similar to lengths but for rows
#'
#' @param x `list` of `data.frames`/`matrices`
#' @noRd
.nrows <- function(x) {
    if (!inherits(x, "list"))
        stop("'x' has to b a 'list'")
    .vapply1d(x, nrow)
}

#' Resample rows (Experiments) in a data.frame
#'
#' @param x `data.frame`
#' @param fun `function`, to apply on the number of rows, e.g. use `seq` to do
#' nothing.
#' @return reordered `data.frame`
#' @noRd
.resample <- function(x, fun=sample) {
    fun <- match.fun(fun)
    x[fun(nrow(x)), , drop=FALSE]
}

#' generate valid scan description
#'
#' @param x `data.frame`
#' @param replications `numeric`, number of replications
#' @param prefix `character`, prefix
#' @return unique names
#' @noRd
.scanDescription <- function(n, replications=1L, prefix="C") {
    if (!is.numeric(n) || length(n) != 1L)
        stop("'n' has to be a 'numeric' of length one.")
    if (!is.numeric(replications) || length(replications) != 1L ||
        replications <= 0L)
        stop(
            "'replications' has to be a 'numeric' of length one and ",
            "greater than 0.")
    if (!is.character(prefix) ||
        (length(prefix) != 1L && length(prefix) != n) ||
        any(!nzchar(prefix)))
        stop(
            "'prefix' has to be a 'character' of length one or ",
            "equal the length of 'n'."
        )
    desc <- paste0(
        prefix,
        rep.int(.formatNumbers(seq_len(n)), replications)
    )
    if (replications > 1L)
        desc <- paste0(desc, "R", rep(seq_len(replications), each=n))
    if (any(nchar(desc) > 16L))
        stop("Calcium devices accept just 16 characters for 'ScanDescription'.")
    if (anyDuplicated(desc))
        stop("Duplicated 'ScanDescription' are not allowed.")
    desc
}

#' shortend string to width and place "..." in the middle
#'
#' @param x `character`
#' @param width number of letters allowed/width of terminal
#' @return `character`
#' @noRd
.snippet <- function(x, width=getOption("width")) {
    nc <- nchar(x)
    w <- (width - 2L:3L) %/% 2L

    ifelse(
        nc <= width,
        x,
        paste0(
            substring(x, 1L, w[1L]), "...", substring(x, nc - w[2L] + 1L, nc)
        )
    )
}

#' normalize subset (turn `logical`, `numeric` and `character` to `numeric`)
#'
#' @param i ANY, subset
#' @param n `integer`, length of the original object
#' @param nms `character`, names of the orignal object
#' @return `logical`, vector of length n
#' @noRd
.subset <- function(i, n, nms=NULL) {
    ## use decode to turn Rle into native vectors, does nothing if i is
    ## already a native vector
    i <- decode(i)
    if (anyNA(i))
        stop("Subsetting by 'NA' is not supported.")
    if (!is.null(nms) && length(nms) != n)
        stop("If 'nms' is given it has to have the same length as 'n'")
    switch(
        class(i),
        "character" = .subsetByCharacter(i, nms),
        "logical" = .subsetByLogical(i, n),
        "integer" = ,
        "double" = ,
        "numeric" = .subsetByNumeric(i, n),
        stop("Unknown index class.")
    )
}

#' subset by `character`
#'
#' @param i `character`, subset
#' @param nms `character`, names of the orignal object
#' @return `numeric`
#' @noRd
.subsetByCharacter <- function(i, nms=NULL) {
    if (is.null(nms))
        return(integer())
    if (!is.character(i))
        stop("'i' has to be a 'character'.")
    if (!is.character(nms))
        stop("'nms' has to be a 'character'.")

    ii <- match(i, nms)
    if (anyNA(ii))
        stop("Subscript out of bound: ", paste0("'", i[is.na(ii)], "'",
                                                collapse=", "))
    ii
}

#' subset by `logical`
#'
#' @param i `logical`, subset
#' @param n `integer`, length
#' @return `numeric`
#' @noRd
.subsetByLogical <- function(i, n) {
    if (!is.logical(i))
        stop("'i' has to be a 'logical'.")
    if (!is.numeric(n))
        stop("'n' has to be a 'numeric'.")

    which(rep_len(i, n))
}

#' subset by `numeric`
#'
#' @param i `numeric`, subset
#' @param n `integer`, length
#' @return `numeric`
#' @noRd
.subsetByNumeric <- function(i, n) {
    if (!is.numeric(i))
        stop("'i' has to be a 'numeric'.")
    if (!is.numeric(n))
        stop("'n' has to be a 'numeric'.")

    if (any(n < i))
        stop("Subscript out of bound: ",
            paste0("'", i[n < i], "'", collapse=", "))
    i
}

#' subset filenames
#'
#' @param files `character`, filenames
#' @param selFiles `character`, selectedFiles, basename without extension
#' @return `character`
#' @noRd
.subsetFiles <- function(files, selFiles) {
    gsub(.topDownFileExtRx("cfmt"), "", files) %in% selFiles
}

#' swap file extensions
#'
#' @param x `character`, file name
#' @param ext `character`, new extension
#' @return `character`
#' @noRd
.swapFileExt <- function(x, ext="meth") {
    paste(file_path_sans_ext(x), ext, sep=".")
}

#' The ScanHeadsMan output for the scan conditons contains a column
#' TargetedMassList with the format "(mz=[0-9]+\.[0-9]+ z=[0-9]+ name=)". This
#' function converts this format to truncated (one decimal place) mz values.
#'
#' @param x `character`
#' @return `double`
#' @noRd
.targetedMassListToMz <- function(x) {
    if (!is.character(x))
        stop("'x' has to be a 'character'.")
    trunc(as.double(gsub("^.*mz=([^ ]+) z.*$", "\\1", x)) * 10L) / 10L
}

#' TopDown file extensions.
#'
#' @param type `character`, which file ext
#' @return `character`, regexp for file extensions
#' @noRd
.topDownFileExtRx <- function(type=c("cfmt", "cmt", "csv", "fasta", "mzml",
                                     "txt", "raw", "all")) {
    type <- match.arg(type)
    ext <- c(
        csv="experiments\\.csv",
        fasta="fasta",
        mzml="mz[Mm][Ll]",
        raw="raw",
        txt="txt"
    )
    sel <- switch(
        type,
        "all" = seq_along(ext),
        "cfmt" = c("csv", "fasta", "mzml", "txt"),
        "cmt" = c("csv", "mzml", "txt"),
        type
    )
    paste0("\\.", ext[sel], "(\\.(gz|bz2|xz|zip))?$", collapse="|")
}

#' Find indicies of top N values
#'
#' @param x `double`/`character`, value of interest
#' @param groupBy `character`, grouping variable
#' @return `integer`, indices
#' @noRd
.topIdx <- function(x, groupByLabels, n) {
    if (!is.double(x) && !is.numeric(x) && !is.character(x)) {
        stop("'x' has to be of type 'double' or 'character'")
    }
    if (n < 1L) {
        stop("'n' has to be greater or equal than 1.")
    }
    if (length(x) != length(groupByLabels)) {
        stop("'length(x)' and 'length(groupByLabels)' have to be equal.")
    }
    o <- order(x, decreasing=TRUE, na.last=TRUE)
    i <- unlist(
        lapply(split(o, groupByLabels[o]), "[", seq_len(n)), use.names=FALSE
    )
    i[!is.na(i)]
}

#' Due to changes in ProteomDiscover some mzML files have a different
#' `spectrumId` format that is not supported by proteowizard (and hence by
#' mzR), e.g. "scan=[acquisitionNum], file=[fileId]" vs the supported
#' "controllerType=0 controllerNumber=1 scan=[acquisitionNum]".
#' As fallback solution proteowizard just use 1:n as acquisitionNum which cause
#' mismatches to the ScanHeadsman output. See
#' https://codeberg.org/sgibb/topdownr/issues/73 for details.
#'
#' @param x `character`
#' @return `double`
#' @noRd
.translateThermoIdToScanId <- function(x) {
    if(!is.character(x) || !length(x) || !all(nzchar(x)))
        stop("'x' has to be a non-empty character vector.")
    as.double(gsub("^.*scan=([0-9]+).*$", "\\1", x))
}

#' Create a valid filename
#'
#' According to
#' https://docs.microsoft.com/de-de/windows/desktop/FileIO/naming-a-file#naming_conventions
#' ":" etc are not allowed in file names on windows
#'
#' @param x `character`
#' @return `character`
#' @noRd
.validFilename <- function(x) {
    if(!is.character(x) || !length(x) || !all(nzchar(x)))
        stop("'x' has to be a non-empty character vector.")
    gsub("[:;\\<>|\\?\\*]", "-", gsub("\\.+", ".", x))
}

#' wrapper around vapply for FUN.VALUE=double(1L)
#' @noRd
.vapply1d <- function(X, FUN, ..., USE.NAMES=FALSE) {
    vapply(X=X, FUN=FUN, FUN.VALUE=NA_real_, ..., USE.NAMES=USE.NAMES)
}

#' wrapper around vapply for FUN.VALUE=logical(1L)
#' @noRd
.vapply1l <- function(X, FUN, ..., USE.NAMES=FALSE) {
    vapply(X=X, FUN=FUN, FUN.VALUE=NA, ..., USE.NAMES=USE.NAMES)
}

context("utils")

test_that(".allIdentical", {
    expect_true(.allIdentical(rep(1L, 3)))
    expect_false(.allIdentical(1:3))
})

test_that(".camelCase", {
    expect_equal(.camelCase(c("Monoisotopic M/Z", "SPS Mass 2",
                                        "RT (min)", "MSLevel", "peaksCount",
                                        "Multi.Inject.Info", "RF.Comp...ppm",
                                        "SupplementalActivationCE",
                                        "TIC", "UseCalibratedUVPDTime",
                                        "UseCalibratedUVPDTimeMS2", "EThcD")),
                 c("MonoisotopicMz", "SpsMass2", "RtMin", "MsLevel",
                   "PeaksCount", "MultiInjectInfo", "RfCompPpm",
                   "SupplementalActivationCe", "Tic",
                   "UseCalibratedUvpdTime", "UseCalibratedUvpdTimeMs2",
                   "Ethcd"))
})

test_that("cat0", {
    expect_output(cat0("foo", "bar"), "foobar")
})

test_that("characterToLogical", {
    expect_error(.characterToLogical(1:2))
    expect_equal(.characterToLogical(c("FOO", "BAR")),
                 c("FOO", "BAR"))
    expect_equal(.characterToLogical(c("On", "Off", "NA")),
                 c(TRUE, FALSE, NA))
    expect_equal(.characterToLogical(c("On", "Off", "NA"),
                                                na.strings="FOO"),
                 c("On", "Off", "NA"))
    expect_equal(.characterToLogical(c("true", "False", "N/A")),
                 c(TRUE, FALSE, NA))
    expect_equal(.characterToLogical(c("true", "False", "N/A",
                                                  NA_character_)),
                 c(TRUE, FALSE, NA, NA))
    expect_equal(.characterToLogical(c("true", "on", "ON")),
                 rep(TRUE, 3))
    expect_equal(.characterToLogical(Rle(c("true", "False", "N/A"))),
                 c(TRUE, FALSE, NA))
    expect_equal(.characterToLogical(Rle(c("true", "on", "ON"))),
                 rep(TRUE, 3))
})

test_that(".fileExt", {
    f <- c("foo.bar", "foo.bar.gz")
    expect_equal(.fileExt(f), c("bar", "bar"))
    expect_equal(.fileExt(f, compression=FALSE), c("bar", "gz"))
})

test_that(".filterStringToId", {
    expect_error(.filterStringToId(1:3))
    expect_equal(.filterStringToId(
    c("FTMS + p NSI sa Full ms2 560.6219@etd50.00@cid7.00 [160.0000-2000.0000]",
      "FTMS + p NSI Full ms2 560.6010@hcd35.00 [160.0000-2000.0000]")),
      c(219L, 10L))
})

test_that(".fixFilterString", {
    fs <- c("FTMS + p NSI Full ms2 162.0004@cid28.00 [100.0000-2000.0000]",
            "FTMS + p NSI Full ms2 162.0004@hcd28.00 [100.0000-2000.0000]",
            "FTMS + p NSI Full ms2 162.0004@hcd28.00 [100.0000-2000.0000]",
            "FTMS + p NSI Full ms2 162.0006@cid35.00 [100.0000-2000.0000]",
            "FTMS + p NSI Full ms2 1162.0008@cid28.00 [100.0000-2000.0000]",
            "FTMS + p NSI Full ms2 1162.0010@hcd28.00 [100.0000-2000.0000]",
            "FTMS + p NSI Full ms2 1162.0010@hcd28.00 [100.0000-2000.0000]",
            "FTMS + p NSI Full ms2 1162.0010@cid35.00 [100.0000-2000.0000]")
    ffs <- fs
    ffs[2:3] <- "FTMS + p NSI Full ms2 162.0005@hcd28.00 [100.0000-2000.0000]"
    ffs[6:7] <- "FTMS + p NSI Full ms2 1162.0009@hcd28.00 [100.0000-2000.0000]"
    expect_equal(.fixFilterString(fs), ffs)
})

test_that(".fixFilterStringId", {
    expect_equal(.fixFilterStringId(c(1, 2, 2, 4)), 1:4)
    expect_equal(.fixFilterStringId(c(1, 3, 3, 4)), 1:4)
    expect_equal(.fixFilterStringId(c(4, 4, 6, 8, 10, 10)),
                 c(4:6, 8:10))
    expect_equal(.fixFilterStringId(c(5, 5, 6, 8, 9, 9)),
                 c(4:6, 8:10))
})

test_that(".flatten", {
    l <- list(a=1:3, list(foo=c("a", "b", "c"), bar=c("d", "e", "f")),
              list(parent=list(child1=1, child2=2)), d=data.frame(a=1:3, b=1:3))
    r <- list(a=1:3, foo=c("a", "b", "c"), bar=c("d", "e", "f"),
              parent.child1=1, parent.child2=2, d=data.frame(a=1:3, b=1:3))
    expect_equal(.flatten(l), r)
    d <- data.frame(a=1:3, b=LETTERS[1:3], stringsAsFactors=FALSE)
    expect_equal(.flatten(d), d)
})

test_that(".formatNumbers", {
    expect_equal(.formatNumbers(1:10), sprintf("%02d", 1:10))
    expect_equal(.formatNumbers(c(1, 100.1)),
                 sprintf("%06.2f", c(1, 100.1)))
    expect_equal(.formatNumbers(c(1, 100) + 0.1),
                 sprintf("%06.2f", c(1, 100) + 0.1))
    expect_equal(.formatNumbers(c(1, 100) + 0.1, asInteger=TRUE),
                 sprintf("%03d", c(1L, 100L)))
    expect_equal(.formatNumbers(c(1, 100) + 0.1, asInteger=FALSE),
                 sprintf("%06.2f", c(1, 100) + 0.1))
    expect_equal(.formatNumbers(c(1, 100) + 0.1, asInteger=NA),
                 sprintf("%06.2f", c(1, 100) + 0.1))
    expect_equal(.formatNumbers(c(1, 1000, 1e6) + 0.1),
                 sprintf("%010.2f", c(1, 1000, 1e6) + 0.1))
    expect_equal(.formatNumbers(c(1, 1000, 1e6)),
                 sprintf("%.1e", c(1, 1000, 1e6)))
    expect_equal(.formatNumbers(c(1, 1000, 1e6), asInteger=TRUE),
                 sprintf("%.1e", c(1, 1000, 1e6)))
    expect_equal(.formatNumbers(c(1, 1000, 1e6), nScientific=10),
                 sprintf("%07d", c(1, 1000, 1e6)))
    expect_equal(.formatNumbers(c(1, 1000, 1e6, NA)),
                 sprintf("%.1e", c(1, 1000, 1e6, NA)))
    expect_equal(.formatNumbers(c(1, 1000, 1e6, NA), na2zero=TRUE),
                 sprintf("%.1e", c(1, 1000, 1e6, 0)))
    expect_equal(.formatNumbers(c(1, -1000)), c("00001", "-1000"))
    expect_equal(.formatNumbers(Rle(c(1.1, 2.1), 2:3)),
                 rep(c("1.10", "2.10"), 2:3))
})

test_that(".fragmentationMethod", {
    d <- expand.grid(EtdActivation=c(NA, 1),
                     CidActivation=c(NA, 1),
                     HcdActivation=c(NA, 1),
                     UvpdActivation=c(NA, 1))
    expect_error(.fragmentationMethod(cbind(d, foo=1L)))
    expect_equal(.fragmentationMethod(d),
                 c("None", "ETD", "CID", "ETcid", "HCD", "EThcd", "CID/HCD",
                   "ETD/CID/HCD", "UVPD", rep(NA_character_, 6), "All"))
})

test_that(".groupBy", {
    x <- data.frame(ID=1:2, LE=rep(LETTERS[1:4], each=2), na=rep(c(1, NA), 4),
                    stringsAsFactors=FALSE)
    expect_error(.groupBy(1:10, "LE"))
    expect_equal(.groupBy(x, "LE"), split(x, x$LE))
    expect_equal(.groupBy(x, c("ID", "LE")),
                 split(x, interaction(as.list(x[, c("ID", "LE")]),
                                      sep=":", lex.order=TRUE)))
    expect_equal(.groupBy(x, c("ID", "na")),
                 setNames(split(x, x$ID), c("1:1", "2:NA")))
})

test_that(".groupByLabels", {
    x <- data.frame(ID=1:2, LE=rep(LETTERS[1:4], each=2), na=rep(c(1, NA), 4),
                    stringsAsFactors=FALSE)
    DF <- DataFrame(ID=1:2, LE=rep(LETTERS[1:4], each=2))
    expect_error(.groupByLabels(1:10, "LE"), "valid column names")
    expect_equal(.groupByLabels(x, "LE"), x$LE)
    expect_equal(.groupByLabels(x, c("ID", "LE")),
                 paste(1:2, rep(LETTERS[1:4], each=2), sep=":"))
    expect_equal(.groupByLabels(DF),
                 paste(1:2, rep(LETTERS[1:4], each=2), sep=":"))
    expect_equal(.groupByLabels(DF, c("ID", "LE")),
                 paste(1:2, rep(LETTERS[1:4], each=2), sep=":"))
    expect_equal(.groupByLabels(x, c("ID", "na")),
                 paste(rep(1:2, 4), rep(c(1, NA), 4), sep=":"))
    expect_equal(.groupByLabels(x, c("ID", "na"), sep="_"),
                 paste(rep(1:2, 4), rep(c(1, NA), 4), sep="_"))
})

test_that(".groupId", {
    x <- data.frame(ID=1:2, LE=rep(LETTERS[1:4], each=4),
                    stringsAsFactors=FALSE)
    expect_error(.groupId(1:10, "LE"))
    expect_equal(.groupId(x, "LE"), rep(1:4, each=4))
    expect_equal(.groupId(x, c("ID", "LE")),
                 rep(1:2, 8) + rep(seq(0, 6, by=2), each=4))
})

test_that(".hft", {
    expect_equal(.hft(letters[1:6]), letters[1:6])
    expect_equal(.hft(letters[1:26]),
                 c("a", "b", "c", "...", "x", "y", "z"))
    expect_equal(.hft(letters[1:26], fill=NULL, n=4),
                 c("a", "b", "c", "d", "w", "x", "y", "z"))
})

test_that(".isEqual", {
    expect_error(.isEqual("foo", 1:2))
    expect_error(.isEqual(1:2, "foo"))
    expect_error(.isEqual(1:2, 1:3))
    expect_true(.isEqual(1:3, 1:3))
    expect_true(.isEqual(1, rep(1, 3)))
    expect_true(.isEqual(1:3, (1:3)+1e-5))
    expect_false(.isEqual(1:3, (1:3)+1e-5, tolerance=1e-6))
})

test_that(".logmsg", {
    rxDate <-paste("^\\[20[0-9]{2}-[01][0-9]-[0-3][0-9]",
                   "[0-2][0-9]:[0-5][0-9]:[0-5][0-9]\\]")

    expect_true(grepl(paste(rxDate, "foo$"), .logmsg("foo")))
    expect_true(grepl(paste(rxDate, "foobar$"),
                      .logmsg("foo", "bar")))
})

test_that(".makeNames", {
    x <- rep(LETTERS[1:3], c(2, 1, 10))
    expect_equal(.makeNames(x),
                 c("A:1", "A:2", "B", sprintf("C:%02d", 1:10)))
    expect_equal(.makeNames(x, sep="_", prefix="D"),
                 c("DA_1", "DA_2", "DB", sprintf("DC_%02d", 1:10)))
})

test_that(".massLabel", {
    expect_equal(.massLabel(c(750, 1000.76), c(1, 245)),
                 c(750.0001, 1000.8245))
    expect_equal(.massLabel(c(750, 1000.76), c(1, 245), divisor=1e5),
                 c(750.00001, 1000.80245))
    expect_equal(.massLabel(1, 1:999),
                 as.double(sprintf("1.%04d", 1:999)))
    expect_error(.massLabel(c(750, 1000.76), c(1, 245), divisor=1e3),
                 "at least two digits more than")
})

test_that(".massLabelToId", {
    expect_equal(.massLabelToId(c("750.0001", "1000.8245")),
                 c(1, 245))
    expect_equal(.massLabelToId(c("750.001", "1000.824"), 2),
                 c(1, 24))
    expect_equal(.massLabelToId(sprintf("1000.%04d", 1:999)),
                 c(1:999))
})

test_that(".msg", {
    expect_message(.msg(TRUE, "foobar"), "foobar")
    expect_message(.msg(TRUE, "foo", "bar"), "foobar")
    expect_silent(.msg(FALSE, "foobar"))
})

test_that(".ndigits", {
    expect_equal(.ndigits(rep(10^(1:6), each=2) - c(0, 1)),
                 rep(2:7, each=2) - c(0, 1))
    expect_equal(.ndigits(-c(1, 10)), 1:2)
    expect_equal(.ndigits(0), 1)
    expect_equal(.ndigits(c(NA, 30)), 2)
    expect_equal(.ndigits(c(NA)), 1)
})

test_that(".nrows", {
    expect_error(.nrows(matrix(nrow=2, ncol=2)))
    expect_error(.nrows(data.frame(a=1, b=1)))
    expect_equal(.nrows(list(matrix(nrow=2, ncol=2),
                                       matrix(nrow=3, ncol=2))), 2:3)
})

test_that(".resample", {
    x <- data.frame(A=LETTERS[1:10],
                    B=1:10)
    set.seed(2017) # set.seed(2017); sample(10); # 5  4 10  8  2  6  1  9  3  7
    expect_equal(.resample(x), x[c(5:4, 10, 8, 2, 6, 1, 9, 3, 7),])
    expect_equal(.resample(x, seq), x)
})

test_that(".scanDescription", {
    expect_error(.scanDescription("FOO"))
    expect_error(.scanDescription(1:3))
    expect_error(.scanDescription(1, replications="FOO"))
    expect_error(.scanDescription(1, replications=0))
    expect_error(.scanDescription(1, replications=1:2))
    expect_error(.scanDescription(1, replications=2, prefix=1))
    expect_error(.scanDescription(1, replications=2, prefix=c("C", "D")))
    expect_error(.scanDescription(1, prefix="AAAAAAAAAAAAAAAA"),
                 "Calcium devices accept just 16 characters")
    expect_equal(.scanDescription(2), c("C1", "C2"))
    expect_equal(.scanDescription(2, replications=2),
                 c("C1R1", "C2R1", "C1R2", "C2R2"))
    expect_equal(.scanDescription(2, replications=1, prefix=c("C", "D")),
                 c("C1", "D2"))
    expect_equal(.scanDescription(10), sprintf("C%02d", 1:10))
})

test_that(".snippet", {
    L <- paste0(LETTERS[1:26], collapse="")
    l <- paste0(letters[1:26], collapse="")
    expect_equal(.snippet(L, 100), L)
    expect_equal(.snippet(L, 10), "ABCD...XYZ")
    expect_equal(.snippet(L, 11), "ABCD...WXYZ")
    expect_equal(.snippet(c(l, L), 10), c("abcd...xyz",
                                                    "ABCD...XYZ"))
    expect_equal(.snippet(c(l, L), 11), c("abcd...wxyz",
                                                    "ABCD...WXYZ"))
})

test_that(".subset", {
    expect_error(.subset(1:2, 10, letters[1:2]))
    expect_error(.subset(c(1, NA, 2), 10, letters[1:10]),
                 "'NA' is not supported")
    expect_error(.subset(list(foo=1:10), 10, letters[1:10]),
                 "Unknown")
    expect_equal(.subset(1:2, 10, letters[1:10]), 1:2)
    expect_equal(.subset(Rle(1:2, c(1, 1)), 10, letters[1:10]), 1:2)
    expect_equal(.subset(c(TRUE, TRUE, rep(FALSE, 8)), 10,
                                   letters[1:10]), 1:2)
    expect_equal(.subset(c("a", "b"), 10, letters[1:10]), 1:2)
})

test_that(".subsetByCharacter", {
    expect_error(.subsetByCharacter(1:2, LETTERS[1:2]))
    expect_error(.subsetByCharacter(letters[1:2], TRUE))
    expect_error(.subsetByCharacter(letters[1:2], LETTERS[1:2]),
                 "Subscript out of bound: 'a', 'b'")
    expect_equal(.subsetByCharacter(letters[1:2], letters[4:1]), 4:3)
    expect_equal(.subsetByCharacter(letters[1:2]), integer())
})

test_that(".subsetByLogical", {
    expect_error(.subsetByLogical(1:2, 10))
    expect_error(.subsetByLogical(TRUE, TRUE))
    expect_error(.subsetByLogical("foo", 10))
    expect_equal(.subsetByLogical(TRUE, 10), 1:10)
    expect_equal(.subsetByLogical(c(TRUE, FALSE), 10),
                 seq(1, 10, by=2))
    expect_equal(.subsetByLogical(rep(TRUE, 10), 10), 1:10)
    expect_equal(.subsetByLogical(rep(TRUE, 12), 10), 1:10)
})

test_that(".subsetByNumeric", {
    expect_error(.subsetByNumeric(TRUE, 10))
    expect_error(.subsetByNumeric(1:10, TRUE))
    expect_error(.subsetByNumeric("foo", 10))
    expect_error(.subsetByNumeric(c(1, 3, 12), 10),
                 "Subscript out of bound: '12'")
    expect_equal(.subsetByNumeric(1:10, 20), 1:10)
})

test_that(".subsetFiles", {
    expect_equal(.subsetFiles(
                  c("foo.experiments.csv", "foo.mzML", "bar.txt"), "foo"),
                 c(TRUE, TRUE, FALSE))
})

test_that(".swapFileExt", {
    expect_equal(.swapFileExt("foo.xml"), "foo.meth")
    expect_equal(.swapFileExt("foo.xml", "bar"), "foo.bar")
})

test_that(".targetedMassListToMz", {
    expect_error(.targetedMassListToMz(1:3))
    expect_equal(.targetedMassListToMz(c("(mz=1000.12 z=2 name=foo)",
                                                   "(mz=933.99 z=3 name=)")),
                 c(1000.1, 933.9))
})

test_that(".topDownFileExtRx", {
    ext <- c("experiments\\.csv", "fasta", "mz[Mm][Ll]", "raw", "txt")
    gz <- "(\\.(gz|bz2|xz|zip))?$"
    expect_error(.topDownFileExtRx("foo"))
    expect_equal(.topDownFileExtRx(),
                 paste0("\\.", ext[-4], gz, collapse="|"))
    expect_equal(.topDownFileExtRx("all"),
                 paste0("\\.", ext, gz, collapse="|"))
    expect_equal(.topDownFileExtRx("cfmt"),
                 paste0("\\.", ext[-4], gz, collapse="|"))
    expect_equal(.topDownFileExtRx("csv"),
                 paste0("\\.", ext[1], gz, collapse="|"))
    expect_equal(.topDownFileExtRx("mzml"),
                 paste0("\\.", ext[3], gz, collapse="|"))
    expect_equal(.topDownFileExtRx("txt"),
                 paste0("\\.", ext[5], gz, collapse="|"))
})

test_that(".topIdx", {
    d <- 1:10
    g <- rep_len(LETTERS[1:3], 10)
    expect_error(.topIdx(logical(10)),
                 "'x' has to be of type")
    expect_error(.topIdx(d, groupByLabels=g, n=-1),
                 "'n' has to be greater or equal than 1.")
    expect_error(.topIdx(d, groupByLabels=1:3, n=3), "have to be equal.")
    expect_equal(.topIdx(d, groupByLabels=g, n=3),
                 c(10, 7, 4, 8, 5, 2, 9, 6, 3))
    expect_equal(.topIdx(d, groupByLabels=g, n=2),
                 c(10, 7, 8, 5, 9, 6))
})

test_that(".translateThermoIdToScanId", {
    expect_error(.translateThermoIdToScanId(NULL), "character")
    expect_error(.translateThermoIdToScanId(1:10), "character")
    expect_error(.translateThermoIdToScanId(c("", "")), "non-empty")
    expect_equal(.translateThermoIdToScanId(c(
        "controllerType=0 controllerNumber=1 scan=11",
        "controllerType=0 controllerNumber=1 scan=12",
        "controllerType=0 controllerNumber=1 scan=13",
        "controllerType=0 controllerNumber=1 scan=14",
        "controllerType=0 controllerNumber=1 scan=15",
        "controllerType=0 controllerNumber=1 scan=16")), 11:16)
    expect_equal(.translateThermoIdToScanId(c(
        "scan=21 file=191",
        "scan=22 file=191",
        "scan=23 file=191",
        "scan=24 file=191",
        "scan=25 file=191",
        "scan=26 file=191")), 21:26)
})

test_that(".validFilename", {
    fn <- c(
        "foo-bar.xml", "foo_bar.xml", "foo/bar.xml",
        "foo-bar..xml", "foo:bar.xml", "foo\\bar.xml", "foo<bar.xml",
        "foo>bar.xml", "foo;bar.xml", "foo|bar.xml", "foo?bar.xml",
        "foo*bar.xml"
    )
    expect_error(.validFilename(FALSE), "character")
    expect_error(.validFilename(character()), "non-empty")
    expect_error(.validFilename(c("foo", "")), "non-empty")
    expect_equal(.validFilename(fn), c("foo-bar.xml", "foo_bar.xml",
                                       "foo/bar.xml", rep("foo-bar.xml", 9)))
})

#' Deprecated functions in topdownr
#'
#' These functions are provided for compatibility with older versions
#' of \sQuote{MyPkg} only, and will be defunct at the next release.
#'
#' @details The following functions are deprecated and will be made defunct; use
#' the replacement indicated below:
#' - `defaultMs1Settings`: [expandMs1Conditions()] in combination with
#' [createExperimentsFragmentOptimisation()]
#' - `defaultMs2Settings`: [expandTms2Conditions()] in combination with
#' [createExperimentsFragmentOptimisation()]
#'
#' @name topdownr-deprecated
#' @aliases topdownr-deprecated
#' @keywords package deprecated
NULL

#' The FragmentViews class
#'
#' The FragmentViews class is a basic container for storing a set of views
#' (start/end locations) on the same peptides/protein sequence. Additionally
#' it keeps information about mass, type and charge of the fragments.
#'
#' @details FragmentViews extends
#' [Biostrings::XStringViews-class].
#' In short it combines an
#' [IRanges::IRanges-class]
#' object to store start/end
#' location on a sequence, an
#' [Biostrings::AAString-class] object.
#'
#' @seealso [Biostrings::XStringViews-class]
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @examples
#' # Constructor
#' fv <- FragmentViews("ACE", start=1, width=1:3, names=paste0("b", 1:3),
#'                     mass=c(72.04439, 232.07504, 361.11763),
#'                     type="b", z=1)
#' fv
#'
#' # Coercion to data.frame
#' as(fv, "data.frame")
## just subclass to ensure that the elementMetadata slot (DataFrame) contains
## a mass column
setClass(
    "FragmentViews",
    contains="XStringViews",
    validity=function(object).validateFragmentViews(object)
)

#' The AbstractTopDownSet class
#'
#' *Abstract/VIRTUAL* parent class for
#' [TopDownSet-class] and [NCBSet-class] to provide common interface.
#'
#' @details
#' This class just provides a common interface. It is not intended for direct
#' use by the user. Please see [TopDownSet-class] for an example usage of its
#' child class.
#'
#' @slot rowViews [Biostrings::XStringViews-class],
#' information about fragments/bonds (name, type, sequence, mass, charge),
#' see [Biostrings::XStringViews-class] and
#' [FragmentViews-class] for details.
#' @slot colData [S4Vectors::DataFrame-class],
#' information about the MS2 experiments and the fragmentation conditions.
#' @slot assay [Matrix::dgCMatrix-class],
#' intensity/coverage values of the fragments/bonds.
#' The rows correspond to the fragments/bonds and the
#' columns to the condition/run. It just stores values that are
#' different from zero.
#' @slot files `character`, files that were imported.
#' @slot processing `character`, log messages.
#'
#' @return This is an *Abstract/VIRTUAL* class
#' to provide a common interface for
#' [TopDownSet-class] and [NCBSet-class].
#' It is not possible to create an `AbstractTopDownSet` object.
#'
#' @seealso
#' - [TopDownSet-class] and [NCBSet-class]
#' which both implement/use this interface.
#' These manual pages also provide some example code.
#' - [FragmentViews-class]
#' (and [Biostrings::XStringViews-class])
#' for the row view interface.
#' - [Matrix::dgCMatrix-class]
#' for technical details about the intensity/coverage storage.
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @examples
#' ## Because AbstractTopDownSet is a VIRTUAL class we could not create any
#' ## object of it. Here we demonstrate the usage with an TopDownSet that
#' ## implements the AbstractTopDownSet interface. See `?"TopDownSet-class"` for
#' ## more details an further examples.
#'
#' ## Example data
#' data(tds, package="topdownr")
#'
#' tds
#'
#' head(summary(tds))
#'
#' # Accessing slots
#' rowViews(tds)
#' colData(tds)
#' head(assayData(tds))
#'
#' # Accessing colData
#' tds$Mz
#' tds$FilterString
#'
#' # Subsetting
#'
#' # First 100 fragments
#' tds[1:100]
#'
#' # All c fragments
#' tds["c"]
#'
#' # Just c 152
#' tds["c152"]
#'
#' # Condition 1 to 10
#' tds[, 1:10]
#
setClass(
    "AbstractTopDownSet",
    contains="VIRTUAL",
    slots=c(
        rowViews="XStringViews",
        colData="DataFrame",
        assay="dgCMatrix",
        files="character",
        processing="character"
    ),
    prototype=prototype(
        rowViews=new("XStringViews"),
        colData=new("DFrame"),
        assay=new("dgCMatrix"),
        files=character(),
        processing=character()),
        validity=function(object).validateAbstractTopDownSet(object)
)

#' The TopDownSet class
#'
#' The TopDownSet class is a container for a whole top-down proteomics
#' experiment.
#'
#' @details
#' See `vignette("analysis", package="topdownr")`
#' for a detailed example how to work with
#' `TopDownSet` objects.
#'
#' @slot rowViews [FragmentViews-class],
#' information about fragments (name, type, sequence, mass, charge), see
#' [FragmentViews-class] for details.
#' @slot colData [S4Vectors::DataFrame-class],
#' information about the MS2 experiments and the fragmentation conditions.
#' @slot assay [Matrix::dgCMatrix-class],
#' intensity values of the fragments. The
#' rows correspond to the fragments and the columns to the condition/run. It
#' just stores values that are different from zero.
#' @slot files `character`, files that were imported.
#' @slot tolerance `double`,
#' tolerance in *ppm* that were used for matching the
#' experimental mz values to the theoretical fragments.
#' @slot redundantMatching `character`, matching strategies for redundant
#' ion/fragment matches. See `redundantIonMatch` and
#' `redundantFragmentMatch` in [readTopDownFiles()] for details.
#' @slot processing `character`, log messages.
#'
#' @return An [TopDownSet-class] object.
#'
#' @seealso
#' - [FragmentViews-class]
#' for the row view interface.
#' - [Matrix::dgCMatrix-class]
#' for technical details about the intensity storage.
#' - `?vignette("analysis", package="topdownr")`
#' for a full documented example of an analysis using `topdownr`.
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @examples
#' ## Example data
#' data(tds, package="topdownr")
#'
#' tds
#'
#' head(summary(tds))
#'
#' # Accessing slots
#' rowViews(tds)
#' colData(tds)
#' head(assayData(tds))
#'
#' # Accessing colData
#' tds$Mz
#' tds$FilterString
#'
#' # Subsetting
#'
#' # First 100 fragments
#' tds[1:100]
#'
#' # All c fragments
#' tds["c"]
#'
#' # Just c 152
#' tds["c152"]
#'
#' # Condition 1 to 10
#' tds[, 1:10]
#'
#' # Filtering
#' # Filter all intensities that don't have at least 10 % of the highest
#' # intensity per fragment.
#' tds <- filterIntensity(tds, threshold=0.1)
#'
#' # Filter all conditions with a CV above 30 % (across technical replicates)
#' tds <- filterCv(tds, threshold=30)
#'
#' # Filter all conditions with a large deviation in injection time
#' tds <- filterInjectionTime(tds, maxDeviation=log2(3), keepTopN=2)
#'
#' # Filter all conditions where fragments don't replicate
#' tds <- filterNonReplicatedFragments(tds)
#'
#' # Normalise by TIC
#' tds <- normalize(tds)
#'
#' # Aggregate technical replicates
#' tds <- aggregate(tds)
#'
#' head(summary(tds))
#'
#' # Coercion
#' as(tds, "NCBSet")
#'
#' if (require("MSnbase")) {
#'     as(tds, "MSnSet")
#' }
setClass(
    "TopDownSet",
    contains="AbstractTopDownSet",
    slots=c(
        tolerance="numeric",
        redundantMatching="character"
    ),
    prototype=prototype(
        rowViews=new("FragmentViews"),
        tolerance=double(),
        redundantMatching=rep.int("remove", 2L)
    )
)

#' The NCBSet class
#'
#' The NCBSet class is a container for a top-down proteomics experiment
#' similar to the [TopDownSet-class]
#' but instead of intensity values it just stores the information if a
#' bond is covered by a N-terminal (encoded as `1`),
#' a C-terminal (encoded as `2`)
#' and/or bidirectional fragments (encoded as `3`).
#'
#' @slot rowViews [Biostrings::XStringViews-class],
#' information about bonds (name, start, end, width, sequence),
#' see [Biostrings::XStringViews-class] for details.
#' @slot colData [S4Vectors::DataFrame-class],
#' information about the MS2 experiments and the fragmentation conditions.
#' @slot assay [Matrix::dgCMatrix-class],
#' coverage values of the bonds. The rows correspond to the bonds and the
#' columns to the condition/run. It just stores values that are different
#' from zero. If a bond is covered by an N-terminal fragment its encoded
#' with `1`, by an C-terminal fragmentl with `2` and
#' by both fragment types/bidirectional by `3` respectively.
#' @slot files `character`, files that were imported.
#' @slot processing `character`, log messages.
#'
#' @return An [NCBSet-class] object.
#'
#' @seealso
#' - An `NCBSet` is generated from an [TopDownSet-class] object.
#' - [Biostrings::XStringViews-class]
#' for the row view interface.
#' - [Matrix::dgCMatrix-class]
#' for technical details about the coverage storage.
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @examples
#' ## Example data
#' data(tds, package="topdownr")
#'
#' ## Aggregate technical replicates
#' tds <- aggregate(tds)
#'
#' ## Coercion into an NCBSet object
#' ncb <- as(tds, "NCBSet")
#'
#' ncb
#'
#' head(summary(ncb))
#'
#' # Accessing slots
#' rowViews(ncb)
#' colData(ncb)
#' head(assayData(ncb))
#'
#' # Accessing colData
#' ncb$Mz
#'
#' # Subsetting
#'
#' # First 100 bonds
#' ncb[1:100]
#'
#' # Just bond 152
#' ncb["bond152"]
#'
#' # Condition 1 to 10
#' ncb[, 1:10]
#'
#' # Plot fragmentation map
#' fragmentationMap(ncb)
setClass(
    "NCBSet",
    contains="AbstractTopDownSet",
    validity=function(object).validateNCBSet(object)
)

#' Investigation of Fragmentation Conditions in Top-Down Proteomics
#'
#' The topdownr package allows automatic and systemic investigation of
#' fragment conditions. It creates Thermo Orbitrap Fusion Lumos method files
#' to test hundreds of fragmentation conditions. Additionally it provides
#' functions to analyse and process the generated MS data and determine the
#' best conditions to maximise overall fragment coverage.
#'
#' The usage of the topdownr package is demonstrated in the following vignettes:
#'
#' - Generate .meth files prior data acquisition for the Thermo Orbitrap Fusion
#' Lumos MS devise: `vignette("data-generation", package="topdownr")`.
#' - How to analyse top-down fragmenation data:
#' `vignette("analysis", package="topdownr")`
#'
#' @docType package
#' @name topdownr-package
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de},
#' Pavel Shliaha \email{pavels@bmb.sdu.dk},
#' Ole Nørregaard Jensen \email{jenseno@bmb.sdu.dk}
#' @references \url{https://codeberg.org/sgibb/topdownr/}
#' @keywords package
#'
#' @import methods
#' @import BiocGenerics
#' @import ProtGenerics
#' @import Biostrings
#' @import S4Vectors
#' @importClassesFrom Matrix Matrix dgCMatrix
#' @importFrom Matrix Matrix sparseMatrix sparseVector crossprod tcrossprod
#' drop0 nnzero
#' @importFrom Biobase assayData
#' @importFrom ggplot2 aes aes_string element_blank element_rect element_text
#' facet_grid geom_hline geom_raster geom_segment geom_text geom_vline ggplot
#' ggtitle labs scale_alpha scale_color_manual scale_fill_manual
#' scale_x_discrete scale_y_continuous theme theme_classic
#' @importFrom grDevices pdf dev.off
#' @importFrom mzR openMSfile close header peaks runInfo
#' @importFrom PSMatch calculateFragments defaultNeutralLoss getAminoAcids
#' @importClassesFrom MSnbase MSnSet
#' @importFrom stats ave median setNames quantile
#' @importFrom tools file_ext file_path_sans_ext
#' @importFrom utils modifyList txtProgressBar setTxtProgressBar object.size
#' read.csv .DollarNames packageVersion
"_PACKAGE"

#' Windows specific functions.
#'
#' The functions `runXmlMethodChanger` and `runScanHeadsman` call
#' `XmlMethodChanger.exe` and `ScanHeadsman.exe`
#' with the corresponding arguments.
#' This only work on Windows (maybe on Linux + wine as well but that was never
#' tested).
#'
#' @details
#'
#' `runXmlMethodChanger` applies ‘XmlMethodChanger.exe’ on all given XML files
#' generated with [writeMethodXmls()]
#' to create `.meth` files from a template.
#'
#' @param template `character`, path to template `.meth` file.
#' @param xml `character`, vector of path to `.xml` files.
#' @param executable `character`, path to the `XmlMethodChanger.exe` or
#' `ScanHeadsman.exe` executable.
#' @param verbose `logical`, if `TRUE` a progress bar is shown.
#' @return Nothing. Used for its side effects.
#' @seealso [writeMethodXmls()]
#' @references XmlMethodChanger source code:
#' https://github.com/thermofisherlsms/meth-modifications/
#' @rdname windows-specific-functions
#' @export
#' @examples
#' \dontrun{
#' runXmlMethodChanger(templateMeth="TMS2IndependentTemplate240Extended.meth",
#'                     modificationXml=list.files(pattern="^method.*\\.xml$"),
#'                     executable="..\\XmlMethodChanger.exe")
#' }
createTngFusionMethFiles <- function(template,
                                     xml=list.files(pattern=".*\\.xml$"),
                                     executable="XmlMethodChanger.exe",
                                     verbose=interactive()) {
    if (.Platform$OS.type != "windows") {
        stop("This function works only on Windows.")
    }
    if (!file.exists(executable)) {
        stop(sQuote(executable), " not found!")
    }
    if (!file.exists(template)) {
        stop(sQuote(template), " not found!")
    }

    if (verbose) {
        pb <- txtProgressBar(0L, length(xml), style=3L)
    }

    for (i in seq(along=xml)) {
        .xmlMethodChanger(
                executable, template, .swapFileExt(xml[i]), xml[i]
        )
        if (verbose) {
            setTxtProgressBar(pb, i)
        }
    }

    if (verbose) {
        close(pb)
    }
}

#' @rdname windows-specific-functions
#' @export
runXmlMethodChanger <- createTngFusionMethFiles

.xmlMethodChanger <- function(exe, input, output, modification) {
    args <- paste0(
        "--", c("input", "output", "modification"), "=",
        shQuote(c(input, output, modification))
    )
    system2(normalizePath(exe), args=args)
}

#' @rdname windows-specific-functions
#'
#' @details
#'
#' `runScanHeadsman` calls `ScanHeadsman.exe`
#' on a given directory containing `.raw` files.
#' `ScanHeadsman.exe` extracts the method and scan header data
#' into `.experiments.csv` and `.txt` files, respectively.
#'
## @param executable `character`, path to the `ScanHeadsman.exe` executable.
#' @param path `character`,
#' path to the directory containing the `.raw` files.
## @return Nothing. Used for its side effects.
#' @export
#' @references ScanHeadsman source code:
#' https://bitbucket.org/caetera/scanheadsman
#' @export
#' @examples
#' \dontrun{
#' runScanHeadsman("raw", executable="..\\ScanHeadsman.exe")
#' }
runScanHeadsman <- function(path=".", executable="ScanHeadsman.exe") {
    if (.Platform$OS.type != "windows") {
        stop("This function works only on Windows.")
    }
    if (!file.exists(executable)) {
        stop(sQuote(executable), " not found!")
    }
    .scanHeadsman(exe=executable, path=path)
}

.scanHeadsman <- function(exe, path=".") {
    args <- c(paste0("--", c("noMS", "methods:CSV")), path)
    system2(normalizePath(exe), args=args)
}

#' Create fragment optimisation experiment
#'
#' This function is used to create a tree-like `list` of
#' all combinations of a user-given set of MS1 and TMS2 settings for an
#' fragment optimisation experiment. The list could be written to an
#' Orbitrap Fusion Lumos method xml file using [writeMethodXmls()].
#'
#' @param ms1 `data.frame`, MS1 settings.
#' @param ... further named arguments with `data.frame`s containing the TMS2
#' settings.
#' @param groupBy `character`, group experiments by columns in the TMS2
#' `data.frame`s. The columns have to be present in all `data.frame`s. Each
#' group will be written to its own XML file.
#' @param nMs2perMs1 `integer`, how many TMS2 scans should be run after a MS1
#' scan?
#' @param scanDuration `double`, if greater than zero (e.g. `scanDuration=0.5`)
#' the Start/EndTimeMin are overwritten with a duration of `scanDuration`. If
#' `scanDuration` is zero (default) Start/EndTimeMin are not overwritten.
#' @param replications `integer`, number of replications.
#' @param randomise `logical`, should the TMS2 scan settings randomised?
#' @return `list`, able to be written via [xml2::as_xml_document()]
#' @export
#' @seealso [writeMethodXmls()],
#' [`expandMs1Conditions()`][expandMs1Conditions],
#' [`expandTms2Conditions()`][expandMs1Conditions]
#' @examples
#' ## build experiments within R
#' ms1 <- expandMs1Conditions(
#'     FirstMass=400,
#'     LastMass=1200,
#'     Microscans=as.integer(10)
#' )
#'
#' targetMz <- cbind(mz=c(560.6, 700.5, 933.7), z=rep(1, 3))
#' common <- list(
#'     OrbitrapResolution="R120K",
#'     IsolationWindow=1,
#'     MaxITTimeInMS=200,
#'     Microscans=as.integer(40),
#'     AgcTarget=c(1e5, 5e5, 1e6)
#' )
#'
#' cid <- expandTms2Conditions(
#'     MassList=targetMz,
#'     common,
#'     ActivationType="CID",
#'     CIDCollisionEnergy=seq(7, 35, 7)
#' )
#' hcd <- expandTms2Conditions(
#'     MassList=targetMz,
#'     common,
#'     ActivationType="HCD",
#'     HCDCollisionEnergy=seq(7, 35, 7)
#' )
#' etd <- expandTms2Conditions(
#'     MassList=targetMz,
#'     common,
#'     ActivationType="ETD",
#'     ETDReactionTime=as.double(1:2)
#' )
#' etcid <- expandTms2Conditions(
#'     MassList=targetMz,
#'     common,
#'     ActivationType="ETD",
#'     ETDReactionTime=as.double(1:2),
#'     ETDSupplementalActivation="ETciD",
#'     ETDSupplementalActivationEnergy=as.double(1:2)
#' )
#' uvpd <- expandTms2Conditions(
#'     MassList=targetMz,
#'     common,
#'     ActivationType="UVPD"
#' )
#'
#' exps <- createExperimentsFragmentOptimisation(
#'     ms1=ms1, cid, hcd, etd, etcid, uvpd,
#'     groupBy=c("AgcTarget", "replication"), nMs2perMs1=10, scanDuration=0.5,
#'     replications=2, randomise=TRUE
#' )
#'
#' ## use different settings for CID
#' cid560 <- expandTms2Conditions(
#'     MassList=cbind(560.6, 1),
#'     common,
#'     ActivationType="CID",
#'     CIDCollisionEnergy=seq(7, 21, 7)
#' )
#' cid700 <- expandTms2Conditions(
#'     MassList=cbind(700.5, 1),
#'     common,
#'     ActivationType="CID",
#'     CIDCollisionEnergy=seq(21, 35, 7)
#' )
#'
#' exps <- createExperimentsFragmentOptimisation(
#'     ms1=ms1, cid560, cid700,
#'     groupBy=c("AgcTarget", "replication"), nMs2perMs1=10, scanDuration=0.5,
#'     replications=2, randomise=TRUE
#' )
#'
#' ## use a CSV (or excel) file as input
#' myCsvContent <- "
#' ActivationType, ETDReactionTime, UVPDActivationTime
#' UVPD,,1000
#' ETD,1000,
#' "
#' myCsvSettings <- read.csv(text=myCsvContent, stringsAsFactors=FALSE)
#' myCsvSettings
#' #   ActivationType ETDReactionTime UVPDActivationTime
#' # 1           UVPD              NA               1000
#' # 2            ETD            1000                 NA
#'
#' exps <- createExperimentsFragmentOptimisation(
#'     ms1 = data.frame(FirstMass=500, LastMass=1000),
#'     ## TMS2
#'     myCsvSettings,
#'     ## other arguments
#'     groupBy="ActivationType"
#' )
createExperimentsFragmentOptimisation <-
    function(ms1, ...,
             groupBy=c("AgcTarget", "replication"),
             nMs2perMs1=10, scanDuration=0,
             replications=2, randomise=TRUE) {

    if (!is.numeric(nMs2perMs1) || length(nMs2perMs1) != 1)
        stop("'nMs2perMs1' has to be a 'numeric' of length one.")
    if (!is.numeric(scanDuration) || length(scanDuration) != 1)
        stop("'scanDuration' has to be a 'numeric' of length one.")
    if (!is.numeric(replications) || length(replications) != 1)
        stop("'replications' has to be a 'numeric' of length one.")
    if (!is.logical(randomise) || length(randomise) != 1)
        stop("'randomise' has to be a 'logical' of length one.")

    ms2 <- do.call(.rbind, .flatten(list(...)))
    nr <- nrow(ms2)

    ms2 <- ms2[rep(seq_len(nr), replications),, drop=FALSE]
    ms2$replication <- rep(seq_len(replications), each=nr)
    ms2$ScanDescription <- .scanDescription(n=nr, replications=replications)

    if (length(ms2)) {
        ms2 <- .groupBy(ms2, groupBy)
    } else {
        ms2 <- list(ms2=ms2)
    }
    if (randomise) {
        ms2 <- lapply(ms2, .resample)
    }

    nrs <- .nrows(ms2)
    mnrs <- max(nrs)

    times <- .startEndTime(
        nMs2=mnrs,
        nMs2perMs1=nMs2perMs1,
        duration=scanDuration
    )

    l <- vector(mode="list", length(ms2))
    names(l) <- names(ms2)

    for (i in seq_along(l)) {
        nMs1 <- ceiling(nrs[i] * 1L/nMs2perMs1)
        nMs2 <- nrs[i]
        n <- nMs1 + nMs2
        nNodes <- n + nMs2 - 1L     # CopyAndAppendExperiment

        sbtimes <- times[seq_len(n),]
        sbtimes$ExpId <- seq_len(n) - 1L
        sbtimes$SrcId <- as.integer(sbtimes$Type == "MS2")

        l[[i]] <- list(MethodModifications=vector(mode="list", length=nNodes))
        names(l[[i]][[1L]]) <- rep("Modification", nNodes)

        l[[i]][[1L]][[1L]] <- structure(
            .ms1ConditionToTree(
                ms1,
                times=unlist(
                    sbtimes[1L, c("StartTimeMin", "EndTimeMin")],
                    use.names=FALSE
                )
            ),
            Order=1L
        )

        for (j in seq_len(nrow(sbtimes) - 2L) + 2L) {
            orderId <- j - 1L
            l[[i]][[1L]][[orderId]] <- structure(
                .copyAndAppendExperiment(
                    srcId=sbtimes$SrcId[j]
                ),
                Order=orderId
            )
        }

        sbtimes <- sbtimes[sbtimes$Type == "MS2",, drop=FALSE]

        for (j in seq_len(nrow(sbtimes))) {
            orderId <- n + j - 1L
            l[[i]][[1L]][[orderId]] <- structure(
                .tms2ConditionToTree(
                    ms2[[i]][j,],
                    id=sbtimes$ExpId[j],
                    times=unlist(
                        sbtimes[j, c("StartTimeMin", "EndTimeMin")],
                        use.names=FALSE
                    )
                ),
                Order=orderId
            )
        }

        attr(l[[i]][[1L]], "Version") <- 2L
        attr(l[[i]][[1L]], "Model") <- "OrbitrapFusionLumos"
        attr(l[[i]][[1L]], "Family") <- "Calcium"
        attr(l[[i]][[1L]], "Type") <- "SL"
    }
    l
}

#' Create a FullMSScan node in a nested list
#'
#' @param x `data.frame` row
#' @param id `integer`, experiment id
#' @param times `double(2)`, start/end time
#' @param \dots arguments passed to internal functions
#' @return nested `list`
#' @noRd
.ms1ConditionToTree <- function(x, id=0L, times=NA_real_, ...) {
    if (anyNA(times)) {
        l <- list(Experiment=list(FullMSScan=NULL))
    } else {
        l <- list(Experiment=vector(mode="list", length=3L))
        names(l$Experiment) <- c(
            "FullMSScan", "StartTimeMin", "EndTimeMin"
        )
        l$Experiment$StartTimeMin <- list(times[1L])
        l$Experiment$EndTimeMin <- list(times[2L])
    }
    l$Experiment$FullMSScan <- lapply(x[, !is.na(x)], as.list)
    attr(l$Experiment, "ExperimentIndex") <- id
    l
}

#' Create a CopyAndAppendExperiment node in a nested list
#'
#' @param srcId `integer`, source experiment id
#' @param \dots arguments passed to internal functions
#' @return nested `list`
#' @noRd
.copyAndAppendExperiment <- function(srcId=0L, ...) {
    list(
        CopyAndAppendExperiment=structure(list(), SourceExperimentIndex=srcId)
    )
}

#' Convert single data.frame row (condition) to nested list
#'
#' @param x `data.frame` row
#' @param id `integer`, experiment id
#' @param times `double(2)`, start/end time
#' @param \dots arguments passed to internal functions
#' @return nested `list`
#' @noRd
.tms2ConditionToTree <- function(x, id, times=NA_real_, ...) {
    if (anyNA(times)) {
        l <- list(Experiment=list(TMSnScan=NULL))
    } else {
        l <- list(Experiment=vector(mode="list", length=3L))
        names(l$Experiment) <- c(
            "TMSnScan", "StartTimeMin", "EndTimeMin"
        )
        l$Experiment$StartTimeMin <- list(times[1L])
        l$Experiment$EndTimeMin <- list(times[2L])
    }
    if (!is.null(x$MassList)) {
        l$Experiment$TMSnScan$MassList <- .massListToTree(x$MassList)
    }
    x[, c("MassList", "replication")] <- NA
    cn <- colnames(x)[!is.na(x)]
    if (length(cn)) {
        l$Experiment$TMSnScan[cn] <- lapply(x[, cn], as.list)
    }
    attr(l$Experiment, "ExperimentIndex") <- id
    l
}

#' Convert collapsed MassList into xml2 ready tree like list structure
#'
#' @param x `character`, collapsed MassList (output of `.collapseMassList`)
#' @return `list`
#' @noRd
.massListToTree <- function(x) {
    x <- unname(.expandMassList(x))
    l <- vector(mode="list", length=nrow(x))
    names(l) <- rep("MassListRecord", length(l))
    for (i in seq_along(l)) {
        l[[i]] <- list(MOverZ=list(x[i, 1L]), Z=list(x[i, 2L]))
    }
    l
}

#' Collapse MassList
#'
#' @param x `matrix`, 2 columns: mz, z
#' @return `character`
#' @noRd
.collapseMassList <- function(x) {
    if (!is.matrix(x) || ncol(x) != 2L)
        stop("'x' has to be a 'matrix' with two columns.")
    paste0(apply(x, 1L, paste0, collapse="/"), collapse=" ")
}

#' Expand MassList
#'
#' @param x `character` collapsed MassList
#' @return `matrix`
#' @noRd
.expandMassList <- function(x) {
    if (!is.character(x))
        stop("'x' has to be a 'character'.")
    x <- strsplit(x, " |/")[[1L]]
    matrix(
        as.numeric(x),
        ncol=2, byrow=TRUE,
        dimnames=list(NULL, c("mz", "z"))
    )
}

#' Expand MS Conditions
#'
#' Create a `data.frame` of all possible combinations of the given arguments.
#' It ensures that just arguments are applied that yield a valid
#' MethodModification.xml file.
#'
#' @param ... further named arguments, used to create the combination of
#' conditions.
#' @param family `character`, currently just Calcium is supported
#' @param version `character`, currently 3.1, 3.2 (default), 3.3 are supported
#' @return `data.frame` with all possible combinations of conditions/settings.
#' @seealso [validMs1Settings()]
#' @rdname expandMsConditions
#' @seealso [validTms2Settings()], [expand.grid()]
#' @export
#' @examples
#' expandMs1Conditions(FirstMass=100, LastMass=400)
expandMs1Conditions <- function(..., family="Calcium", version="3.2") {
    settings <- .flatten(list(...))
    .validateMsSettings(type="MS1", settings, family=family, version=version)
    expand.grid(settings, KEEP.OUT.ATTRS=FALSE, stringsAsFactors=FALSE)
}

#' @rdname expandMsConditions
#' @param ActivationType `character`, *ActivationType* for TMS2,
#' either CID, HCD, ETD, or UVPD.
#' @param MassList `matrix`, 2 columns (mass, z) for targeted mass list,
#' or `NULL` (default) to not overwrite targeted mass.
#' @export
#' @examples
#' expandTms2Conditions(
#'      ActivationType="CID",
#'      OrbitrapResolution="R120K",
#'      IsolationWindow=1,
#'      MaxITTimeInMS=200,
#'      Microscans=as.integer(40),
#'      AgcTarget=c(1e5, 5e5, 1e6),
#'      CIDCollisionEnergy=c(NA, seq(7, 35, 7)),
#'      MassList=cbind(mz=c(560.6, 700.5, 933.7), z=rep(1, 3))
#' )
expandTms2Conditions <- function(ActivationType=c("CID", "HCD", "ETD", "UVPD"),
                                 ...,
                                 MassList=NULL,
                                 family="Calcium", version="3.2") {
    ActivationType <- match.arg(ActivationType)
    settings <- .flatten(list(...))

    .validateMsSettings(
        type=ActivationType,
        settings,
        family=family,
        version=version
    )

    if (!is.null(MassList)) {
        MassList <- .collapseMassList(MassList)
    }

    expand.grid(
        c(
            MassList=MassList,
            ActivationType=ActivationType,
            settings
        ),
        KEEP.OUT.ATTRS=FALSE,
        stringsAsFactors=FALSE
    )
}

#' List valid MS settings.
#'
#' These functions list settings for MS1 or TMS2 that are supported by
#' *Thermo's XmlMethodChanger*.
#'
#' @param family `character`, currently just Calcium is supported
#' @param version `character`, currently 3.1, 3.2 (default), 3.3 are supported
#' @return `matrix` with three columns:
#'  - name: element name
#'  - class: expected R class of the value
#'  - type: MS/ActivationType, e.g. MS1/TMS2/ETD/...
#' @rdname validMsSettings
#' @export
#' @examples
#' validMs1Settings()
validMs1Settings <- function(family="Calcium", version="3.2") {
    .validMsSettings("MS1", family=family, version=version)
}

#' @rdname validMsSettings
#'
#' @param type `character`, type of activation.
#' @export
#' @examples
#' validTms2Settings()
#' validTms2Settings("TMS2")
#' validTms2Settings("ETD")
#' validTms2Settings(c("TMS2", "ETD"))
validTms2Settings <- function(type=c("All", "TMS2", "ETD", "CID", "HCD", "UVPD"),
                              family="Calcium", version="3.2") {
    type <- match.arg(type, several.ok=TRUE)
    if ("All" %in% type) {
        type <- c("TMS2", "ETD", "CID", "HCD", "UVPD")
    }
    .validMsSettings(type, family=family, version=version)
}

#' List valid MS settings
#'
#' @param type `character`, MS1/TMS2/Activation
#' @param family `character`, currently just Calcium is supported
#' @param version `character`, currently 3.1, 3.2 [default], 3.3 are supported
#' @return `matrix`
#' @noRd
.validMsSettings <- function(type, family="Calcium", version="3.2") {
    if (!is.character(type))
        stop("'type' has to be a 'character'.")
    if (!is.character(family) || !family %in% names(.validMsSettingsXsd))
        stop("'family' has to be a 'character' and a valid family name.")
    if (!is.character(version) ||
        !version %in% names(.validMsSettingsXsd[[family]]))
        stop("'version' has to be a 'character' and a valid version.")
    m <- .validMsSettingsXsd[[family]][[version]]
    m[m[, "type"] %in% type,, drop=FALSE]
}

#' Validate a single MS setting against internal .validMsSettings (derivated
#' from XSD)
#'
#' @param name `character`, element name
#' @param value any type, value of element
#' @param type `character`, type of setting
#' @param family `character`, currently just Calcium is supported
#' @param version `character`, currently 3.1, 3.2 [default], 3.3 are supported
#' @return `TRUE` if valid, else message
#' @noRd
.validateMsSetting <- function(name, value, type, family="Calcium",
                               version="3.2") {
    if (type %in% c("ETD", "CID", "HCD", "UVPD")) {
        type <- c("TMS2", type)
    }
    settings <- .validMsSettings(type, family=family, version=version)
    entry <- settings[settings[, "name"] == name,]

    if (!length(entry)) {
        return(
            paste0(
                name, " is not a valid element of type ",
                paste0("'", type, "'", collapse="/"),
                " and/or not defined in MethodModification.xsd.\n",
                "  Run `validMs", ifelse(all(type == "MS1"), "1", "2"),
                "Settings()` for a complete list of possible settings."
            )
        )
    }

    tcl <- entry["class"]
    cl <- typeof(value)

    if (isTRUE(cl == "character" && grepl(":", tcl))) {
        isValidValue <-
            .vapply1l(value, function(x)grepl(paste0("(^|:)", x, "(:|$)"), tcl))

        if (any(!isValidValue)) {
            return(
                paste0(
                    name, " could not be '", paste0(value[!isValidValue]),
                    "'. Should be one of '", gsub(":", ", ", tcl), "'."
                )
            )
        }
    } else if (cl != tcl) {
        return(
            paste0(name, " should be of class '", tcl, "' but is '", cl, "'.")
        )
    }
    TRUE
}

#' Validate MS settings
#'
#' @param type `character`, MS1/TMS2/ActivationType
#' @param settings `list`, named arguments used for validation
#' @param family `character`, currently just Calcium is supported
#' @param version `character`, currently 3.1, 3.2 [default], 3.3 are supported
#' @return `TRUE` if valid, else stops with an error
#' @noRd
.validateMsSettings <- function(type=c("MS1", "TMS2", "ETD", "CID", "HCD",
                                       "UVPD"),
                                settings, family="Calcium", version="3.2") {
    type <- match.arg(type)
    validation <- mapply(
        .validateMsSetting,
        name=names(settings),
        value=settings,
        type=type,
        family=family,
        version=version,
        SIMPLIFY=FALSE
    )
    isValid <- .vapply1l(validation, isTRUE)

    if (any(!isValid)) {
        stop(paste0(unlist(validation[!isValid]), collapse="\n  "))
    }
    TRUE
}

#' Calculate Start/End time of each scan
#'
#' @param nMs2 `integer`, number of MS2 scans.
#' @param nMs2perMs1 `integer`, number of MS2 scans for each MS1 scan.
#' @param duration `double`, duration of scan in minutes.
#' @param gap `double`, pause between two scans in minutes.
#' @return `data.frame` with columns type (type of scan), start and end times
#' in minutes
#' @noRd
.startEndTime <- function(nMs2, nMs2perMs1=9L, duration=0.5, gap=0.01) {
    nMs1 <- ceiling(nMs2 * 1L/nMs2perMs1)
    n <- nMs2 + nMs1

    if (n > 150) {
        warning(
            "More than 150 experiments might cause the MS device ",
            "to become unresponsive. Choose other ", sQuote("groupBy"),
            " parameters to reduce number of experiments per file."
        )
    }

    if (duration) {
        start <- seq(gap, by=duration, length.out=n)
        end <- seq(duration, by=duration, length.out=n)
    } else {
        start <- end <- NA_real_
    }

    type <- rep_len(rep.int(c("MS1", "MS2"), times=c(1L, nMs2perMs1)), n)
    data.frame(
        Type=type, StartTimeMin=start, EndTimeMin=end, stringsAsFactors=FALSE
    )
}

context("experiment")

test_that("createExperimentsFragmentOptimisation", {
    ms1 <- data.frame(FirstMass=100, LastMass=200)
    ms2 <- data.frame(OrbitrapResolution=c("60K", "120K"), ActivationType="CID",
                      MassList="10/1", stringsAsFactors=FALSE)
    mods <- list(
        MethodModifications=structure(list(
            Modification=structure(list(
                Experiment=structure(
                    list(
                        FullMSScan=list(
                            FirstMass=list(100),
                            LastMass=list(200)
                        ),
                        StartTimeMin=list(0.01),
                        EndTimeMin=list(1)
                    ),
                    ExperimentIndex=0L
                )),
                Order=1L
            ),
            Modification=structure(list(
                    CopyAndAppendExperiment=structure(
                        list(),
                        SourceExperimentIndex=1L
                    )
                ),
                Order=2L
            ),
            Modification=structure(list(
                Experiment=structure(
                    list(
                        TMSnScan=list(
                            MassList=list(
                                MassListRecord=list(
                                    MOverZ=list(10),
                                    Z=list(1)
                                )
                            ),
                            OrbitrapResolution=list("60K"),
                            ActivationType=list("CID"),
                            ScanDescription=list("C1R1")
                        ),
                        StartTimeMin=list(1.01),
                        EndTimeMin=list(2)
                    ),
                    ExperimentIndex=1L
                )),
                Order=3L
            ),
            Modification=structure(list(
                Experiment=structure(
                    list(
                        TMSnScan=list(
                            MassList=list(
                                MassListRecord=list(
                                    MOverZ=list(10),
                                    Z=list(1)
                                )
                            ),
                            OrbitrapResolution=list("120K"),
                            ActivationType=list("CID"),
                            ScanDescription=list("C2R1")
                        ),
                        StartTimeMin=list(2.01),
                        EndTimeMin=list(3)
                    ),
                    ExperimentIndex=2L
                )),
                Order=4L
            )),
            Version=2L,
            Model="OrbitrapFusionLumos",
            Family="Calcium",
            Type="SL"
        )
    )

    exps <- list("1"=mods, "2"=mods)
    exps[[2]]$MethodModifications[[3]]$Experiment$TMSnScan$ScanDescription  <-
        list("C1R2")
    exps[[2]]$MethodModifications[[4]]$Experiment$TMSnScan$ScanDescription  <-
        list("C2R2")
    ## No Start/EndTime
    for (i in seq_along(exps)) {
        for (j in seq_along(exps[[i]]$MethodModifications)) {
            exps[[i]]$MethodModifications[[j]]$Experiment$StartTimeMin <- NULL
            exps[[i]]$MethodModifications[[j]]$Experiment$EndTimeMin <- NULL
        }
    }
    expect_equal(createExperimentsFragmentOptimisation(ms1, ms2,
                    groupBy="replication", randomise=FALSE), exps)
    ## No MassList
    for (i in seq_along(exps)) {
        exps[[i]]$MethodModifications[[3]]$Experiment$TMSnScan$MassList <- NULL
        exps[[i]]$MethodModifications[[4]]$Experiment$TMSnScan$MassList <- NULL
    }
    expect_equal(createExperimentsFragmentOptimisation(ms1,
                    ms2[c("OrbitrapResolution", "ActivationType")],
                    groupBy="replication", randomise=FALSE), exps)

    exps <- list("1"=mods, "2"=mods)
    exps[[2]]$MethodModifications[[3]]$Experiment$TMSnScan$ScanDescription  <-
        list("C1R2")
    exps[[2]]$MethodModifications[[4]]$Experiment$TMSnScan$ScanDescription  <-
        list("C2R2")
    expect_equal(
        createExperimentsFragmentOptimisation(
            ms1, ms2, groupBy="replication", scanDuration=1, randomise=FALSE
        ),
        exps
    )
})

test_that(".ms1ConditionToTree", {
    d <- data.frame(FirstMass=100, LastMass=200)
    l1 <- list(Experiment=list(FullMSScan=list(FirstMass=list(100),
                                               LastMass=list(200))))
    attr(l1$Experiment, "ExperimentIndex") <- 2
    l2 <- l1
    l2$Experiment$StartTimeMin <- list(1)
    l2$Experiment$EndTimeMin <- list(2)
    expect_equal(.ms1ConditionToTree(d, 2, times=NA), l1)
    expect_equal(.ms1ConditionToTree(d, 2, times=1:2), l2)
})

test_that(".copyAndAppendExperiment", {
    l <- list(CopyAndAppendExperiment=list())
    attr(l$CopyAndAppendExperiment, "SourceExperimentIndex") <- 0
    expect_equal(.copyAndAppendExperiment(0), l)
    attr(l$CopyAndAppendExperiment, "SourceExperimentIndex") <- 2
    expect_equal(.copyAndAppendExperiment(2), l)
})

test_that(".tms2ConditionToTree", {
    d <- data.frame(ActivationType="CID", AgcTarget=1e5, stringsAsFactors=FALSE)
    d2 <- cbind(MassList="10/1", d, stringsAsFactors=FALSE)
    d3 <- data.frame(MassList="10/1", stringsAsFactors=FALSE)
    l1 <- list(Experiment=list(TMSnScan=list(ActivationType=list("CID"),
                                             AgcTarget=list(1e5))))
    attr(l1$Experiment, "ExperimentIndex") <- 2
    l2 <- l1
    l2$Experiment$StartTimeMin <- list(1)
    l2$Experiment$EndTimeMin <- list(2)
    l3 <- l1
    l3$Experiment$TMSnScan$MassList <- list(MassListRecord=list(MOverZ=list(10),
                                                       Z=list(1)))
    l4 <- l2
    l4$Experiment$TMSnScan$MassList <- l3$Experiment$TMSnScan$MassList
    l3$Experiment$TMSnScan <- l3$Experiment$TMSnScan[c("MassList",
                                                       "ActivationType",
                                                       "AgcTarget")]
    l4$Experiment$TMSnScan <- l4$Experiment$TMSnScan[c("MassList",
                                                       "ActivationType",
                                                       "AgcTarget")]
    l5 <- list(Experiment=list(TMSnScan=list(MassList=l3$Experiment$TMSnScan$MassList)))
    attr(l5$Experiment, "ExperimentIndex") <- 2

    expect_equal(.tms2ConditionToTree(d, 2, times=NA), l1)
    expect_equal(.tms2ConditionToTree(d, 2, times=1:2), l2)
    expect_equal(.tms2ConditionToTree(d2, 2, times=NA), l3)
    expect_equal(.tms2ConditionToTree(d2, 2, times=1:2), l4)
    expect_equal(.tms2ConditionToTree(d3, 2), l5)
})

test_that(".collapseMassList", {
    ml1 <- list(MassListRecord=list(MOverZ=list(10), Z=list(1)))
    ml2 <- list(
        MassListRecord=list(MOverZ=list(10), Z=list(1)),
        MassListRecord=list(MOverZ=list(20), Z=list(2))
    )
    expect_equal(.massListToTree("10/1"), ml1)
    expect_equal(.massListToTree("10/1 20/2"), ml2)
})

test_that(".collapseMassList", {
    expect_error(.collapseMassList(1:10))
    expect_error(.collapseMassList(cbind(1:3, 1:3, 1:3)))
    expect_equal(.collapseMassList(cbind(c(10, 20), 1:2)), "10/1 20/2")
})

test_that(".expandMassList", {
    expect_error(.expandMassList(1:10))
    expect_equal(
        .expandMassList("10/1 20/2"),
        matrix(c(10, 20, 1:2), ncol=2, dimnames=list(NULL, c("mz", "z")))
    )
})

test_that("expandMs1Conditions", {
    expect_error(expandMs1Conditions(FOO=1), "FOO is not a valid element")
    expect_error(expandMs1Conditions(FirstMass=1, family="FOO"))
    expect_error(expandMs1Conditions(FirstMass=1, version="xx"))
    expect_equal(expandMs1Conditions(FirstMass=100, LastMass=200),
                 data.frame(FirstMass=100, LastMass=200), )
})

test_that("expandTms2Conditions", {
    expect_error(expandTms2Conditions(FOO=1), "FOO is not a valid element")
    expect_error(expandTms2Conditions(ActivationType="CID", AgcTarget=1,
                                     family="FOO"))
    expect_error(expandTms2Conditions(ActivationType="CID", AgcTarget=1,
                                     version="xx"))
    ms2 <- data.frame(MassList="10/1 20/2",
                      ActivationType="CID",
                      AgcTarget=rep(c(1e5, 5e5), 2),
                      OrbitrapResolution=rep(c("R120K", "R60K"), each=2),
                      stringsAsFactors=FALSE)
    expect_equal(expandTms2Conditions(ActivationType="CID",
                                     AgcTarget=c(1e5, 5e5),
                                     OrbitrapResolution=c("R120K", "R60K")),
                 ms2[-1])
    expect_equal(expandTms2Conditions(MassList=cbind(mz=c(10, 20), z=1:2),
                                     ActivationType="CID",
                                     AgcTarget=c(1e5, 5e5),
                                     OrbitrapResolution=c("R120K", "R60K")),
                 ms2)
})

test_that("validMs1Settings", {
    expect_error(validMs1Settings(family=1))
    expect_error(validMs1Settings(family="FOO"))
    expect_error(validMs1Settings(version="xx"))
    m <- validMs1Settings()
    expect_is(m, "matrix")
    expect_equal(colnames(m), c("name", "class", "type"))
    expect_equal(m[1:3, "name"], c("FirstMass", "LastMass", "Microscans"))
    expect_equal(m[1:3, "class"], c("double", "double", "integer"))
    expect_equal(m[1:3, "type"], rep("MS1", 3))
})

test_that("validTms2Settings", {
    expect_error(validTms2Settings("FOO"))
    expect_error(validTms2Settings(family=1))
    expect_error(validTms2Settings(family="FOO"))
    expect_error(validTms2Settings(version="xx"))
    m <- validTms2Settings()
    expect_is(m, "matrix")
    expect_equal(colnames(m), c("name", "class", "type"))
    expect_equal(validTms2Settings("All"),
                 validTms2Settings(c("TMS2", "ETD", "CID", "HCD", "UVPD")))
})

test_that(".validMsSettings", {
    expect_error(.validMsSettings(1))
    expect_error(.validMsSettings(FALSE))
    expect_error(.validMsSettings("MS1", family=1))
    expect_error(.validMsSettings("MS1", family="FOO"))
    expect_error(.validMsSettings("MS1", family="Calcium",
                                             version=3))
    expect_error(.validMsSettings("MS1", family="Calcium", version="foo"))
    expect_true(all(grepl("UVPD.*ActivationTime",
        .validMsSettings("UVPD", family="Calcium", version="3.2")[, "name"])))
    expect_true(any(grepl("ScanDescription",
        .validMsSettings("TMS2", family="Calcium", version="3.2")[, "name"])))
    expect_false(any(grepl("ScanDescription",
        .validMsSettings("TMS2", family="Calcium", version="3.1")[, "name"])))
})

test_that(".validateMsSetting", {
    expect_true(.validateMsSetting(
        "OrbitrapResolution", c("R15K", "R500K", "R50K"), "TMS2"))
    expect_true(.validateMsSetting(
        "OrbitrapResolution", c("R15K", "R500K", "R50K"), "ETD"))
    expect_true(.validateMsSetting("FirstMass", 1000, "MS1"))
    expect_true(.validateMsSetting("Microscans", 40L, "MS1"))
    expect_true(.validateMsSetting("MinAgcTarget", TRUE, "TMS2"))
    expect_true(grepl("FooBar is not a valid element",
        .validateMsSetting("FooBar", TRUE, "MS2")))
    expect_true(grepl("of type 'MS1'",
        .validateMsSetting("OrbitrapResolution", TRUE, "MS1")))
    expect_true(grepl("could not be 'R40K'",
        .validateMsSetting("OrbitrapResolution", c("R15K", "R40K"), "TMS2")))
    expect_true(grepl("should be of class 'integer'",
        .validateMsSetting("Microscans", 10, "MS1")))
})

test_that(".validateMsSettings", {
    expect_true(.validateMsSettings("TMS2",
        list(OrbitrapResolution=c("R15K", "R50K", "R500K"), MinAgcTarget=TRUE)))
    expect_error(.validateMsSettings("TMS2",
        list(FirstMass=1000, OrbitrapResolution=c("R15K", "R50K", "R500K"))),
        "of type 'TMS2'"
    )
})

test_that(".startEndTime", {
    r <- data.frame(Type=c("MS1", rep("MS2", 12), "MS1", rep("MS2", 8)),
                    StartTimeMin=seq(0.02, by=0.8, length.out=22),
                    EndTimeMin=seq(0.8, by=0.8, length.out=22),
                    stringsAsFactors=FALSE)
    expect_equal(.startEndTime(nMs2=20, nMs2perMs1=12, duration=0.8,
                                         gap=0.02), r)
    expect_warning(.startEndTime(nMs2=201, nMs2perMs1=2),
                   "More than 150 experiments")
})

#' @describeIn NCBSet Best combination of conditions.
#'
#' Finds the best combination of conditions for highest coverage of fragments or
#' bonds. If there are two (or more conditions) that would add the same number
#' of fragments/bonds the one with the highest assigned intensity is used. Use
#' `n` to limit the number of iterations and combinations that should be
#' returned.
#' If `minN` is set at least `minN` fragments have to be added to the
#' combinations. The function returns a 7-column matrix. The first column
#' contains the index (`Index`) of the condition (column number). The next
#' columns contain the newly added number of fragments or bonds
#' (`FragmentsAddedToCombination`, `BondsAddedToCombination`), the fragments
#' or bonds in the condition (`FragmentsInCondition`, `BondsInCondition`), and
#' the cumulative coverage fragments or bonds (`FragmentCoverage`,
#' `BondCoverage`).
#'
#' @param object `NCBSet`
#' @param n `integer`, max number of combinations/iterations.
#' @param minN `integer`,
#' stop if there are less than `minN` additional fragments
#' @param maximise `character`, optimisation targeting for the highest number of
#' `"fragments"` (default) or `"bonds"`.
#' @param \ldots arguments passed to internal/other methods.
#' added.
## @return `matrix`, first column: index of condition (`Index`), second column: number of
## newly added fragments third column: number of newly covered bonds, fourth and
## fifth column: fragments/bonds in the condition; sixth and seventh column:
## fragment/bond coverage
#' @aliases bestConditions bestConditions,NCBSet-method
#' @export
setMethod("bestConditions", "NCBSet",
          function(object, n=ncol(object), minN=0L,
                   maximise=c("fragments", "bonds"), ...) {
    m <- .bestNcbCoverageCombination(
        object@assay,
        intensity=object@colData$AssignedIntensity,
        n=n,
        minN=minN,
        maximise=maximise
    )
    m <- cbind(
        m,
        .countFragments(object@assay[, m[, "index"], drop=FALSE]),
        .colCounts(object@assay[, m[, "index"], drop=FALSE]),
        cumsum(m[, "fragments"])/(2L * nrow(object@assay)),
        cumsum(m[, "bonds"])/nrow(object@assay)
    )
    dimnames(m) <- list(
        colnames(object)[m[, "index"]],
        c(
            "Index",
            paste0(
                c("Fragments", "Bonds"),
                rep(c("AddedToCombination", "InCondition"), each=2L)
            ),
            paste0(c("Fragment", "Bond"), "Coverage")
        )
    )
    m
})

#' @describeIn NCBSet Plot fragmentation map.
#'
#' Plots a fragmentation map of the Protein.
#' Use `nCombinations` to add another
#' plot with `nCombinations` combined conditions.
#' If `cumCoverage` is `TRUE` (default)
#' these combinations increase the coverage cumulatively.
#'
## @param object `NCBSet`
#' @param nCombinations `integer`,
#' number of combinations to show (0 to avoid plotting them at all).
#' @param cumCoverage `logical`,
#' if `TRUE` (default) cumulative coverage of combinations is shown.
## @param maximise `character`, optimisation targeting for the highest number of
## `"fragments"` (default) or `"bonds"`.
#' @param labels `character`, overwrite x-axis labels.
#' @param alphaIntensity `logical`, if `TRUE` (default) the alpha level of the
#' color is used to show the `colData(object)$AssignedIntensity`. If `FALSE` the
#' alpha is set to `1`.
#' @aliases fragmentationMap fragmentationMap,NCBSet-method
#' @export
setMethod("fragmentationMap", "NCBSet",
          function(object, nCombinations=10, cumCoverage=TRUE,
                   maximise=c("fragments", "bonds"), labels=colnames(object),
                   alphaIntensity=TRUE, ...) {

    if (length(labels) != ncol(object)) {
        stop("The number of elements in 'labels' has to be the same as ",
            "the number of columns in 'object'.")
    }
    d <- .dgCMatrix2data.frame(object@assay)
    d$Activation <- as.character(object$Activation[d$col])
    d$AssignedIntensity <- object$AssignedIntensity[d$col]

    if (nCombinations) {
        i <- bestConditions(object, n=nCombinations,
                            maximise=maximise)[, "Index"]
        combinations <- object[, i]
        labels <- c(labels, labels[i])

        if (cumCoverage) {
            cmb <- .dgCMatrix2data.frame(.cumComb(combinations@assay))
        } else {
            cmb <- .dgCMatrix2data.frame(combinations@assay)
        }
        ## overwrite col (.dgCMatrix2data.frame creates 1:nCombinations)
        i <- i[cmb$col]
        cmb$AssignedIntensity <- object$AssignedIntensity[i]
        ## ggplot doesn't accept duplicated col for a facet
        cmb$col <- cmb$col + ncol(object)
        cmb$Activation <- "Cmb"
        d <- rbind(d, cmb)
    }

    ## tell ggplot that we have an already ordered factor
    d$col <- as.ordered(d$col)
    d$x <- as.factor(d$x)
    d$Activation <-
        factor(
            d$Activation,
            levels=c("CID", "HCD", "ETD", "ETcid", "EThcd", "UVPD", "Cmb"),
            ordered=TRUE
        )
    names(labels) <- seq_along(labels)

    gg <- ggplot(data=d)
        if (alphaIntensity) {
            gg <- gg +
                geom_raster(
                    aes_string(
                        x="col",
                        y="row",
                        fill="x",
                        alpha="AssignedIntensity"
                    )
                ) + scale_alpha(name="Assigned Intensity")
        } else {
           gg <- gg + geom_raster(aes_string(x="col", y="row", fill="x"))
        }
    gg  <- gg +
        facet_grid(. ~ Activation, scales="free_x", space="free_x") +
        scale_fill_manual(
            name="Observed Fragments",
            labels=c("N-terminal", "C-terminal", "Bidirectional"),
            values=c("#1b9e77", "#d95f02", "#7570b3")
        ) +
        scale_x_discrete(
            name="Condition", expand=c(0L, 0L), labels=labels
        ) +
        scale_y_continuous(
            name=expression(paste("Bonds (", N-terminal %->% C-termnial, ")")),
            breaks=seq_len(nrow(object)),
            expand=c(0L, 0L)
        ) +
        geom_vline(
            xintercept=c(0L, seq_len(ncol(object))) + 0.5,
            colour="#808080", size=0.1
        ) +
        geom_hline(
            yintercept=c(0L, seq_len(nrow(object))) + 0.5,
            colour="#808080", size=0.1
        ) +
        ggtitle("fragmentation map") +
        theme(
            axis.text.x=element_text(angle=90, hjust=1, vjust=0.4),
            plot.title=element_text(hjust=0.5, face="bold"),
            panel.grid.major=element_blank(),
            panel.border=element_blank(),
            panel.background=element_blank(),
            strip.background=element_rect(fill="#f0f0f0", colour="#ffffff")
        )
    gg
})

#' @rdname NCBSet-class
#' @aliases show,NCBSet-method
#' @export
setMethod("show", "NCBSet", function(object) {
    callNextMethod()

    if (length(object@rowViews)) {
        cat("- - - Fragment data - - -\n")
        cat0(
            paste0(
                "Number of ",
                c("N-terminal", "C-terminal", "N- and C-terminal"),
                " fragments: ", tabulate(object@assay@x, nbins=3L),
            "\n")
        )
    }

    if (nrow(object@colData)) {
        cat("- - - Condition data - - -\n")
        cat("Number of conditions:", length(unique(object$Sample)), "\n")
        cat("Number of scans:", nrow(object@colData), "\n")
        cat0("Condition variables (", ncol(object@colData), "): ",
            paste0(.hft(colnames(object@colData), n=2), collapse=", "), "\n")
    }

    if (all(dim(object))) {
        cat("- - - Assay data - - -\n")
        cat(sprintf(
                "Size of array: %dx%d (%.2f%% != 0)\n",
                nrow(object@assay), ncol(object@assay),
                nnzero(object@assay) / length(object@assay) * 100L
            )
        )
    }

    if (length(object@processing)) {
        cat("- - - Processing information - - -\n")
        cat(paste0(object@processing, collapse="\n"), "\n")
    }

    invisible(NULL)
})

#' @describeIn NCBSet Summary statistics.
#'
#' Returns a `matrix` with some statistics: number of fragments,
#' total/min/first quartile/median/mean/third quartile/maximum of intensity
#' values.
#'
## @param object `NCBSet`
#' @param what `character`,
#' specifies whether `"conditions"` (columns; default) or
#' `"bonds"` (rows) should be summarized.
#' @aliases summary,NCBSet-method
#' @export
setMethod("summary", "NCBSet",
          function(object, what=c("conditions", "bonds"), ...) {
    what <- if (match.arg(what) == "conditions") { "columns" } else { "rows" }
    callNextMethod(object=object, what=what)
})

#' Read top-down files.
#'
#' It creates an [TopDownSet-class] object and is its only constructor.
#'
#' @details
#'
#' `readTopDownFiles` reads and processes all top-down files, namely:
#' * `.fasta` (protein sequence)
#' * `.mzML` (spectra)
#' * `.experiments.csv` (method/fragmentation conditions)
#' * `.txt` (scan header information)
#'
#' `customModifications`: additional to the provided unimod modifications
#' available through the `modifications` argument `customModifications` allow to
#' apply user-definied modifications to the output of
#' [`PSMatch::calculateFragments()`].
#' The `customModifications` argument takes a
#' `data.frame` with the `mass` to add, the `name` of the modification, the
#' location (could be the position of the amino acid or "N-term"/"C-term"),
#' whether the modification is always seen (`variable=FALSE`) or both, the
#' modified and unmodified amino acid are present (`variable=TRUE`), e.g.
#' for Activation (which is available via `modification="Acetyl"`)
#' `data.frame(mass=42.010565, name="Acetyl", location="N-term", variable=FALSE)`
#' or variable one (that could be present or not):
#' `data.frame(mass=365.132, name="Custom", location=10, variable=TRUE)`
#'
#' If the `customModifications` `data.frame` contains multiple columns the
#' modifications are applied from row one to the last row one each time.
#'
#' `adducts`: *Thermo's Xtract*
#' allows some mistakes in deisotoping, mostly it
#' allows `+/- C13-C12` and `+/- H+`.
#' The `adducts` argument takes a
#' `data.frame` with the `mass` to add, the `name`
#' that should assign to these
#' new fragments and an information `to`
#' whom the modification should be
#' applied, e.g. for `H+` on `z`,
#' `data.frame(mass=1.008, name="zpH", to="z")`.
#'
#' *Please note:* The `adducts` are added to the output of
#' [`PSMatch::calculateFragments()`].
#' That has some limitations, e.g.
#' neutral loss calculation could not be done in
#' [topdownr-package].
#' If neutral loss should be applied on adducts you have to create
#' additional rows, e.g.:
#' `data.frame(mass=c(1.008, 1.008), name=c("cpH", "cpH_"), to=c("c", "c_"))`.
#'
#' @param path `character`,
#' path to directory that contains the top-down files.
#' @param pattern `character`,
#' a filename pattern, the default `.*` means all files.
#' @param type `character`,
#' type of fragments, currently *a-c* and *x-z* are
#' supported, see
#' [`PSMatch::calculateFragments()`]
#' for details.
#' @param modifications `character`,
#' unimod names of modifications that should be applied.
#' Currenlty just *Acetyl* (Unimod:1 but just protein N-term),
#' *Carbamidomethyl* (Unimod:4) and
#' *Met-loss* (Unimod:765) are supported.
#' *Met-loss* removes M
#' (if followed by A, C, G, P, S, T, or V;
#' (see also
#' http://www.unimod.org/modifications_view.php?editid1=1,
#' http://www.unimod.org/modifications_view.php?editid1=4, and
#' http://www.unimod.org/modifications_view.php?editid1=765 for details)).
#' Use `NULL` to disable all modifications.
#' @param adducts `data.frame`,
#' with 3 columns, namely: mass, name, to, see details section.
#' @param customModifications `data.frame`,
#' with 4 columns, namely: mass, name, location, variable, see details section.
#' @param neutralLoss `list`,
#' neutral loss that should be applied, see
#' [`PSMatch::calculateFragments()`] and
#' [`PSMatch::defaultNeutralLoss()`]
#' for details.
#' @param sequenceOrder `character`,
#' order of the sequence before fragment calculation and matching is done.
#' `"original"` doesn't change anything.
#' `"inverse"` reverse the sequence and
#' `"random"` arranges the amino acid sequence at random.
#' @param tolerance `double`,
#' tolerance in *ppm* that is used to match the
#' theoretical fragments with the observed ones.
#' @param redundantIonMatch `character`, a mz could be matched to one, two or
#' more fragments. If it is matched against more than one fragment the match
#' could be `"remove"`d or the match to the `"closest"` fragment could be
#' chosen.
#' @param redundantFragmentMatch `character`, one or more mz could be matched to
#' the same fragment, these matches could be `"remove"`d or the match to the
#' `"closest"` mz is chosen.
#' @param dropNonInformativeColumns logical,
#' should columns with just one identical value across all runs be removed?
#' @param sampleColumns `character`,
#' column names of the [colData()]
#' used to define a sample (technical replicate). This is used to add the
#' `Sample` column (used for easier aggregation, etc.).
#' @param conditions `character`/`numeric`, one of:
#'  - `"ScanDescription"` (default): create condition IDs based on the given
#'    "Scan Description" parameter (set automatically by
#'    [createExperimentsFragmentOptimisation()]).
#'  - `"FilterString"`: create condition IDs based on mass labels in
#'    the *FilterString* column (included for backward-compatibilty, used
#'    in [writeMethodXmls()] prior version 1.5.2 in Dec 2018).
#'  - A single `numeric` value giving the number of conditions.
#' @param verbose `logical`, verbose output?
#' @return A `TopDownSet` object.
#' @export
#' @seealso [`PSMatch::calculateFragments()`],
#' [`PSMatch::defaultNeutralLoss()`]
#' @examples
#' if (require("topdownrdata")) {
#'     # add H+ to z and no neutral loss of water
#'     tds <- readTopDownFiles(
#'         topdownrdata::topDownDataPath("myoglobin"),
#'         ## Use an artifical pattern to load just the fasta
#'         ## file and files from m/z == 1211, ETD reagent
#'         ## target 1e6 and first replicate to keep runtime
#'         ## of the example short
#'         pattern=".*fasta.gz$|1211_.*1e6_1",
#'         adducts=data.frame(mass=1.008, name="zpH", to="z"),
#'         neutralLoss=PSMatch::defaultNeutralLoss(
#'             disableWaterLoss=c("Cterm", "D", "E", "S", "T")),
#'         tolerance=25e-6
#'    )
#' }
readTopDownFiles <- function(path, pattern=".*",
                             type=c("a", "b", "c", "x", "y", "z"),
                             modifications=c("Carbamidomethyl",
                                             "Acetyl", "Met-loss"),
                             customModifications=data.frame(),
                             adducts=data.frame(),
                             neutralLoss=PSMatch::defaultNeutralLoss(),
                             sequenceOrder=c("original", "random", "inverse"),
                             tolerance=5e-6,
                             redundantIonMatch=c("remove", "closest"),
                             redundantFragmentMatch=c("remove", "closest"),
                             dropNonInformativeColumns=TRUE,
                             sampleColumns=c("Mz", "AgcTarget",
                                             "EtdReagentTarget",
                                             "EtdActivation",
                                             "CidActivation",
                                             "HcdActivation",
                                             "UvpdActivation"),
                             conditions="ScanDescription",
                             verbose=interactive()) {


    redundantIonMatch <- match.arg(redundantIonMatch)
    redundantFragmentMatch <- match.arg(redundantFragmentMatch)

    files <- .listTopDownFiles(path, pattern=pattern)

    sequence <- .readFasta(files$fasta, verbose=verbose)

    fragmentViews <- .calculateFragments(
        sequence=sequence,
        type=type,
        modifications=modifications,
        customModifications=customModifications,
        adducts=adducts,
        neutralLoss=neutralLoss,
        sequenceOrder=sequenceOrder,
        verbose=verbose
    )

    scanConditions <- .rbind(
        lapply(
            files$txt,
            .readScanHeadsTable,
            conditions=conditions,
            verbose=verbose
        )
    )

    scanConditions$Scan <- unlist(mapply(
        .rtToScanId,
        file=files$mzML,
        rt=split(scanConditions$RtMin, scanConditions$File),
        MoreArgs=list(
            verbose=verbose
        ),
        SIMPLIFY=FALSE, USE.NAMES=FALSE
    ))

    headerInformation <- .rbind(
        lapply(files$csv, .readExperimentCsv, verbose=verbose)
    )

    mzml <- mapply(
        .readMzMl,
        file=files$mzML,
        scans=split(scanConditions$Scan, scanConditions$File),
        MoreArgs=list(
            fmass=mz(fragmentViews),
            tolerance=tolerance,
            redundantIonMatch=redundantIonMatch,
            redundantFragmentMatch=redundantFragmentMatch,
            verbose=verbose
        ),
        SIMPLIFY=FALSE, USE.NAMES=FALSE
    )

    mzmlHeader <- do.call(rbind, lapply(mzml, "[[", "hd"))

    scanHeadsman <- .mergeScanConditionAndHeaderInformation(
        scanConditions, headerInformation
    )

    header <- .mergeSpectraAndHeaderInformation(mzmlHeader, scanHeadsman)

    if (dropNonInformativeColumns) {
        header <- .dropNonInformativeColumns(
            header,
            keep=c(
                "File", "Scan", "SpectrumIndex", "Activation", "Mz", "AgcTarget"
            )
        )
    }

    header$Charge <- round(fragmentViews@metadata$mass / header$Mz)

    assay <- do.call(cbind, lapply(mzml, "[[", "m"))
    dimnames(assay) <- list(names(fragmentViews), rownames(header))

    tds <- new(
        "TopDownSet",
        rowViews=fragmentViews,
        colData=.colsToRle(.colsToLogical(as(header, "DataFrame"))),
        assay=assay,
        files=unlist(unname(files)),
        tolerance=tolerance,
        redundantMatching=c(
            ion=redundantIonMatch,
            fragment=redundantFragmentMatch
        )
    )
    tds <- .atdsLogMsg(
        tds, .logdim(tds), " matched (tolerance: ",
        round(tolerance / 1e-6, 1L), " ppm, strategies ion/fragment: ",
        redundantIonMatch, "/", redundantFragmentMatch, ").", addDim=FALSE
    )
    tds <- updateConditionNames(tds, sampleColumns=sampleColumns, verbose=FALSE)
    updateMedianInjectionTime(tds)
}

#' Turn condition into a data.frame
#'
#' @param object `TopDownSet`
#' @return `data.frame`
#' @noRd
.condition2data.frame <- function(object) {
    .isTopDownSet(object)

    if (ncol(object) != 1L) {
        stop("Converting more than one condition is currently not implemented.")
    }

    s <- .readSpectrum(
        object@files[
            .subsetFiles(basename(object@files), object@colData$File[1L]) &
            grepl(.topDownFileExtRx("mzml"), object@files)
        ],
        object$SpectrumIndex[1L]
    )
    nr <- nrow(s)
    fragment <- character(nr)
    type <- rep.int("None", nr)
    fv <- object@rowViews[object@assay[, 1L] > 0L]

    k <- .matchFragments(
        s[, 1L],
        mz(fv),
        tolerance=object@tolerance,
        redundantIonMatch=object@redundantMatching[1L],
        redundantFragmentMatch=object@redundantMatching[2L]
    )

    notNA <- !is.na(k)
    if (sum(notNA)) {
        fragment[notNA] <- names(fv)[k[notNA]]
        type[notNA] <- ifelse(
            elementMetadata(fv)$type[k[notNA]] %in% c("a", "b", "c"),
            "N-terminal", "C-terminal"
        )
    }
    data.frame(
        mz=s[, 1L],
        intensity=s[, 2L],
        fragment=fragment,
        type=factor(
            type,
            levels=c("None", "N-terminal", "C-terminal", "Bidirectional"),
            ordered=TRUE
        ),
        stringsAsFactors=FALSE
    )
}

#' Test for TopDownSet class
#'
#' @param object object to test
#' @return `TRUE` if object is a TopDownSet otherwise fails with an error
#' @noRd
.isTopDownSet <- function(object) {
    if (!isTRUE(is(object, "TopDownSet"))) {
        stop("'object' has to be an 'TopDownSet' object.")
    }
    TRUE
}

#' Create NCB Map (N-/C-terminal, or Bidirectional)
#'
#' @param object `TopDownSet`
#' @param nterm `character(1)`, regular expression to match N-term
#' @param cterm `character(1)`, regular expression to match C-term
#' @return `Matrix`, Nterm == 1, Cterm == 2, bidirectional == 3
#' @noRd
.ncbMap <- function(object, nterm="^a|^b|^c", cterm="^x|^y|^z") {
    .isTopDownSet(object)

    w <- width(object@rowViews)
    mn <- mc <- object@assay
    selN <- grepl(nterm, fragmentType(object))
    selC <- grepl(cterm, fragmentType(object))
    mn[!selN, ] <- 0L
    mn <- drop0(mn)
    mc[!selC, ] <- 0L
    mc <- drop0(mc)

    mn <- as(.colSumsGroup(mn, w) > 0L, "dMatrix")
    mc <- as(.colSumsGroup(mc, max(w) + 1L - w) > 0L, "dMatrix")
    mc@x[] <- 2L
    m <- drop0(mn + mc)
    colnames(m) <- colnames(object)
    rownames(m) <- paste0(
        "bond", .formatNumbers(seq_len(nrow(m)), asInteger=TRUE)
    )
    m
}

#' Plot a specific condition of an TopDownSet object
#'
#' @param x `TopDownSet`
#' @noRd
.plot <- function(x) {
    .isTopDownSet(x)

    d <- .condition2data.frame(x)
    ggplot(
        data=d,
        aes_string(x="mz", y="intensity", fragment="fragment", color="type")
    ) +
    geom_segment(aes_string(xend="mz", yend=0L)) +
    geom_text(
        aes_string(label="fragment"),
        angle=90L,
        hjust=0.2,
        vjust=0.5,
        nudge_y=max(d$intensity) / 100L
    ) +
    scale_color_manual(
        name="Observed Fragments",
        labels=c("none", "N-terminal", "C-terminal", "Bidirectional"),
        values=c("#000000", "#1b9e77", "#d95f02", "#7570b3"),
        guide=FALSE
    ) +
    theme_classic() +
    theme(
        plot.title=element_text(hjust=0.5, face="bold"),
        legend.position="none",
    ) +
    labs(title=colnames(x)[1L], x="m/z", y="intensity")
}

context("TopDownSet")

tds <- new("TopDownSet",
           rowViews=FragmentViews("ACE", mass=1:3 * 100,
                                  type=c("c", "c", "x"),
                                  start=1:3, width=c(1:2, 1),
                                  names=c("c1", "c2", "x1")),
           colData=DataFrame(Scan=1:5, File=Rle(c(rep("foo", 3),
                                                  "bar", "bar")),
                             row.names=paste("condition",
                                             rep_len(1:3, 5),
                                             rep(1:2, c(3, 2)), sep="_")),
           assay=sparseMatrix(i=c(1:2, 1:3, 1, 3, 2),
                              j=rep(1:5, c(2, 3, 1, 1, 1)),
                              x=2:9),
           files=c("bar.experiments.csv", "foo.experiments.csv",
                   "foo.fasta", "bar.mzML", "foo.mzML", "bar.txt", "foo.txt"),
           processing="[2017-07-16 14:00:00] Data created.")

test_that("[", {
    tdsc <- new("TopDownSet",
                rowViews=FragmentViews("ACE", mass=1:2 * 100,
                                       type=c("c", "c"),
                                       start=1:2, width=1:2,
                                       names=c("c1", "c2")),
               colData=DataFrame(Scan=1:5, File=Rle(c(rep("foo", 3),
                                                      "bar", "bar")),
                                 row.names=paste("condition",
                                                 rep_len(1:3, 5),
                                                 rep(1:2, c(3, 2)), sep="_")),
               assay=sparseMatrix(i=rep(1:2, 3),
                                   j=rep(c(1:3, 5), c(2, 2, 1, 1)),
                                   x=c(2:5, 7, 9)),
              files=c("bar.experiments.csv", "foo.experiments.csv",
                      "foo.fasta", "bar.mzML", "foo.mzML", "bar.txt",
                      "foo.txt"),
               processing=c("[2017-07-16 14:00:00] Data created.",
                            paste0("[2017-07-16 14:00:01] ",
                                   "Subsetted 8 fragments [3;5] to ",
                                   "6 fragments [2;5].")))
    tdsc1 <- new("TopDownSet",
                 rowViews=FragmentViews("ACE", mass=100, type="c",
                                        start=1, width=1, names="c1"),
                colData=DataFrame(Scan=1:5, File=Rle(c(rep("foo", 3),
                                                       "bar", "bar")),
                                  row.names=paste("condition",
                                                  rep_len(1:3, 5),
                                                  rep(1:2, c(3, 2)), sep="_")),
                assay=sparseMatrix(i=rep(1, 3),
                                    j=1:3,
                                    x=c(2, 4, 7),
                                    dims=c(1, 5)),
               files=c("bar.experiments.csv", "foo.experiments.csv",
                       "foo.fasta", "bar.mzML", "foo.mzML", "bar.txt",
                       "foo.txt"),
                processing=c("[2017-07-16 14:00:00] Data created.",
                             paste0("[2017-07-16 14:00:02] ",
                                    "Subsetted 8 fragments [3;5] to ",
                                    "3 fragments [1;5].")))

    tdsf <- new("TopDownSet",
                rowViews=FragmentViews("ACE", mass=1:3 * 100,
                                       type=c("c", "c", "x"),
                                       start=1:3, width=c(1:2, 1),
                                       names=c("c1", "c2", "x1")),
                colData=DataFrame(Scan=1:3, File=Rle(rep("foo", 3)),
                                  row.names=paste("condition", 1:3, rep(1, 3),
                                                  sep="_")),
                assay=sparseMatrix(i=c(1:2, 1:3, 1),
                                    j=rep(1:3, c(2, 3, 1)),
                                    x=2:7),
                files=c("foo.experiments.csv", "foo.fasta", "foo.mzML",
                        "foo.txt"),
                processing=c("[2017-07-16 14:00:00] Data created.",
                             paste0("[2017-07-16 14:00:03] ",
                                    "Subsetted 8 fragments [3;5] to ",
                                    "6 fragments [3;3].")))
    expect_equal(tds["c"], tdsc)
    expect_equal(tds["c",], tdsc)
    expect_equal(tds["c1"], tdsc1)
    expect_equal(tds[,1:3], tdsf)
    expect_equal(tds[,Rle(1:3, rep(1, 3))], tdsf)
    expect_warning(tds[3:1,], "row order")
    expect_warning(tds[1, drop=TRUE], "'drop' is ignored")
})

test_that("[[ and $", {
    expect_equal(tds[[1]], 1:5)
    expect_equal(tds[["Scan"]], 1:5)
    expect_equal(tds$Scan, 1:5)
    tdn <- tds
    tdn$Scan <- 11:15
    expect_equal(tdn$Scan, 11:15)
    tdn[["Scan"]] <- 1:5
    expect_equal(tdn$Scan, 1:5)
    tdn$Scan[1:3] <- 11:13
    expect_equal(tdn$Scan, c(11:13, 4:5))
    tdn$Scan[1:3] <- 11:13
    expect_equal(tdn$Scan, c(11:13, 4:5))
})

test_that("accessors", {
    expect_equal(assayData(tds), tds@assay)
    expect_equal(colData(tds), tds@colData)
    expect_equal(conditionData(tds), colData(tds))
    expect_equal(rowViews(tds), tds@rowViews)
})

test_that("accessors<-", {
    tdn <- tds
    colData(tdn)[["Scan"]] <- 11:15
    expect_equal(colData(tdn)$Scan, 11:15)
    tdn <- tds
    conditionData(tdn)[["Scan"]] <- 11:15
    expect_equal(conditionData(tdn)$Scan, 11:15)
})

test_that("aggregate", {
    tds$Sample <- c(2, 2, 2, 10, 10)
    tda <- new("TopDownSet",
               rowViews=FragmentViews("ACE", mass=1:3 * 100,
                                      type=c("c", "c", "x"),
                                      start=1:3, width=c(1:2, 1),
                                      names=c("c1", "c2", "x1")),
               colData=DataFrame(Scan=c(1, 4), File=Rle(c("foo", "bar")),
                                 Sample=c(2, 10),
                                 row.names=paste0("condition_1_", 1:2)),
               assay=sparseMatrix(i=c(1:3, 2:3),
                                   j=rep(1:2, 3:2),
                                   x=c(13/3, 4, 6, 9, 8)),
               files=tds@files,
               processing=c("[2017-07-16 14:00:00] Data created.",
                            paste0("[2017-07-16 14:00:01] Aggregated ",
                                   "8 fragments [3;5] to ",
                                   "5 fragments [3;2].")))
    expect_error(aggregate(tds, by="FooBar"), "same length")
    expect_equal(aggregate(tds, by=list(tds$File)), tda)
    expect_equal(aggregate(tds, by=list(rep(1:2, c(3, 2)))), tda)
    expect_equal(aggregate(tds, by=list(rep(c(2, 10), c(3, 2)))), tda)
})

test_that("combine", {
    tds$Mz <- 100
    tds$AgcTarget <- 1e5
    tds$EtdReagentTarget <- 1e6
    tds$EtdActivation <- tds$CidActivation <- tds$HcdActivation <- NA_real_
    tds$UvpdActivation <- (1:5) * 1000
    tds$IonInjectionTimeMs <- 1:5
    tds@tolerance <- 5e-6
    tds@redundantMatching <- c("remove", "remove")
    rownames(tds@assay) <- rownames(tds)
    tds <- updateConditionNames(tds)
    tds1 <- tds2 <- tds
    o <- c(matrix(1:10, nrow=2, byrow=TRUE))
    a <- cbind(tds1@assay, tds2@assay)[, o]
    cd <- .colsToRle(rbind(tds1@colData, tds2@colData)[o, ])
    colnames(a) <- rownames(cd) <- paste0("C", rep((1:5) * 1000, each=2), "_",
                                          rep(1:2, 5))
    tdsr <- new("TopDownSet",
                rowViews=tds@rowViews,
                colData=cd,
                assay=a,
                tolerance=5e-6,
                files=unique(tds1@files, tds2@files),
                processing=c(tds1@processing, tds2@processing,
                             paste("[2017-12-28 15:30:00]",
                                   "Condition names updated based on: Mz,",
                                   "AgcTarget, EtdReagentTarget,",
                                   "EtdActivation, CidActivation,",
                                   "HcdActivation, UvpdActivation. Order of",
                                   "conditions changed. 5 conditions."),
                             paste("[2017-12-28 15:30:01]",
                                   "Recalculate median injection time based",
                                   "on: Mz, AgcTarget."),
                             paste("[2017-12-28 15:30:02]",
                                   "Combined 8 fragments [3;5] and 8 fragments",
                                   "[3;5] into a 16 fragments [3;10]",
                                   "TopDownSet object.")))
    tdsr$MedianIonInjectionTimeMs <- Rle(3, 10)
    expect_equal(combine(tds1, tds2), tdsr)
    tds2@tolerance <- 1e-6
    expect_warning(combine(tds1, tds2), "Matching tolerance differs")
    expect_equal(suppressWarnings(combine(tds1, tds2)), tdsr)
    tds2@tolerance <- tds1@tolerance
    tds2@redundantMatching <- c("closest", "closest")
    expect_warning(combine(tds1, tds2), "Matching strategies differ")
    expect_equal(suppressWarnings(combine(tds1, tds2)), tdsr)
})

test_that("conditionNames", {
    expect_equal(conditionNames(tds),
                 paste("condition",
                       rep_len(1:3, 5),
                       rep(1:2, c(3, 2)), sep="_"))
})

test_that("condition2data.frame", {
    expect_error(.condition2data.frame(1:10),
                 "has to be an 'TopDownSet' object")
    expect_error(.condition2data.frame(tds),
                 "more than one condition")
    skip_if_not_installed("topdownrdata", "0.2")
    suppressWarnings(tds <- readTopDownFiles(
        topdownrdata::topDownDataPath("myoglobin"),
        pattern=".*fasta.gz$|1211_.*1e6_1",
        conditions="FilterString",
        neutralLoss=NULL,
        tolerance=25e-6
    ))
    s <- .readSpectrum(tds@files[grep("mzML.gz", tds@files)],
                                  tds$SpectrumIndex[3])
    d <- data.frame(
        mz=s[,1], intensity=s[,2], fragment="",
        type=factor(
            "None",
            levels=c("None", "N-terminal", "C-terminal", "Bidirectional"),
            ordered=TRUE
        ),
        stringsAsFactors=FALSE
    )
    i <- c(29, 34, 42, 45, 60, 76, 77, 78, 84, 85, 95, 97, 98, 99, 100, 114, 117)
    d$fragment[i] <- c("y48", "y51", "y58", "x60", "y75", "z90", "b89", "c89",
        "y94", "x94", "y101", "y105", "z106", "y106", "y112", "y152", "c152")
    d$type[i] <- paste0(c("C", "C", "C", "C", "C", "C", "N", "N", "C", "C",
        "C", "C", "C", "C", "C", "C", "N"), "-terminal")
    expect_equal(.condition2data.frame(tds[, 3]), d)
    s <- .readSpectrum(tds@files[grep("mzML.gz", tds@files)],
                                  tds$SpectrumIndex[103])
    d <- data.frame(
        mz=s[,1], intensity=s[,2], fragment="",
        type=factor(
            "None",
            levels=c("None", "N-terminal", "C-terminal", "Bidirectional"),
            ordered=TRUE
        ),
        stringsAsFactors=FALSE
    )
    i <- c(23, 26)
    d$fragment[i] <- c("z152", "b152")
    d$type[i] <- paste0(c("C", "N"), "-terminal")
    expect_equal(.condition2data.frame(tds[, 103]), d)
})

test_that("dim", {
    expect_equal(dim(tds), c(3, 5))
})

test_that("dimnames", {
    expect_equal(dimnames(tds), list(c("c1", "c2", "x1"),
                                     paste("condition",
                                           rep_len(1:3, 5),
                                           rep(1:2, c(3, 2)), sep="_")))
})

test_that("filterCv", {
    tdfit <- tds
    tdfit$Sample <- rep(1:2, 3:2)

    expect_error(filterCv(tdfit, threshold="A"),
                 "has to be a 'numeric'")
    expect_error(filterCv(tdfit, threshold=1:2),
                 "length one")
    expect_error(filterCv(tdfit, threshold=-1),
                 "greater than 0")

    expect_equal(filterCv(tdfit, threshold=100), tdfit)
    tdfitr <- tdfit
    tdfitr@assay[c(1, 4, 7)] <- 0L
    tdfitr@assay <- drop0(tdfitr@assay)
    tdfitr@processing <- c(tdfitr@processing,
                           paste0("[2017-08-04 18:05:00] 3 fragments with ",
                                  "CV > 40% filtered; 5 fragments [3;5]."))
    expect_equal(filterCv(tdfit, threshold=40), tdfitr)
})

test_that("filterInjectionTime", {
    tdfit <- tds
    tdfit$IonInjectionTimeMs <- c(1:3, 2:3)
    tdfit$MedianIonInjectionTimeMs <- rep(1:2, 3:2)
    tdfit$Sample <- rep(1:2, 3:2)

    expect_error(filterInjectionTime(tdfit, maxDeviation="A"),
                 "has to be a 'numeric'")
    expect_error(filterInjectionTime(tdfit, maxDeviation=1:2),
                 "length one")
    expect_error(filterInjectionTime(tdfit, maxDeviation=-1),
                 "greater than 0")

    expect_equal(filterInjectionTime(tdfit, maxDeviation=100, keepTopN=5),
                 tdfit)
    tdfitr <- tdfit[, c(1, 4)]
    tdfitr@processing <- c(tdfitr@processing,
                           paste0("[2017-07-28 16:00:02] 3 scans filtered ",
                                  "with injection time deviation >= 0.5 or ",
                                  "rank >= 6; 3 fragments [3;2]."))
    expect_equal(filterInjectionTime(tdfit, maxDeviation=0.5, keepTopN=5),
                 tdfitr)
    tdfitr <- tdfit[, -3]
    tdfitr@processing <- c(tdfitr@processing,
                           paste0("[2017-07-28 16:00:02] 1 scan filtered ",
                                  "with injection time deviation >= 5 or ",
                                  "rank >= 3; 7 fragments [3;4]."))
    expect_equal(filterInjectionTime(tdfit, maxDeviation=5, keepTopN=2),
                 tdfitr)
    tdfitr <- tdfit[, -(2:3)]
    tdfitr@processing <- c(tdfitr@processing,
                           paste0("[2017-07-28 16:00:02] 2 scans filtered ",
                                  "with injection time deviation >= 0.6 or ",
                                  "rank >= 3; 4 fragments [3;3]."))
    expect_equal(filterInjectionTime(tdfit, maxDeviation=0.6, keepTopN=2),
                 tdfitr)
})

test_that("filterIntensity", {
   tdl <- tds
   tdl@assay <- sparseMatrix(i=c(1, 3, 2), j=3:5, x=7:9)
   tdl@processing <- c(tdl@processing,
                       paste0("[2017-07-16 14:00:02] ",
                              "5 intensity values < 7 filtered; ",
                              "3 fragments [3;5]."))
   expect_error(filterIntensity(tds, 1:2), "length one")
   expect_error(filterIntensity(tds, "c"), "numeric")
   expect_error(filterIntensity(tds, 2), "between 0 and 1")
   expect_error(filterIntensity(tds, -1), "between 0 and 1")
   expect_equal(filterIntensity(tds, 7, relative=FALSE), tdl)
   tdl@processing[2L] <- paste0("[2017-07-16 14:00:02] ",
                                "5 intensity values < 0.8 (relative) filtered; ",
                                "3 fragments [3;5].")
   expect_equal(filterIntensity(tds, 0.8), tdl)
})

test_that("filterNonReplicatedFragments", {
    tdfit <- tds
    tdfit$Sample <- rep(1:2, 3:2)

    expect_error(filterNonReplicatedFragments(tdfit, minN="A"),
                 "has to be a 'numeric'")
    expect_error(filterNonReplicatedFragments(tdfit, minN=1:2),
                 "length one")

    expect_equal(filterNonReplicatedFragments(tdfit, minN=0),
                 tdfit)
    tdfitr <- tdfit
    tdfitr@assay <- sparseMatrix(i=c(1:2, 1:2, 1),
                                 j=rep(1:3, c(2, 2, 1)),
                                 x=c(2:5, 7), dims=c(3, 5))
    tdfitr@processing <- c(tdfitr@processing,
                           paste0("[2017-07-31 22:15:00] 3 intensity values ",
                                  "of fragments replicated < 2 times ",
                                  "filtered; 5 fragments [3;5]."))
    expect_equal(filterNonReplicatedFragments(tdfit, minN=2), tdfitr)
})

test_that(".isTopDownSet", {
    expect_true(.isTopDownSet(new("TopDownSet")))
    expect_true(.isTopDownSet(tds))
    expect_error(.isTopDownSet(1L),
                 "has to be an 'TopDownSet' object")
})

test_that(".ncbMap", {
    tds1 <- new("TopDownSet",
                rowViews=FragmentViews("ACE", mass=1:5 * 100,
                                       type=c("c", "c", "x", "y", "z_"),
                                       start=c(1:2, 1, 1, 3),
                                       width=c(1:2, 3, 3, 1),
                                       names=c("c1", "c2", "x3", "y3", "z1_")),
                colData=DataFrame(Scan=1:4),
                assay=sparseMatrix(i=c(1:2, 3:4, 1:4, 5),
                                    j=rep(1:4, c(2, 2, 4, 1)),
                                    x=rep(9, 9)),
                files=c("foo.experiments.csv", "foo.fasta", "foo.mzML",
                        "foo.txt"),
                processing="[2017-07-16 14:00:00] Data created.")

    r <- sparseMatrix(i=rep(1:2, c(3, 4)),
                      j=c(1:3, 1:2, 4:5),
                      x=c(rep(1, 4), 3:1),
                      dims=c(2, 5),
                      dimnames=list(paste0("bond", 1:2), colnames(tds)))

    r1 <- sparseMatrix(i=c(1:2, 1, 1:2),
                       j=c(1, 1, 2, 3, 3),
                       x=c(1, 1, 2, 3, 1),
                       dims=c(3, 4),
                       dimnames=list(paste0("bond", 1:3), c()))

    expect_equal(.ncbMap(tds), r)
    expect_equal(.ncbMap(tds1, cterm = "^x$|^y$|^z$"), r1)
})

test_that("normalize", {
    tds$TotIonCurrent <- c(10, 20, 10, 10, 20)
    tdn <- tds
    tdn@assay <- t(t(tds@assay) / tdn$TotIonCurrent)
    tdn@processing <- c(tdn@processing,
                        paste0("[2017-08-06 14:50:00] ",
                               "Intensity values normalized ",
                               "to TIC."))
    expect_equal(normalize(tds, method="TIC"), tdn)
})

test_that("readTopDownFiles", {
    expect_error(readTopDownFiles(".", pattern="FOOBAR"),
                 "Could not find any csv, fasta, mzML, txt files!")
})

test_that("removeEmptyConditions", {
    tdr <- tds
    tdr@assay[cbind(c(1, 3), 3:4)] <- 0L
    tdr@assay <- drop0(tdr@assay)
    tdrr <- tdr[, c(1:2, 5)]
    tdrr@processing <- c(tdrr@processing,
                         paste0("[2017-08-01 22:25:00] ",
                                "2 empty conditions removed; ",
                                "6 fragments [3;3]."))
    expect_equal(removeEmptyConditions(tdr), tdrr)
})

test_that("show", {
    expect_output(show(new("TopDownSet")),
                  "TopDownSet object \\([0-9]\\.[0-9]+ Mb\\)")
    tds$Sample <- rep(1:2, 3:2)
    expect_output(show(tds),
                  paste(c("TopDownSet object \\([0-9]\\.[0-9]+ Mb\\)",
                          "- - - Protein data - - -",
                          "Amino acid sequence \\(3\\): ACE ",
                          "- - - Fragment data - - -",
                          "Number of theoretical fragments: 3 ",
                          "Theoretical fragment types \\(2\\): c, x",
                          "Theoretical mass range: \\[100\\.00;300\\.00\\]",
                          "- - - Condition data - - -",
                          "Number of conditions: 2 ",
                          "Number of scans: 5 ",
                          "Condition variables \\(3\\): Scan, File, Sample",
                          "- - - Intensity data - - -",
                          "Size of array: 3x5 \\(53\\.33% != 0\\)",
                          "Number of matched fragments: 8 ",
                          "Intensity range: \\[2.00;9.00\\]",
                          "- - - Processing information - - -",
                          "\\[2017-07-16 14:00:00\\] Data created. "),
                        collapse="\n"))
    tdn <- tds
    tdn@assay <- Matrix(0, nrow=3, ncol=5, sparse=TRUE)
    expect_output(show(tdn),
                  paste(c("Size of array: 3x5 \\(0\\.00% != 0\\)",
                          "Number of matched fragments: 0 ",
                          "Intensity range: \\[NA;NA\\]"),
                        collapse="\n"))
    tdn@rowViews@metadata$modifications <-
        c("Carbamidomethyl", "Met-loss+Acetyl")
    expect_output(show(tdn),
                  "Modifications \\(2\\): Carbamidomethyl, Met-loss\\+Acetyl")
})

test_that("summary", {
    dc <- data.frame(Fragments=c(2, 3, 1, 1, 1), Total=c(5, 15, 7:9),
                     Min=c(2, 4, 7:9), Q1=c(2.25, 4.5, 7:9),
                     Median=c(2.5, 5.0, 7:9), Mean=c(5/3, 5, 7/3, 8/3, 3),
                     Q3=c(2.75, 5.5, 7:9), Max=c(3, 6, 7:9))
    dr <- data.frame(Fragments=c(3, 3, 2), Total=c(13, 17, 14), Min=c(2:3, 6),
                     Q1=c(3:4, 6.5), Median=c(4:5, 7), Mean=c(2.6, 3.4, 2.8),
                     Q3=c(5.5, 7.0, 7.5), Max=c(7, 9, 8))
    expect_equal(summary(tds), dc)
    expect_equal(summary(tds, "conditions"), dc)
    expect_equal(summary(tds, "fragments"), dr)
})

test_that("validObject", {
    tdn <- tds
    tdn@assay <- tdn@assay[1,,drop=FALSE]
    expect_error(validObject(tdn), "Mismatch between fragment data")
    tdn <- tds
    rownames(tdn@assay) <- seq_len(nrow(tdn@assay))
    expect_error(validObject(tdn), "Mismatch between fragment names")
    tdn <- tds
    tdn@assay <- tdn@assay[,1,drop=FALSE]
    expect_error(validObject(tdn), "Mismatch between condition data")
    expect_true(validObject(tds))
    tdn <- tds
    rownames(tdn@colData) <- seq_len(nrow(tdn@colData))
    colnames(tdn@assay) <- rev(seq_len(ncol(tdn@assay)))
    expect_error(validObject(tdn), "Mismatch between condition names")
})

test_that("as(\"MSnSet\")", {
    msn <- new("MSnSet",
               exprs=matrix(c(2:3, 0, 4:6, 7, rep(0, 4), 8, 0, 9, 0), nrow=3,
                            dimnames=dimnames(tds)),
               phenoData=as(data.frame(Scan=1:5,
                                       File=rep(c("foo", "bar"), 3:2),
                                       row.names=colnames(tds),
                                       stringsAsFactors=FALSE),
                            "AnnotatedDataFrame"),
               featureData=as(data.frame(fragment=c("A", "CE", "E"),
                                         start=1:3, end=c(1, 3, 3), width=c(1, 2, 1),
                                         name=c("c1", "c2", "x1"),
                                         type=factor(c("c", "c", "x")),
                                         mass=(1:3)*100, z=1,
                                         row.names=c("c1", "c2", "x1")),
                              "AnnotatedDataFrame"))
    msn@processingData <- new("MSnProcess", files=tds@files,
                              processing="[2017-07-16 14:00:00] Data created.")
    expect_equal(as(tds, "MSnSet"), msn)
})

test_that("as(\"NCBSet\")", {
    ncb <- new("NCBSet",
               rowViews=Views(AAString("ACE"), start=1, width=1:2,
                              names=paste0("bond", 1:2)),
               colData=DataFrame(tds@colData, AssignedIntensity=c(5, 15, 7:9),
                                 row.names=paste("condition",
                                                 rep_len(1:3, 5),
                                                 rep(1:2, c(3, 2)), sep="_")),
               assay=sparseMatrix(i=rep(1:2, c(3, 4)),
                                  j=c(1:3, 1:2, 4:5),
                                  x=c(rep(1, 4), 3, 2, 1),
                                  dimnames=list(c("bond1", "bond2"),
                                                paste("condition",
                                                      rep_len(1:3, 5),
                                                      rep(1:2, c(3, 2)),
                                                      sep="_"))),
               files=tds@files,
               processing=c(tds@processing,
                            paste("[2017-08-20 16:30:00]",
                                  "Coerced TopDownSet into an NCBSet object;",
                                  "7 fragments [2;5].")))
    expect_equal(as(tds, "NCBSet"), ncb)
})

devtools::load_all()

baseurl <-
    "https://raw.githubusercontent.com/thermofisherlsms/meth-modifications"

## Currently we just support the 3.x serie of the "Calcium" family
version <- list(
    Calcium=c("3.1", "3.2", "3.3")
)

## 3.2/3.3 are (internal) beta (3.1 is released (public) beta?)
release <- list(
    Calcium=paste(c("release/beta", "beta", "beta"), version$Calcium, sep="-")
)

.validMsSettingsXsd <- vector(mode="list", length=length(version))
names(.validMsSettingsXsd) <- names(version)

for (i in seq(along=.validMsSettingsXsd)) {
    .validMsSettingsXsd[[i]] <- vector(mode="list", length=length(version[[i]]))
    names(.validMsSettingsXsd[[i]]) <- version[[i]]

    for (j in seq(along=version[[i]])) {
        url <- paste(
            baseurl,
            release[[i]][j],
            "xsds",
            names(version)[i],
            version[[i]][j],
            "MethodModifications.xsd",
            sep="/"
        )
        xsd <- xml2::read_xml(url)
        .validMsSettingsXsd[[i]][[j]] <- .xmlValidMsSettings(xsd)
    }
}

usethis::use_data(
    .validMsSettingsXsd,
    internal=TRUE,
    overwrite=TRUE
)

#' Create Orbitrap Fusion Lumos method.xml files.
#'
#' This function is used to create Orbitrap Fusion Lumos method files from
#' a tree-like `list` experiment generated by e.g.
#' [createExperimentsFragmentOptimisation()].
#'
#' @param exps `list`, generated by e.g.
#' [createExperimentsFragmentOptimisation()]
#' @param pattern `character`, file name pattern for the method.xml files.
#' @param verbose `logical`, verbose output?
#'
#' @details
#'
#' * `exps`: a named tree-like `list` object generated by e.g.
#' [createExperimentsFragmentOptimisation()]. Its names are used as filename.
#' * `pattern`: The file name pattern used to name different method files.
#'  It must contain a `"%s"` that is replaced by the conditions defined in
#'  `groupBy`.
#'
#' **DEFUNCT** options:
#'
#' * `ms1Settings`:
#'   A `list` of MS1 settings. This has to be a named `list`.
#'   Valid MS1 settings are:
#'   `c("FirstMass", "LastMass", "Microscans", "MaxITTimeInMS", "AgcTarget")`
#' * `ms2Settings`:
#'   A `list` of MS2 settings. This has to be a named `list`.
#'   Valid MS2 settings are:
#'   `c("ActivationType", "IsolationWindow", "EnableMultiplexIons",
#'      "EnableMSXIds", "MaxNoOfMultiplexIons", "OrbitrapResolution",
#'      "AgcTarget", "MinAgcTarget", "MaxITTimeInMS", "Microscans",
#'      "ETDReactionTime", "ETDReagentTarget",
#'      "MaximumETDReagentInjectionTime", "UseInternalCalibratedETD",
#'      "ETDSupplementalActivationEnergy", "ETDSupplementalActivation")`
#' * `groupBy`: The `groupBy` parameter is used to split methods into
#'  different files. Valid entries are all settings that could be used in
#'  `ms2Settings` and `"replication"`.
#' * `massLabeling`: The Orbitrap Fusion devices seems not to respect the
#'  start and end times of the runs given in the method.xml files. That's why it
#'  is nearly impossible to identify the run with its conditions based on the
#'  timings. If `massLabeling` is `TRUE` (default) the mass values given
#'  in `mz` are rounded to the first decimal place and the second to fourth
#'  decimal place is used as numeric identifier.
#'
#' @seealso [createExperimentsFragmentOptimisation()]
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}, Pavel V. Shliaha
#' \email{pavels@@bmb.sdu.dk}
#' @examples
#' ms1 <- expandMs1Conditions(FirstMass=400, LastMass=1200, Microscans=as.integer(10))
#'
#' targetMz <- cbind(mz=c(560.6, 700.5, 933.7), z=rep(1, 3))
#' common <- list(
#'     OrbitrapResolution="R120K",
#'     IsolationWindow=1,
#'     MaxITTimeInMS=200,
#'     Microscans=as.integer(40),
#'     AgcTarget=c(1e5, 5e5, 1e6)
#' )
#' cid <- expandTms2Conditions(
#'     MassList=targetMz,
#'     common,
#'     ActivationType="CID",
#'     CIDCollisionEnergy=seq(7, 35, 7)
#' )
#' hcd <- expandTms2Conditions(
#'     MassList=targetMz,
#'     common,
#'     ActivationType="HCD",
#'     HCDCollisionEnergy=seq(7, 35, 7)
#' )
#' etd <- expandTms2Conditions(
#'     MassList=targetMz,
#'     common,
#'     ActivationType="ETD",
#'     ETDReagentTarget=c(1e6, 5e6, 1e7),
#'     ETDReactionTime=c(2.5, 5, 10, 15, 30, 50),
#'     ETDSupplementalActivation=c("None", "ETciD", "EThcD"),
#'     ETDSupplementalActivationEnergy=seq(7, 35, 7)
#' )
#' exps <- createExperimentsFragmentOptimisation(ms1=ms1, cid, hcd, etd,
#'     groupBy=c("AgcTarget", "replication"), nMs2perMs1=10, scanDuration=0.5,
#'     replications=2, randomise=TRUE
#' )
#' writeMethodXmls(exps=exps)
#' @export
writeMethodXmls <- function(exps, pattern="method-%s.xml",
                            verbose=interactive()) {

    requireNamespace("xml2")

    if (!grepl("%s", pattern)) {
        stop(
            sQuote("pattern"),
            " has to contain '%s' to be replaced by the ",
            "grouping condition."
        )
    }

    fn <- .validFilename(sprintf(pattern, names(exps)))
    for (i in seq(along=exps)) {
        if (verbose) {
            message("Writing ", fn[i])
        }
        xml2::write_xml(xml2::as_xml_document(exps[[i]]), file=fn[i])
    }
}

setGeneric("assayData",
    function(object)standardGeneric("assayData"))
setGeneric("rowViews",
    function(object, ...)standardGeneric("rowViews"))
setGeneric("colData",
    function(object, ...)standardGeneric("colData"))
setGeneric("colData<-",
    function(object, ..., value)standardGeneric("colData<-"))
setGeneric("conditionData",
    function(object, ...)standardGeneric("conditionData"))
setGeneric("conditionData<-",
    function(object, ..., value)standardGeneric("conditionData<-"))
setGeneric("conditionNames",
    function(object)standardGeneric("conditionNames"))
setGeneric("bestConditions",
    function(object, ...)standardGeneric("bestConditions"))
setGeneric("filterCv",
    function(object, ...)standardGeneric("filterCv"))
setGeneric("filterInjectionTime",
    function(object, ...)standardGeneric("filterInjectionTime"))
setGeneric("filterIntensity",
    function(object, ...)standardGeneric("filterIntensity"))
setGeneric("filterNonReplicatedFragments",
    function(object, ...) standardGeneric("filterNonReplicatedFragments"))
setGeneric("fragmentationMap",
    function(object, ...)standardGeneric("fragmentationMap"))
setGeneric("removeEmptyConditions",
    function(object, ...)standardGeneric("removeEmptyConditions"))
setGeneric("updateConditionNames",
    function(object, ...)standardGeneric("updateConditionNames"))
setGeneric("updateMedianInjectionTime",
    function(object, ...)standardGeneric("updateMedianInjectionTime"))

#' Find best combination of columns for highest coverage
#'
#' @param x `dgCMatrix`
#' @param intensity `double` total intensity
#' @param n `integer`, max number of combinations/iterations
#' @param minN `integer` stop if there are less than `minN` non-zero
#' elements added by the next column.
#' @param maximise `character`, maximise fragment/bond coverage
#' @return `matrix`, first column: index, second column: number of fragments,
#' third column: number of bonds
#' @noRd
.bestNcbCoverageCombination <- function(x, intensity=NULL,
                                        n=ncol(x), minN=0L,
                                        maximise=c("fragments", "bonds")) {
    if (!is(x, "dgCMatrix"))
        stop("'x' is not of class 'dgCMatrix'.")
    if (is.null(intensity))
        intensity <- rep(0L, ncol(x))
    if (ncol(x) != length(intensity))
        stop(
            "Number of columns in 'x' doesn't match the length of",
            "'intensity'."
        )
    maximise <- match.arg(maximise)
    m <- matrix(NA_real_, nrow=n, ncol=3L,
                dimnames=list(NULL, c("index", "fragments", "bonds")))

    ## make bonds binary but not logical because we want to use
    ## .removeNcbCombinations latter
    bonds <- x
    bonds@x[] <- 1L

    for (i in seq_len(n)) {
        if (maximise == "fragments") {
            hc <- .highestNcbFragmentCoverage(x, intensity=intensity)
            m[i, ] <- c(hc, .colCounts(bonds[, hc["index"], drop=FALSE]))
        } else {
            hc <- .highestNcbBondCoverage(bonds, intensity=intensity)
            m[i, c("index", "bonds", "fragments")] <-
                c(hc, .countFragments(x[, hc["index"], drop=FALSE]))
        }
        x <- .removeNcbCombinations(x, hc["index"])
        bonds <- .removeNcbCombinations(bonds, hc["index"])

        if (((!nnzero(x) && maximise == "fragments") ||
             (!nnzero(bonds) && maximise == "bonds")) &&
            hc[maximise] >= minN) {
            m <- m[seq_len(i), , drop=FALSE]
            break
        } else if (hc[maximise] < minN) {
            m <- m[seq_len(i - 1L), , drop=FALSE]
            break
        }
    }
    m
}

#' Highest NCB bond coverage
#'
#' Find column with highest coverage of bonds.
#' If multiple max. are found choose the one with the highest total intensity.
#'
#' @param x `dgCMatrix`
#' @param intensity `double` total intensity
#' @return `numeric`, first element: index of column with highest coverage,
#' second element: number bonds
#' @noRd
.highestNcbBondCoverage <- function(x, intensity=rep(0L, ncol(x))) {
    nb <- unname(.colCounts(x))

    ## we don't use `which.max` because if there are multiple matches we want to
    ## select the one with the highest intensity and not the first one.
    i <- which(nb == max(nb), useNames=FALSE)

    if (length(i) > 1L) {
        i <- i[which.max(intensity[i])]
    }
    c(index=i, bonds=nb[i])
}

#' Highest NCB fragment coverage
#'
#' Find column with highest coverage of NCB fragments, B fragments count twice.
#' If multiple max. are found choose the one with the highest total intensity.
#'
#' @param x `dgCMatrix`
#' @param intensity `double` total intensity
#' @param maximise `character`, maximise fragment/bond coverage
#' @return `numeric`, first element: index of column with highest coverage,
#' second element: number fragments
#' @noRd
.highestNcbFragmentCoverage <- function(x, intensity=rep(0L, ncol(x))) {
    nf <- unname(.countFragments(x))

    ## we don't use `which.max` because if there are multiple matches we want to
    ## select the one with the highest intensity and not the first one.
    i <- which(nf == max(nf), useNames=FALSE)

    if (length(i) > 1L) {
        i <- i[which.max(intensity[i])]
    }
    c(index=i, fragments=nf[i])
}

#' Remove NCB combinations
#'
#' @param x `dgCMatrix`
#' @param i `integer`, column with highest coverage
#' @return `dgCMatrix`, coverage reduced
#' @noRd
.removeNcbCombinations <- function(x, i) {
    if (!is(x, "dgCMatrix"))
        stop("'x' is not of class 'dgCMatrix'.")
    if (any(x@x > 3L))
        stop("Unknown fragment id.")
    r <- .row(x[, i, drop=FALSE])
    hc <- x[r, i]
    r <- r - 1L
    ## if 3 (bidirectional) remove all
    x@x[x@i %in% r[hc == 3L]] <- 0L
    ## if 1 (N) keep 2 (C) and reduce 3 (bidirectional) to 2 (C)
    isN <- x@i %in% r[hc == 1L]
    isN <- isN & x@x != 2L
    x@x[isN] <- x@x[isN] - 1L
    ## if 2 (C) keep 1 (N) and reduce 3 (bidirectional) to 1 (N)
    isC <- x@i %in% r[hc == 2L]
    isC <- isC & x@x != 1L
    x@x[isC] <- x@x[isC] - 2L
    drop0(x)
}

context("coverage")

test_that(".bestNcbCoverageCombination", {
    m1 <- sparseMatrix(i=c(1, 2, 2, 3, 5, 5, 6, 9, 8, 9, 8),
                       j=c(1, 5, 3, 4, 4, 5, 4, 4, 5, 5, 1),
                       x=c(1, 1, 3, 1, 1, 2, 2, 2, 3, 1, 2))
    expect_equal(.bestNcbCoverageCombination(m1),
                 cbind(index=c(5:4, 1, 3), fragments=c(5:4, 1, 1),
                       bonds=c(4, 2, 1, 0)))
    expect_equal(.bestNcbCoverageCombination(m1,
                                                        maximise="fragments"),
                 cbind(index=c(5:4, 1, 3), fragments=c(5:4, 1, 1),
                       bonds=c(4, 2, 1, 0)))
    expect_equal(.bestNcbCoverageCombination(m1, maximise="bonds"),
                 cbind(index=c(4, 1, 3), fragments=c(4, 2, 2),
                       bonds=c(4, 2, 1)))
    expect_equal(.bestNcbCoverageCombination(m1, intensity=1:5),
                 cbind(index=c(5:3, 1), fragments=c(5:4, 1, 1),
                       bonds=c(4, 2, 0, 1)))
    expect_equal(.bestNcbCoverageCombination(m1, minN=3),
                 cbind(index=c(5:4), fragments=c(5, 4), bonds=c(4, 2)))
    expect_equal(.bestNcbCoverageCombination(m1, n=3),
                 cbind(index=c(5:4, 1), fragments=c(5:4, 1), bonds=c(4, 2, 1)))
    expect_equal(.bestNcbCoverageCombination(m1, minN=5),
                 cbind(index=5, fragments=5, bonds=4))
})

test_that(".highestNcbBondCoverage", {
    m1 <- sparseMatrix(i=c(1:10, 2), j=c(1, 4, 3, 4, 4, 5, 4, 5, 5, 5, 1),
                       x=rep(1, 11))
    expect_error(.highestNcbBondCoverage(as.matrix(1:10)))
    expect_error(.highestNcbBondCoverage(m))
    expect_equal(.highestNcbBondCoverage(m1, intensity=1:5),
                 c(index=5, bonds=4))
    expect_equal(.highestNcbBondCoverage(m1, intensity=5:1),
                 c(index=4, bonds=4))
    expect_equal(.highestNcbBondCoverage(t(m1)),
                 c(index=2, bonds=2))
})

test_that(".highestNcbFragmentCoverage", {
    m1 <- sparseMatrix(i=c(1:10, 2), j=c(1, 5, 3, 4, 4, 5, 4, 5, 5, 5, 1),
                       x=c(1, 1, 3, 1, 1, 2, 2, 2, 3, 1, 1))
    expect_error(.highestNcbFragmentCoverage(as.matrix(1:10)))
    expect_error(.highestNcbFragmentCoverage(m))
    expect_equal(.highestNcbFragmentCoverage(m1, intensity=1:5),
                 c(index=5, fragments=6))
    expect_equal(.highestNcbFragmentCoverage(m1[,1:3]),
                 c(index=1, fragments=2))
    expect_equal(.highestNcbFragmentCoverage(m1[,1:3], intensity=1:3),
                 c(index=3, fragments=2))
    expect_equal(.highestNcbFragmentCoverage(t(m1)),
                 c(index=2, fragments=2))
    expect_equal(.highestNcbFragmentCoverage(t(m1)),
                 c(index=2, fragments=2))
})

test_that(".removeNcbCombinations", {
    m1 <- sparseMatrix(i=c(1, 2, 2, 3, 5, 5, 6, 9, 8, 9, 8),
                       j=c(1, 5, 3, 4, 4, 5, 4, 4, 5, 5, 1),
                       x=c(1, 1, 3, 1, 1, 2, 2, 2, 3, 1, 2))
    r1 <- sparseMatrix(i=c(1, 2, 3, 5, 6, 9),
                       j=c(1, 3, 4, 4, 4, 4),
                       x=c(1, 2, 1, 1, 2, 2), dims=c(9, 5))
    r2 <- sparseMatrix(i=c(1, 2, 2, 5, 8, 9, 8),
                       j=c(1, 5, 3, 5, 5, 5, 1),
                       x=c(1, 1, 3, 2, 3, 1, 2))
    expect_error(.removeNcbCombinations(matrix(1:10, ncol=2), 2))
    expect_error(.removeNcbCombinations(m, 2))
    expect_equal(.removeNcbCombinations(m1, 5), r1)
    expect_equal(.removeNcbCombinations(m1, 4), r2)
})

#' @describeIn AbstractTopDownSet Subset operator.
#'
#' For `i` `numeric`, `logical` or `character` vectors or empty
#' (missing) or `NULL` are supported.
#' Subsetting is done on the fragment/bond (row) level.
#' `character` indices could be names
#' (e.g. `c("a1", "b1", "c1", "c2", "c3")`)
#' or types (e.g. `c("c", "x")`) of the fragments for
#' [TopDownSet-class] objects,
#' or names of the bonds (e.g. `c("bond001")`) for
#' [NCBSet-class] objects. \cr
#' `j` could be a `numeric` or `logical` vector
#' and subsetting is done on the condition/run (column) level.
#'
#' @param object,x `AbstractTopDownSet`
#' @param i,j `numeric`, `logical` or `character`,
#' indices specifying elements to extract or replace.
#' @param \ldots arguments passed to internal/other methods.
#' @param drop `logical`, currently ignored.
#'
## @param i `numeric`, `logical` or `character`, subsetting on fragment/bond
## data, names (`c("a1", "b1", "c1", "c2", "c3")`) and types (`c("c", "x")`)
## (or for [NCBSet-class] bonds e.g. `bond001`) are supported.
## @param j `numeric` or `logical`, subsetting based on condition data.
## @param \ldots currently ignored.'
#' @aliases [,AbstractTopDownSet,ANY,ANY,ANY-method
#' @export
setMethod("[", c("AbstractTopDownSet", "ANY", "ANY"),
          function(x, i, j, ..., drop=FALSE) {
    d0 <- dim(x)
    ld0 <- .logdim(x)
    dn <- dimnames(x)

    if (missing(i)) {
        i <- seq_len(d0[1L])
    }

    if (is.character(i)) {
        sel <- dn[[1L]] %in% i
        fragtype <- fragmentType(x)
        if (!is.null(fragtype)) {
            sel <- sel | as.character(fragtype) %in% i
        }
        ii <- .subset(sel, d0[1L], dn[[1L]])
    } else {
        ii <- .subset(i, d0[1L], dn[[1L]])
    }

    if (is.unsorted(ii)) {
        warning("It is not possible to change the row order.")
        ii <- sort(ii)
    }

    if (missing(j)) {
        j <- seq_len(d0[2L])
    }
    jj <- .subset(j, d0[2L], dn[[2L]])

    if (drop) {
        warning("'drop' is ignored.")
    }

    x@assay <- x@assay[ii, jj, drop=FALSE]
    x@colData <- .droplevels(x@colData[jj, ])
    x@rowViews <- x@rowViews[ii, ]

    if (!is.null(x@rowViews@elementMetadata)) {
        x@rowViews@elementMetadata <- .droplevels(x@rowViews@elementMetadata)
    }
    isFasta <- grepl(.topDownFileExtRx("fasta"), x@files)
    x@files <- x@files[
        .subsetFiles(basename(x@files), unique(x@colData$File)) | isFasta
    ]

    ld1 <- .logdim(x)

    if (validObject(x)) {
        .atdsLogMsg(x, "Subsetted ", ld0, " to ", ld1, ".", addDim=FALSE)
    }
})

#' @describeIn AbstractTopDownSet Subset operator.
#'
#' `i` could be a `numeric` or `logical` vector and
#' subsetting is done on the condition/run (column) level.
#'
## @param x `AbstractTopDownSet`
## @param i `logical` or `character`, subsetting based on condition
## @param j currently ignored.
## @param \ldots currently ignored.
#' @aliases [[,AbstractTopDownSet,ANY,missing,-method
#' @export
setMethod("[[", c("AbstractTopDownSet", "ANY", "missing"),
          function(x, i, j, ...) {
    colData(x)[[i, ...]]
})

#' @describeIn AbstractTopDownSet Setter for a column in the `colData` slot.
#'
#' The `[[<-` operator is used to add/replace
#' a single column of the `colData` `DataFrame`.
#
## @param x `AbstractTopDownSet`
## @param i `logical` or `character`, subsetting based on condition
## @param j currently ignored.
## @param \ldots currently ignored.
#' @param value replacment value.
#' @aliases [[<-,AbstractTopDownSet,ANY,missing,-method
#' @export
setReplaceMethod("[[", c("AbstractTopDownSet", "ANY", "missing"),
                 function(x, i, j, ..., value) {
    colData(x)[[i, ...]] <- value
    if (validObject(x)) {
        x
    }
})

#' @param x `AbstractTopDownSet`
#' @export
#' @noRd
.DollarNames.AbstractTopDownSet <- function(x, pattern="") {
    grep(pattern, names(colData(x)), value=TRUE)
}

#' @describeIn AbstractTopDownSet Accessor for columns in the `colData` slot.
#'
#' The `$` simplifies the accession of a single column
#' of the `colData`.
#' It is identical to the `[[` operator.
#'
## @param x `AbstractTopDownSet`
#' @param name `character` name of an (non)existing column in `colData`.
## @return `AbstractTopDownSet`
#' @aliases $,AbstractTopDownSet-method
#' @export
setMethod("$", "AbstractTopDownSet", function(x, name) {
    colData(x)[[name]]
})

#' @describeIn AbstractTopDownSet Setter for a column in the `colData` slot.
#'
#' The `$<-` operator is used to add/replace a single column
#' of the `colData` `DataFrame`.
#' It is identical to the `[[<-` operator.
#'
## @param x `AbstractTopDownSet`
## @return `AbstractTopDownSet`
#' @aliases $<-,AbstractTopDownSet-method
#' @export
setReplaceMethod("$", "AbstractTopDownSet", function(x, name, value) {
    colData(x)[[name]] <- value
    x
})

#' @describeIn AbstractTopDownSet Test if two objects are equal.
#'
#' @param target, current `AbstractTopDownSet`
#' @return Either 'TRUE' or a the return value of `all.equal.default`.
#' @noRd
#' @export
all.equal.AbstractTopDownSet <- function(target, current, ..., check.date=FALSE) {
    if (!check.date) {
        target@processing <- gsub("^\\[[^]]+\\] *", "", target@processing)
        current@processing <- gsub("^\\[[^]]+\\] *", "", current@processing)
    }
    all.equal.default(target, current, ...)
}

#' @describeIn AbstractTopDownSet Accessor for the `assay` slot.
#'
#' Returns a [Matrix::dgCMatrix-class] that stores the
#' intensity/coverage information of [AbstractTopDownSet-class]
#' object.
#'
## @param object `AbstractTopDownSet`
## @return `dgCMatrix`
#' @aliases assayData,AbstractTopDownSet-method
#' @export
setMethod("assayData", "AbstractTopDownSet", function(object) {
    object@assay
})

#' @describeIn AbstractTopDownSet Accessor for the `colData` slot.
#'
#' Returns a [S4Vectors::DataFrame-class] that stores
#' metadata for the conditons/runs (columns) of the
#' [AbstractTopDownSet-class] object.
#'
## @param object `AbstractTopDownSet`
## @return `DataFrame`
#' @aliases colData colData,AbstractTopDownSet-method
#' @export
setMethod("colData", "AbstractTopDownSet", function(object) {
    object@colData
})

#' @describeIn AbstractTopDownSet Setter for the `colData` slot.
#'
#' Replaces metadata for the conditons/runs (columns) of the
#' [AbstractTopDownSet-class] object.
#'
## @param object `AbstractTopDownSet`
## @return `AbstractTopDownSet`
#' @aliases colData<- colData<-,AbstractTopDownSet-method
#' @export
setReplaceMethod("colData", "AbstractTopDownSet", function(object, ..., value) {
    object@colData <- value
    if (validObject(object)) {
        object
    }
})

#' @describeIn AbstractTopDownSet Combine `AbstractTopDownSet` objects.
#'
#' `combine` allows to combine two or more `AbstractTopDownSet` objects.
#' Please note that it uses the default
#' `sampleColumns` to define technical replicates (see [readTopDownFiles()]).and
#' the default `by` argument to group ion injection times for the calculation of
#' the median time (see [updateMedianInjectionTime()]). Both could be modified
#' after `combine` by calling [updateConditionNames()] (with modified
#' `sampleColumns` argument) and [updateMedianInjectionTime()] (with modified
#' `by` argument).
#'
## @param x `AbstractTopDownSet`
#' @param y `AbstractTopDownSet`
## @param \ldots
#' @aliases combine combine,AbstractTopDownSet,AbstractTopDownSet-method
#' @export
setMethod("combine",
          signature(x="AbstractTopDownSet", y="AbstractTopDownSet"),
          function(x, y) {
    if (class(x) != class(y)) {
        stop(paste0("Objects must be the same class, but are ",
                    class(x), ", ", class(y), "."))
    }
    ldx0 <- .logdim(x)
    ldy0 <- .logdim(y)
    x@rowViews <- combine(x@rowViews, y@rowViews)
    x@colData <- .colsToRle(.colsToLogical(.rbind(x@colData, y@colData)))
    x@assay <- .cbind(x@assay, y@assay)[names(x@rowViews),]
    x@files <- unique(x@files, y@files)
    x@processing <- c(x@processing, y@processing)
    x <- updateConditionNames(x)
    x <- updateMedianInjectionTime(x)

    if (validObject(x)) {
        x <- .atdsLogMsg(
            x, "Combined ", ldx0, " and ", ldy0, " into a ", .logdim(x), " ",
            class(x), " object.", addDim=FALSE
        )
    }
})

#' @describeIn AbstractTopDownSet Accessor for the `colData` slot.
#'
#' An alias for `colData`.
#'
## @param object `AbstractTopDownSet`
## @return `DataFrame`
#' @aliases conditionData conditionData,AbstractTopDownSet-method
#' @export
setMethod("conditionData", "AbstractTopDownSet", function(object, ...) {
    colData(object)
})

#' @describeIn AbstractTopDownSet Setter for the `colData` slot.
#'
#' An alias for `colData<-`.
#'
## @param object `AbstractTopDownSet`
## @return `AbstractTopDownSet`
#' @aliases conditionData<- conditionData<-,AbstractTopDownSet-method
#' @export
setReplaceMethod("conditionData", "AbstractTopDownSet",
                 function(object, ..., value) {
    colData(object) <- value
    if (validObject(object)) {
        object
    }
})

#' @describeIn AbstractTopDownSet Accessor for condition names.
#'
#' Returns a `character` with names for the conditions/runs (columns).
#'
## @param object `AbstractTopDownSet`
## @return `character`
#' @aliases conditionNames conditionNames,AbstractTopDownSet-method
#' @export
setMethod("conditionNames", "AbstractTopDownSet", function(object) {
    dimnames(object)[[2L]]
})

#' @describeIn AbstractTopDownSet Accessor for dimensions.
#'
#' Returns a `numeric` with number of fragments/bonds (rows) and
#' conditions/runs (columns).
#'
## @param object `AbstractTopDownSet`
## @return `numeric`
#' @aliases dim,AbstractTopDownSet-method
#' @export
setMethod("dim", "AbstractTopDownSet", function(x) {
    dim(x@assay)
})

#' @describeIn AbstractTopDownSet Accessor for dimension names.
#'
#' Returns a `list` with names for the fragments/bonds (rows) and for the
#' conditions/runs (columns).
#'
## @param object `AbstractTopDownSet`
## @return `list`
#' @aliases dimnames,AbstractTopDownSet-method
#' @export
setMethod("dimnames", "AbstractTopDownSet", function(x) {
    list(names(x@rowViews), row.names(x@colData))
})

#' @describeIn AbstractTopDownSet Remove empty conditions/runs.
#'
#' Removes conditions/runs (columns) without any intensity/coverage
#' information from the [AbstractTopDownSet-class] object.
#' It returns a modified [AbstractTopDownSet-class] object.
#'
## @param object `AbstractTopDownSet`
## @return `AbstractTopDownSet`
#' @aliases removeEmptyConditions
#' removeEmptyConditions,AbstractTopDownSet-method
#' @export
setMethod("removeEmptyConditions", "AbstractTopDownSet",
          function(object) {
    i <- Matrix::colSums(object@assay) != 0L
    object <- object[, i]
    .atdsLogMsg(object, sum(!i), " empty conditions removed")
})

#' @describeIn AbstractTopDownSet Accessor for the `rowViews` slot.
#'
#' Depending on the implementation it returns an
#' [FragmentViews-class] object for
#' [TopDownSet-class] objects
#' or an [Biostrings::XStringViews-class] object for
#' [NCBSet-class] objects.
#'
## @param object `AbstractTopDownSet`
## @return `XStringViews`
#' @aliases rowViews rowViews,AbstractTopDownSet-method
#' @export
setMethod("rowViews", "AbstractTopDownSet", function(object, ...) {
    object@rowViews
})


#' @rdname AbstractTopDownSet-class
#' @aliases show,AbstractTopDownSet-method
#' @export
setMethod("show", "AbstractTopDownSet", function(object) {
    cat(sprintf("%s object (%.2f Mb)\n",
                class(object), object.size(object) / 1024L^2L))

    if (length(object@rowViews)) {
        cat("- - - Protein data - - -\n")
        prefix <- sprintf(
            "Amino acid sequence (%d):", nchar(object@rowViews@subject)
        )
        cat(prefix,
            .snippet(
                as.character(object@rowViews@subject),
                getOption("width") - nchar(prefix)
            ), "\n"
        )
        if (length(metadata(object@rowViews)$mass)) {
            cat0("Mass : ", metadata(object@rowViews)$mass, "\n")
        }
        if (length(metadata(object@rowViews)$modifications)) {
            mod <- metadata(object@rowViews)$modifications
            cat0("Modifications (", length(mod), "): ",
                paste0(.hft(mod, n=3), collapse=", "), "\n")
        }
    }

    invisible(NULL)
})

#' @describeIn AbstractTopDownSet Summary statistics.
#'
#' Returns a `matrix` with some statistics: number of fragments,
#' total/min/first quartile/median/mean/third quartile/maximum of intensity
#' values.
#'
## @param object `AbstractTopDownSet`
#' @param what `character`,
#' specifies whether `"rows"` or `"columns"` should be summarized.
#' @aliases summary,AbstractTopDownSet-method
#' @export
setMethod("summary", "AbstractTopDownSet",
          function(object, what=c("rows", "columns"), ...) {
    .summary(object@assay, what=what)
})

#' @describeIn AbstractTopDownSet Update condition names.
#'
#' Updates condition names based on `sampleColumns` from
#' `conditionData`/`colData`. Columns with just identical entries are ignored.
#' This method will create/update the `colData(object)$Sample` column that
#' identifies technical replicates and could be used in other methods.
#'
## @param object `AbstractTopDownSet`
#' @param sampleColumns `character`,
#' column names of the [colData()]
#' used to define a sample (technical replicate). This is used to add the
#' `Sample` column (used for easier aggregation, etc.).
#' @param verbose `logical`, verbose output?
#' @aliases updateConditionNames updateConditionNames,AbstractTopDownSet-method
#' @export
setMethod("updateConditionNames", "AbstractTopDownSet",
          function(object, sampleColumns=c("Mz", "AgcTarget",
                                           "EtdReagentTarget",
                                           "EtdActivation",
                                           "CidActivation",
                                           "HcdActivation",
                                           "UvpdActivation"),
                   verbose=interactive()) {

    isColPresent <- sampleColumns %in% colnames(object@colData)

    .msg(
        verbose & any(!isColPresent),
        paste0(sampleColumns[!isColPresent], collapse=", "),
        " is/are not present and ignored."
    )

    if (all(!isColPresent)) {
        stop("'sampleColumns' must contain names from 'colnames(colData(x))'")
    }

    sampleColumns <- sampleColumns[isColPresent]

    o <- .orderByColumns(object@colData, cols=sampleColumns)

    resorted <- is.unsorted(o)
    .msg(verbose & resorted, "Order of conditions changed.")

    object@colData <- object@colData[o, ]
    object@colData$Sample <- .groupId(object@colData, cols=sampleColumns)
    object@colData <- .colsToRle(object@colData)
    object@assay <- object@assay[, o]
    rn <- rownames(object@colData)
    colnames(object@assay) <-
        rownames(object@colData) <-
            .makeRowNames(object@colData[, sampleColumns, drop=FALSE])

    if (is.null(rn) || any(rn != rownames(object@colData))) {
        object <- .atdsLogMsg(
            object,
            "Condition names updated based on: ",
            paste0(sampleColumns, collapse=", "), ".",
            if (resorted) { " Order of conditions changed." },
            " ", length(unique(object@colData$Sample)), " conditions.",
            addDim=FALSE
        )
    }

    if (validObject(object)) {
        object
    }
})

#' @describeIn AbstractTopDownSet Update median ion injection times.
#'
#' Recalculates median ion injection times by a user given grouping variable
#' (default: Mz, AgcTarget). This is useful if you acquire new data and the ion
#' injection time differs across the runs. Use the `by` argument to provide a
#' `list`/`data.frame` of grouping variables, e.g.
#' `by=colData(object)[, c("Mz", "AgcTarget", "File")]`.
#'
## @param object `TopDownSet`
#' @param by `list`, grouping information.
## @return `AbstractTopDownSet`
#' @aliases updateMedianInjectionTime
#' updateMedianInjectionTime,TopDownSet-method
#' @export
setMethod("updateMedianInjectionTime", "AbstractTopDownSet",
          function(object, by=list(Mz=object$Mz, AgcTarget=object$AgcTarget)) {
    object@colData$MedianIonInjectionTimeMs <- tryCatch(
        ave(
            object@colData$IonInjectionTimeMs,
            .groupByLabels(by),
            FUN=function(x)median(x, na.rm=TRUE)
        ),
        warning=function(w) {
            stop("converted from warning: ", conditionMessage(w))
        }
    )
    object@colData$MedianIonInjectionTimeMs <- .colsToRle(
        object@colData[, "MedianIonInjectionTimeMs", drop=FALSE]
    )$MedianIonInjectionTimeMs
    msg <- "Recalculate median injection time"
    if (length(names(by))) {
        msg <- paste0(msg, " based on: ", paste0(names(by), collapse=", "))
    }
    .atdsLogMsg(object, msg, ".", addDim=FALSE)
})

#' @rdname FragmentViews-class
#' @param object,x,y FragmentViews
#' @aliases combine,FragmentViews-method
#' @export
setMethod("combine", signature(x="FragmentViews", y="FragmentViews"),
          function(x, y) {
    if (!identical(x@subject, y@subject)) {
        stop("'subject' must be identical")
    }
    if (!identical(x@metadata$mass, y@metadata$mass)) {
        stop("'metadata(...)$mass' must be identical")
    }
    if (!identical(x@metadata$modifications, y@metadata$modifications)) {
        stop("'metadata(...)$modifications' must be identical")
    }
    un <- union(names(x), names(y))
    xn <- intersect(names(x), un)
    yn <- setdiff(un, xn)
    x@elementMetadata <- rbind(
        elementMetadata(x[xn], use.names=FALSE),
        elementMetadata(y[yn], use.names=FALSE)
    )
    if (!is.null(x@elementMetadata$type) &&
        is.factor(x@elementMetadata$type)) {
        x@elementMetadata$type <- factor(
            x@elementMetadata$type,
            levels=sort(levels(x@elementMetadata$type))
        )
    }
    x@ranges <- c(x@ranges[xn], y@ranges[yn])
    x@metadata <- modifyList(metadata(x), metadata(y))
    x <- x[order(elementMetadata(x)$mass)]
    if (validObject(x)) {
        x
    }
})

#' @rdname FragmentViews-class
## @param object FragmentViews
#' @param \ldots arguments passed to internal/other methods.
#' @aliases mz,FragmentViews-method
#' @export
setMethod("mz", "FragmentViews", function(object, ...) {
    elementMetadata(object)$mass
})

#' @rdname FragmentViews-class
## @param object FragmentViews
#' @aliases show,FragmentViews-method
#' @export
setMethod("show", "FragmentViews", function(object) {
    cat0(class(object), " on a ",
        length(subject(object)), "-letter sequence:\n")
    cat0("  ",
        .snippet(
            as.character(subject(object)),
            getOption("width") - 2L
        ), "\n"
    )

    if (length(metadata(object)$mass)) {
        cat0("Mass:\n")
        cat0(paste0("  ", metadata(object)$mass, "\n"))
    }

    if (length(metadata(object)$modifications)) {
        cat0("Modifications:\n")
        cat0(paste0("  ", metadata(object)$modifications, "\n"))
    }

    cat0("Views:\n")

    entries <- list(
        ## rownames
        c("", .hft(paste0("[", seq_len(length(object)), "]"), n=5L)),
        ## ranges
        start=c("start", .hft(start(object), n=5L)),
        end=c("end", .hft(end(object), n=5L)),
        width=c("width", .hft(width(object), n=5L)),
        ## metadata
        mass=c("mass", .hft(sprintf("%.2f", elementMetadata(object)$mass),
                            n=5L)),
        name=c("name", .hft(names(object), n=5L)),
        type=c("type", .hft(as.character(elementMetadata(object)$type), n=5L)),
        z=c("z", as.character(.hft(elementMetadata(object)$z, n=5L)))
    )

    cw <- .vapply1d(entries, function(e)max(nchar(e)))

    ## views
    mw <- sum(cw + 1L)
    ## n == 5 + 1 (to compensate for the fill ("...") below
    vw <-
        as(object[.hft(seq_len(length(object)), fill=NULL, n=6L)], "character")
    vw <- c("",
        .hft(.snippet(paste0("[", vw, "]"), getOption("width") - mw), n=5L))

    ## format
    just <- c(rep("right", 5), "left", "left", "right", "left")
    entries <- mapply(format, x=c(entries, list(vw)), justify=just)

    ## output
    out <- paste(apply(entries, 1L, paste, collapse=" "), collapse="\n")
    cat0(out, "\n")

    invisible(NULL)
})

#' @rdname FragmentViews-class
#' @name coerce,FragmentViews,data.frame-method
#' @section Coercion:
#'
#' `as(object, "data.frame")`: Coerce an
#' [FragmentViews-class] object into a `data.frame`.
#' @examples
#' as(fv, "data.frame")
setAs("FragmentViews", "data.frame", function(from) {
    data.frame(
        fragment=as(from, "character"),
        start=start(from),
        end=end(from),
        width=width(from),
        name=names(from),
        type=elementMetadata(from)$type,
        mass=elementMetadata(from)$mass,
        z=elementMetadata(from)$z,
        row.names=names(from)
    )
})

#' TopDownSet Example Data
#'
#' An example data set for `topdownr`. It is just a subset of the myoglobin
#' dataset available in
#' [topdownrdata::topdownrdata-package].
#'
#' It was created as
#' follows:
#'
#' ```
#' tds <- readTopDownFiles(
#'    topdownrdata::topDownDataPath("myoglobin"),
#'    ## Use an artifical pattern to load just the fasta
#'    ## file and files from m/z == 1211, ETD reagent
#'    ## target 1e6 and first replicate to keep runtime
#'    ## of the example short
#'    pattern=".*fasta.gz$|1211_.*1e6_1",
#'    adducts=data.frame(mass=1.008, name="zpH", to="z"),
#'    neutralLoss=PSMatch::defaultNeutralLoss(
#'        disableWaterLoss=c("Cterm", "D", "E", "S", "T")),
#'    tolerance=25e-6)
#' ```
#'
#' @format A [TopDownSet-class]
#' with 14901 fragments (1949 rows, 351 columns).
#' @source Subset taken from the
#' [topdownrdata::topdownrdata-package]
#' package.
"tds"

#' Add adducts to the output of PSMatch::calculateFragments
#'
#' @param x `data.frame`, output of [PSMatch::calculateFragments()]
#' @param adducts `data.frame`, with 3 columns mass, name, to
#' @return `data.frame`
#' @noRd
.addAdducts <- function(x, adducts) {
    if (!nrow(adducts)) {
        return(x)
    }

    if (!all(c("mass", "name", "to") %in% colnames(adducts))) {
        stop(
            "The 'adducts' data.frame must have the columns: ",
            "'mass', 'name' and 'to'."
        )
    }

    r <- do.call(rbind, lapply(seq_len(nrow(adducts)), function(i) {
        a <- x[x$type == adducts$to[i], , drop = FALSE]
        a$mz <- a$mz + adducts$mass[i]
        a$ion <- paste0(adducts$name[i], a$pos)
        a
    }))
    x <- rbind(x, r)
    rownames(x) <- NULL
    x
}

#' Add adducts to the output of PSMatch::calculateFragments
#'
#' @param x `data.frame`, output of [PSMatch::calculateFragments()].
#' @param n `numeric(1)`, length of sequence.
#' @param modifications `data.frame`, with 4 columns mass, name, location,
#' variable.
#' @return `data.frame`
#' @noRd
.addCustomModifications <- function(x, n, modifications) {
    if (!nrow(modifications)) {
        return(x)
    }

    if (!all(c("mass", "name", "location", "variable") %in%
             colnames(modifications))) {
        stop(
            "The 'customModifications' data.frame must have the columns: ",
            "'mass', 'name', 'location' and 'variable'."
        )
    }

    if (is.character(modifications$location)) {
        modifications$location[tolower(modifications$location) == "n-term"] <-
            0L
        modifications$location[tolower(modifications$location) == "c-term"] <-
            n + 1L
        modifications$location <- as.integer(modifications$location)
    }

    for (i in seq_len(nrow(modifications))) {
        x <- .cusmod(
            x, n=n,
            id=modifications$name[i],
            deltamz=modifications$mass[i],
            location=modifications$location[i],
            variable=modifications$variable[i]
        )
    }
    x
}

#' Calculate Fragments (via PSMatch::calculateFragments)
#'
#' @param sequence `AAString`, peptide sequence
#' @param type `character`, type of fragments
#' @param modification `character`, unimod names
#' @param adducts `data.frame`, with 3 columns mass, name, to
#' @param neutralLoss `list`, neutral loss (see [PSMatch::calculateFragments()])
#' @param sequenceOrder `character`, `c("original", "random", "inverse")`
#' @param verbose `logical`, verbose output?
#' @return `FragmentViews`
#' @noRd
.calculateFragments <- function(sequence, type=c("a", "b", "c", "x", "y", "z"),
                                modifications=c(
                                    "Carbamidomethyl", "Acetyl",
                                    "Met-loss"
                                ),
                                customModifications=data.frame(),
                                adducts=data.frame(),
                                neutralLoss=defaultNeutralLoss(),
                                sequenceOrder=c(
                                    "original",
                                    "random",
                                    "inverse"
                                ),
                                verbose=interactive()) {
    modifications <- match.arg(
        modifications,
        choices=c(
        "", # allow NULL for nothing
        "Carbamidomethyl",
        "Acetyl",
        "Met-loss"
        ),
        several.ok=TRUE
    )
    sequenceOrder <- match.arg(sequenceOrder)

    ## just to be sure if an AAString is given
    csequence <- as.character(sequence)

    ## TODO: replace by unimod package
    if ("Met-loss" %in% modifications) {
        csequence <- .unimod765(csequence)
    }

    ## has to be done after Met-loss but before any other modification
    csequence <- .reorderSequence(csequence, method=sequenceOrder)

    d <- calculateFragments(
        csequence,
        type=type,
        fixed_modifications=NULL,
        neutralLoss=neutralLoss,
        verbose=FALSE
    )

    ## add protein sequence to data.frame to calculate modifications
    d <- rbind(
        list(
            mz=.calculateProteinMass(csequence),
            ion="none", type="protein", pos=0, z=0,
            seq=csequence
        ),
        d[c("mz", "ion", "type", "pos", "z", "seq")]
    )

    ## TODO: replace by unimod package
    if ("Acetyl" %in% modifications) {
        d <- .unimod1(d, csequence)
    }
    ## TODO: replace by unimod package
    if ("Carbamidomethyl" %in% modifications) {
        d <- .unimod4(d)
    }
    if (all(!nchar(modifications))) {
        modifications <- NULL
    }
    ## TODO: replace by unimod package
    d <- .addCustomModifications(d, nchar(csequence), customModifications)
    d <- .addAdducts(d, adducts)

    ## remove protein sequence from data.frame (just added to calculate
    ## modifications)
    mass <- d$mz[1L]
    d <- d[-1L, ]

    n <- nchar(csequence)
    FragmentViews(
        csequence, mass=d$mz, type=d$type, z=Rle(d$z), names=d$ion,
        start=ifelse(
            startsWith(csequence, d$seq),
            1L,
            ifelse(endsWith(csequence, d$seq), n-d$pos + 1L, d$pos)
        ),
        width=nchar(d$seq),
        metadata=list(modifications=modifications, mass=mass)
    )
}

#' Calculate protein mass
#'
#' TODO: replace by unimod package
#'
#' @param x `character`, sequence
#' @return `numeric`
#' @noRd
.calculateProteinMass <- function(x) {
    aa <- getAminoAcids()[, c("AA", "ResidueMass")]
    aamass <- setNames(aa$ResidueMass, aa$AA)
    x <- strsplit(x, "")[[1L]]
    sum(aamass[x])
}

#' Match fragments and measured mz values.
#'
#' Similar to MALDIquant:::.match.closest but we need to reimplement it here,
#' because @pavel_shliaha asks for handling duplicated matches differently: see
#' https://codeberg.org/sgibb/topdownr/issues/72
#'
#' @param mz `double`, measured mz.
#' @param fmass `double`, fragment mass
#' @param tolerance `double`, allowed tolerance
#' @param redundantIonMatch `character`, a mz could be matched to two or more
#' fragments, it would be removed or matched to the closest fragment.
#' @param redundantFragmentMatch `character`, multiple mz could be matched to
#' the same fragment, these matches would be removed or the closest mz is
#' chosen.
#' @param relative `logical`, relative tolerance?
#' @return `integer`
#' @noRd
.matchFragments <- function(mz, fmass, tolerance=5e-6,
                            redundantIonMatch=c("remove", "closest"),
                            redundantFragmentMatch=c("remove", "closest",
                                                     "ignore"),
                            relative=TRUE) {
    if (!length(mz)) {
        return(integer())
    }
    if (!length(fmass)) {
        return(rep.int(NA_integer_, length(mz)))
    }

    lIdx <- findInterval(mz, fmass, rightmost.closed=FALSE, all.inside=TRUE)
    rIdx <- lIdx + 1L
    lIdx[lIdx == 0L] <- 1L
    lDiff <- abs(fmass[lIdx] - mz)
    rDiff <- abs(fmass[rIdx] - mz)
    tolerance <- rep_len(tolerance, length(fmass))
    if (relative) {
        tolerance <- tolerance * fmass
    }
    lDiff[lDiff > tolerance[lIdx]] <- Inf
    rDiff[rDiff > tolerance[rIdx]] <- Inf

    d <- which(lDiff >= rDiff)
    lIdx[d] <- rIdx[d]

    ## no match at all
    lIdx[is.infinite(lDiff) & is.infinite(rDiff)] <- NA_integer_

    ## multiple mz to one fragment?
    if (anyDuplicated(lIdx)) {
        redundantFragmentMatch <- match.arg(redundantFragmentMatch)
        if (redundantFragmentMatch == "remove") {
            lIdx[duplicated(lIdx) | duplicated(lIdx, fromLast=TRUE)] <- NA_integer_
        } else if (redundantFragmentMatch == "closest") {
            o <- order(abs(mz - fmass[lIdx]))
            m <- lIdx[o]
            m[duplicated(m)] <- NA_integer_
            lIdx[o] <- m
        }
        ## ignore
    }
    ## multiple fragments to one mz (closest is default because of
    ## which(lDiff >= rDiff); "ignore" isn't possible here
    redundantIonMatch <- match.arg(redundantIonMatch)
    if (redundantIonMatch == "remove") {
        lIdx[is.finite(lDiff) & is.finite(rDiff)] <- NA_integer_
    }

    as.integer(lIdx)
}

#' Reorder protein sequence.
#'
#' @param x `character`, sequence
#' @param method `character`, reorder method
#' @return `character`
#' @noRd
.reorderSequence <- function(x, method=c("original", "random", "inverse")) {
    if (!is.character(x))
        stop("'x' has to be a 'character'.")
    method <- match.arg(method)

    if (method != "original") {
        x <- strsplit(x, "", fixed=TRUE)[[1L]]

        if (method == "random") {
            x <- sample(x)
        } else if (method == "inverse") {
            x <- rev(x)
        }
        x <- paste0(x, collapse = "")
    }
    x
}

#' Apply unimod modification 1: Acetyl
#'
#' Acetylation
#'
#' TODO: replace by unimod package
#'
#' @param x `data.frame`, generated by [PSMatch::calculateFragments()]
#' @param s `character`, sequence
#' @return modified `data.frame`
#' @noRd
.unimod1 <- function(x, s) {
    i <- startsWith(s, x$seq)
    x$mz[i] <- x$mz[i] + 42.010565
    x
}

#' Apply unimod modification 4:  Carbamidomethyl
#'
#' Carboxyamidomethylation
#'
#' TODO: replace by unimod package
#'
#' @param x `data.frame`, generated by [PSMatch::calculateFragments()]
#' @return modified `data.frame`
#' @noRd
.unimod4 <- function(x) {
    iCU <- grep("C|U", x$seq)
    x$mz[iCU] <- x$mz[iCU] + 57.021464
    x
}

#' Apply unimod modification 765: Met-loss
#'
#' N-terminal methionine removed if followed by A, C, G, P, S, T, or V
#'
#' TODO: replace by unimod package
#'
#' @param x `character`/`AAString`, sequence
#' @return `character`/`AAString` without ^M
#' @noRd
.unimod765 <- function(x) {
    gsub("^M([ACGPSTV])", "\\1", x)
}

#' Apply custom modification
#'
#' TODO: replace by unimod package
#'
#' @param fragments `data.frame`, generated by [PSMatch::calculateFragments()].
#' @param n `integer(1)`, length of peptide sequence.
#' @param id `character(1)`.
#' @param deltamz `numeric(1)`.
#' @param location `integer(1)`, 0 for "N-term", n+1 for "C-term" or index.
#' @param variable `logical(1)`, if TRUE the unmodified and modified fragments
#' are returned.
#' @return modified `data.frame`
#' @noRd
.cusmod <- function(x, n, id, deltamz, location, variable) {
    nterm <- grepl("^a|^b|^c", x$type) & location <= x$pos
    cterm <- grepl("^x|^y|^z", x$type) & location > n - x$pos

    i <- nterm | cterm

    m <- x
    m$mz[i] <- m$mz[i] + deltamz
    m$ion[i] <- paste0(m$ion[i], "_m", id)
    m$type[i] <- paste0(m$type[i], "_m", id)

    if (variable)
        rbind(x, m[i, ], make.row.names = FALSE)
    else
        m
}

context("fragments")

test_that(".addAdducts", {
    d <- data.frame(mz=1:6, ion=c("c1", "c2", "c3", "x1", "x2", "y1"),
                    type=rep(c("c", "x", "y"), 3:1), z=1,
                    pos=c(1:3, 1:2, 1),
                    seq=c("A", "AC", "ACE", "E", "CE", "E"),
                    stringsAsFactors=FALSE)
    r <- data.frame(mz=c(2:4, 4), ion=c("cpH1", "cpH2", "cpH3", "ym2H1"),
                    type=c(rep("c", 3), "y"), z=1,
                    pos=c(1:3, 1),
                    seq=c("A", "AC", "ACE", "E"),
                    stringsAsFactors=FALSE)
    a <- data.frame(mass=c(1, -2), name=c("cpH", "ym2H"), to=c("c", "y"))
    expect_error(.addAdducts(d, d),
                 "data.frame must have the columns: 'mass', 'name' and 'to'")
    expect_equal(.addAdducts(d, data.frame()), d)
    expect_equal(.addAdducts(d, a), rbind(d, r))
})

test_that(".addCustomModifications", {
    d <- data.frame(mz=1:6, ion=c("c1", "c2", "c3", "x1", "x2", "y1"),
                    type=rep(c("c", "x", "y"), 3:1), z=1,
                    pos=c(1:3, 1:2, 1),
                    seq=c("A", "AC", "ACE", "E", "CE", "E"),
                    stringsAsFactors=FALSE)
    m <- data.frame(mass=42, name="Acetyl", location="N-term", variable=FALSE)
    r <- d
    r$mz[1:3] <- r$mz[1:3] + 42
    r$type[1:3] <- paste0(r$type[1:3], "_mAcetyl")
    r$ion[1:3] <- paste0(r$ion[1:3], "_mAcetyl")
    expect_error(.addCustomModifications(d, 3, d),
                 "'mass', 'name', 'location' and 'variable'")
    expect_equal(.addCustomModifications(d, 3, data.frame()), d)
    expect_equal(.addCustomModifications(d, 3, m), r)
    m$variable <- TRUE
    expect_equal(.addCustomModifications(d, 3, m), rbind(d, r[1:3,]))
    m <- rbind(m, data.frame(mass=2, name="Foo", location=2, variable=FALSE))
    r <- rbind(d, r[1:3,])
    i <- c(2, 3, 5, 8, 9)
    r$mz[i] <- r$mz[i] + 2
    r$type[i] <- paste0(r$type[i], "_mFoo")
    r$ion[i] <- paste0(r$ion[i], "_mFoo")
    expect_equal(.addCustomModifications(d, 3, m), r)
    r$type[7:9] <- c("c_mAcetyl", "c_mFoo_mAcetyl", "c_mFoo_mAcetyl")
    r$ion[7:9] <- c("c1_mAcetyl", "c2_mFoo_mAcetyl", "c3_mFoo_mAcetyl")
    expect_equal(.addCustomModifications(d, 3, m[2:1,]), r)
})

test_that(".matchFragments", {
    expect_equal(.matchFragments(mz=integer(), fmass=1:3), integer())
    expect_equal(.matchFragments(mz=1:3, fmass=integer()),
                 rep(NA_integer_, 3))
    expect_equal(.matchFragments(c(1, 99, 101), fmass=c(1.1, 100),
                                            redundantFragmentMatch="closest",
                                            tolerance=0.2),
                 as.integer(c(1, 2, NA)))
    expect_equal(.matchFragments(c(1, 98, 101), fmass=c(1.1, 100),
                                            redundantFragmentMatch="closest",
                                            tolerance=0.2),
                 as.integer(c(1, NA, 2)))
    expect_equal(.matchFragments(1:2, 1.5, 1,
                                            redundantFragmentMatch="ignore",
                                            redundantIonMatch="closest",
                                            relative=FALSE),
                 c(1L, 1L))
    expect_equal(.matchFragments(1:2, 1.5, 0.4,
                                            redundantFragmentMatch="closest",
                                            redundantIonMatch="closest",
                                            relative=TRUE),
                 c(1L, NA_integer_))
    expect_equal(.matchFragments(1:2, 1.5, 1,
                                            redundantFragmentMatch="remove",
                                            relative=FALSE),
                 c(NA_integer_, NA_integer_))
    expect_equal(.matchFragments(1:2, 1.5, 1,
                                            redundantFragmentMatch="closest",
                                            relative=FALSE),
                 c(1L, NA_integer_))
    expect_equal(.matchFragments(1.5, 1:2, 1,
                                            redundantIonMatch="remove",
                                            relative=FALSE),
                 NA_integer_)
    expect_equal(.matchFragments(1.5, 1:2, 1,
                                            redundantIonMatch="closest",
                                            relative=FALSE),
                 2L)

    mz <- c(3.4, 3.5, 3.6, 3.7, 8.8, 9.1, 10.9)
    fmass <- 1:10
    tolerance=0.7
    expect_equal(.matchFragments(mz, fmass, tolerance,
                                            redundantIonMatch="remove",
                                            redundantFragmentMatch="remove"),
                 .matchFragments(mz, fmass, tolerance))
    expect_equal(.matchFragments(mz, fmass, tolerance,
                                            relative=FALSE),
                 rep(NA_integer_, 7))
    expect_equal(.matchFragments(mz, fmass, tolerance,
                                            redundantFragmentMatch="closest",
                                            relative=FALSE),
                 as.integer(c(NA, NA, NA, 4, NA, 9, NA)))
    expect_equal(.matchFragments(mz, fmass, tolerance,
                                            redundantIonMatch="closest",
                                            relative=FALSE),
                 as.integer(c(3, rep(NA, 6))))
    expect_equal(.matchFragments(mz, fmass, tolerance,
                                            redundantFragmentMatch="ignore",
                                            redundantIonMatch="closest",
                                            relative=FALSE),
                 as.integer(c(3, 4, 4, 4, 9, 9, NA)))
    expect_equal(.matchFragments(mz, fmass, tolerance,
                                            redundantFragmentMatch="closest",
                                            redundantIonMatch="closest",
                                            relative=FALSE),
                 as.integer(c(3, NA, NA, 4, NA, 9, NA)))
})

test_that(".reorderSequence", {
    expect_error(.reorderSequence(1:10))
    expect_equal(.reorderSequence("ABCDE"), "ABCDE")
    expect_equal(.reorderSequence("ABCDE", "original"), "ABCDE")
    expect_equal(.reorderSequence("ABCDE", "inverse"), "EDCBA")
    set.seed(2017)
    expect_equal(.reorderSequence("ABCDE", "random"), "DABCE")
})

test_that(".unimod1", {
    d <- data.frame(mz=200:202, pos=1, seq=c("A", "AC", "ACE"),
                    ion=c("c1", "c2", "c3"), stringsAsFactors=FALSE)
    r <- data.frame(mz=200:202 + 42.010565, pos=1, seq=c("A", "AC", "ACE"),
                    ion=c("c1", "c2", "c3"), stringsAsFactors=FALSE)
    expect_equal(.unimod1(d, "ACE"), r)
})

test_that(".unimod4", {
    d <- data.frame(mz=1:5, seq=c("C", "AC", "U", "AE", "AB"),
                    stringsAsFactors=FALSE)
    r <- data.frame(mz=c(57.021464 + 1:3, 4:5), seq=d$seq,
                    stringsAsFactors=FALSE)
    expect_equal(.unimod4(d), r)
})

test_that(".unimod765", {
    expect_equal(.unimod765(c("MACE", "MWE", "EAC")),
                 c("ACE", "MWE", "EAC"))
})

test_that(".cusmod", {
    d <- data.frame(mz=1:6, ion=c("c1", "c2", "c3", "x1", "x2", "y1"),
                    type=rep(c("c", "x", "y"), 3:1), z=1,
                    pos=c(1:3, 1:2, 1),
                    seq=c("A", "AC", "ACE", "E", "CE", "E"),
                    stringsAsFactors=FALSE)
    r <- d
    r$mz[4:6] <- d$mz[4:6] + 0.5
    r$type[4:6] <- paste(d$type[4:6], "mN", sep = "_")
    r$ion[4:6] <- paste(d$ion[4:6], "mN", sep = "_")
    expect_equal(
        .cusmod(d, 3, id = "N", deltamz = 0.5, location = 4, variable = FALSE),
        r
    )

    rvar <- d
    rvar <- rbind(d, r[4:6,], make.row.names = FALSE)
    expect_equal(
        .cusmod(d, 3, id = "N", deltamz = 0.5, location = 4, variable = TRUE),
        rvar
    )
})

#' Find xml children names and tags
#'
#' @param xsd `xml2::xml_document`
#' @param name `character`, element name
#'
#' @return `matrix` of valid tag names and their types
#' @noRd
.xmlChildrenNameType <- function(xsd, name) {
    requireNamespace("xml2")
    nds <- xml2::xml_find_all(
        xsd,
        sprintf(".//xs:element[@name = '%s']//xs:element[@name|@ref]", name)
    )
    attrs <- lapply(xml2::xml_attrs(nds), function(a) {
        name <- if (is.na(a["name"])) a["ref"] else a["name"]
        type <- a["type"]
        if (is.na(type) && name == "MassList") {
            type <- "MassListRecord"
        } else if (is.na(type) && name == "ScanDescription") {
            type <- "character"
        }
        c(name, type)
    })
    m <- do.call(rbind, attrs)
    colnames(m) <- c("name", "class")
    repl <- matrix(c("double$", "double",
                     "int.*$", "integer",
                     "boolean$", "logical",
                     "string$", "character"), byrow=TRUE, nrow=4L)
    repl[, 1L] <- paste0("^xs:", repl[, 1L])
    for (i in seq_len(nrow(repl))) {
        m[, "class"] <- sub(repl[i, 1L], repl[i, 2L], m[, "class"])
    }
    m
}

#' Find xml enumerations
#'
#' @param xsd `xml2::xml_document`
#' @param name `character`, element name
#'
#' @return `character` of valid enumerations
#' @noRd
.xmlEnumeration <- function(xsd, name) {
    requireNamespace("xml2")
    nds <- xml2::xml_find_all(
        xsd,
        sprintf(".//xs:simpleType[@name = '%s']//xs:enumeration", name)
    )
    xml2::xml_attr(nds, "value")
}

#' Find TMSnScan parameters
#'
#' @param xsd `xml2::xml_document`
#'
#' @return `matrix` (`character`)
#' @noRd
.xmlTmsnScanParameters <- function(xsd) {
    param <- .xmlChildrenNameType(xsd, "TMSnScan")
    isEnum <- !param[, "class"] %in%
        c("logical", "integer", "double", "character", "MassListRecord")
    param[isEnum, "class"] <- vapply(
        param[isEnum, "class"],
        function(tt)paste0(.xmlEnumeration(xsd, tt), collapse=":"),
        NA_character_
    )
    # Exclude "Ms2 parameters"
    param[!startsWith(param[, "name"], "Ms2"),]
}

#' Find valid MS1/MSn settings
#'
#' @param xsd `xml2::xml_document`
#' @return `matrix` (`character`), 3 columns: name, class, type
#' @noRd
.xmlValidMsSettings <- function(xsd) {
    settings <- rbind(
        cbind(.xmlChildrenNameType(xsd, "FullMSScan"), type="MS1"),
        cbind(.xmlTmsnScanParameters(xsd), type="TMS2"))

    for (actType in c("ETD", "CID", "HCD", "UVPD")) {
        isType <- grepl(actType, settings[, "name"])
        settings[isType, "type"] <- actType
    }
    settings
}

context("xml")

xsd <- '<?xml version="1.0" encoding="utf-8"?>
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" >
  <xs:simpleType name="Version">
    <xs:restriction base="xs:string">
      <xs:enumeration value="1"/>
      <xs:enumeration value="2"/>
    </xs:restriction>
  </xs:simpleType>
  <xs:element name="FullMSScan">
    <xs:complexType>
      <xs:all>
        <xs:element name="FirstMass" type="xs:double" minOccurs="0" maxOccurs="1" />
        <xs:element name="LastMass" type="xs:double" minOccurs="0" maxOccurs="1" />
        <xs:element name="Microscans" type="xs:int" minOccurs="0" maxOccurs="1" />
      </xs:all>
    </xs:complexType>
  </xs:element>
  <xs:element name="TMSnScan">
    <xs:complexType>
      <xs:all>
        <xs:element name="AgcTarget" type="xs:double" minOccurs="0" maxOccurs="1" />
        <xs:element name="ETDReactionTime" type="xs:double" minOccurs="0" maxOccurs="1" />
        <xs:element name="CIDCollisionEnergy" type="xs:double" minOccurs="0" maxOccurs="1"/>
        <xs:element name="CIDActivationQ" type="xs:double" minOccurs="0" maxOccurs="1"/>
        <xs:element name="Ms2CIDCollisionEnergy" type="xs:double" minOccurs="0" maxOccurs="1"/>
        <xs:element name="Ms2CIDActivationQ" type="xs:double" minOccurs="0" maxOccurs="1"/>
        <xs:element ref="MassList" minOccurs="0" maxOccurs="1"/>
        <xs:element name="ScanDescription" minOccurs="0" maxOccurs="1"/>
      </xs:all>
    </xs:complexType>
  </xs:element>
</xs:schema>'

test_that(".xmlChildrenNameType", {
    skip_if_not_installed("xml2")
    expect_equal(
        .xmlChildrenNameType(xml2::read_xml(xsd), "FullMSScan"),
        cbind(
            name=c("FirstMass", "LastMass", "Microscans"),
            class=c("double", "double", "integer")
        )
    )
})

test_that(".xmlEnumeration", {
    skip_if_not_installed("xml2")
    expect_equal(
        .xmlEnumeration(xml2::read_xml(xsd), "Version"),
        c("1", "2")
    )
})

test_that(".xmlTmsnScanParameters", {
    skip_if_not_installed("xml2")
    expect_equal(
        .xmlTmsnScanParameters(xml2::read_xml(xsd)),
        cbind(
            name=c(
                "AgcTarget", "ETDReactionTime", "CIDCollisionEnergy",
                "CIDActivationQ", "MassList", "ScanDescription"
            ),
            class=c(rep("double", 4), "MassListRecord", "character")
        )
    )
})

test_that(".xmlValidMsSettings", {
    skip_if_not_installed("xml2")
    expect_equal(
        .xmlValidMsSettings(xml2::read_xml(xsd)),
        cbind(
            name=c(
                "FirstMass", "LastMass", "Microscans", "AgcTarget",
                "ETDReactionTime", "CIDCollisionEnergy", "CIDActivationQ",
                "MassList", "ScanDescription"
            ),
            class=rep(
                c("double", "integer", "double", "MassListRecord", "character"),
                c(2, 1, 4, 1, 1)
            ),
            type=rep(c("MS1", "TMS2", "ETD", "CID", "TMS2"), c(3, 1, 1, 2, 2))
        )
    )
})

context("NCBSet")

ncb <- new("NCBSet",
           rowViews=Views(AAString("ACED"), start=1, width=1:3,
                                  names=paste0("bond", 1:3)),
           colData=DataFrame(Scan=1:5, Sample=c(1, 1, 2, 1, 2)),
           assay=sparseMatrix(i=c(1:2, 1:3, 1, 3, 2),
                              j=rep(1:5, c(2, 3, 1, 1, 1)),
                              x=c(1, 2, 1:3, 1, 2, 1)),
           files="aced.fasta",
           processing="[2017-08-19 15:00:00] Data created.")

test_that("[", {

    ncb1 <- new("NCBSet",
                rowViews=Views(AAString("ACED"), start=1, width=1,
                               names="bond1"),
                colData=DataFrame(Scan=1:5, Sample=c(1, 1, 2, 1, 2)),
                assay=sparseMatrix(i=rep(1, 3),
                                   j=1:3,
                                   x=rep(1, 3),
                                   dims=c(1, 5)),
                files="aced.fasta",
                processing=c("[2017-08-19 15:00:00] Data created.",
                             paste0("[2017-08-19 21:48:00] ",
                                    "Subsetted 8 fragments [3;5] to ",
                                    "3 fragments [1;5].")))

    ncb3 <- new("NCBSet",
                rowViews=Views(AAString("ACED"), start=1, width=1:3,
                               names=paste0("bond", 1:3)),
                colData=DataFrame(Scan=1:3, Sample=c(1, 1, 2)),
                assay=sparseMatrix(i=c(1:2, 1:3, 1),
                                   j=rep(1:3, c(2, 3, 1)),
                                   x=c(1, 2, 1:3, 1)),
                files="aced.fasta",
                processing=c("[2017-08-19 15:00:00] Data created.",
                             paste0("[2017-08-19 21:48:00] ",
                                    "Subsetted 8 fragments [3;5] to ",
                                    "6 fragments [3;3].")))

    expect_equal(ncb["bond1"], ncb1)
    expect_equal(ncb[1,], ncb1)
    expect_equal(ncb[,1:3], ncb3)
    expect_warning(ncb[3:1,], "row order")
    expect_warning(ncb[1, drop=TRUE], "'drop' is ignored")
})

test_that("[[ and $", {
    expect_equal(ncb[[1]], 1:5)
    expect_equal(ncb[["Scan"]], 1:5)
    expect_equal(ncb$Scan, 1:5)
    ncbn <- ncb
    ncbn$Scan <- 11:15
    expect_equal(ncbn$Scan, 11:15)
    ncbn[["Scan"]] <- 1:5
    expect_equal(ncbn$Scan, 1:5)
    ncbn$Scan[1:3] <- 11:13
    expect_equal(ncbn$Scan, c(11:13, 4:5))
    ncbn$Scan[1:3] <- 11:13
    expect_equal(ncbn$Scan, c(11:13, 4:5))
})

test_that("accessors", {
    expect_equal(assayData(ncb), ncb@assay)
    expect_equal(colData(ncb), ncb@colData)
    expect_equal(conditionData(ncb), colData(ncb))
    expect_equal(rowViews(ncb), ncb@rowViews)
})

test_that("accessors<-", {
    ncbn <- ncb
    colData(ncbn)[["Scan"]] <- 11:15
    expect_equal(colData(ncbn)$Scan, 11:15)
    ncbn <- ncb
    conditionData(ncbn)[["Scan"]] <- 11:15
    expect_equal(conditionData(ncbn)$Scan, 11:15)
})

test_that("bestConditions", {
    cn <- c("Index", "FragmentsAddedToCombination", "BondsAddedToCombination",
            "FragmentsInCondition", "BondsInCondition", "FragmentCoverage",
            "BondCoverage")
    expect_equal(bestConditions(ncb), matrix(c(2, 5, 4, 1, 3, 0, 4, 1, 3, 1,
                                               2/3, 5/6, 1, 1),
                                             nrow=2, dimnames=list(NULL, cn)))
    ncbn <- ncb
    ncbn@assay[1, 2] <- 0
    rownames(ncbn@colData) <- LETTERS[1:5]
    expect_equal(bestConditions(ncbn),
                 matrix(c(2:1, 5, 3, 1, 1, 2:0, 3:1, 2, 2, 1,
                          0.5, 2/3, 5/6, 2/3, 1, 1), nrow=3,
                        dimnames=list(c("B", "A", "E"), cn)))
    expect_equal(bestConditions(ncbn, n=1),
                 matrix(c(2, 3, 2, 3, 2, 0.5, 2/3),
                        nrow=1, dimnames=list("B", cn)))
    expect_equal(bestConditions(ncbn, minN=2),
                 matrix(c(2, 3, 2, 3, 2, 0.5, 2/3),
                        nrow=1, dimnames=list("B", cn)))
})

test_that("dim", {
    expect_equal(dim(ncb), c(3, 5))
})

test_that("dimnames", {
    expect_equal(dimnames(ncb), list(paste0("bond", 1:3), NULL))
})

test_that("removeEmptyConditions", {
    ncbr <- ncb
    ncbr@assay[cbind(c(1, 3), 3:4)] <- 0L
    ncbr@assay <- drop0(ncbr@assay)
    ncbrr <- ncbr[, c(1:2, 5)]
    ncbrr@processing <- c(ncbrr@processing,
                          paste0("[2017-08-01 22:25:00] ",
                                 "2 empty conditions removed; ",
                                 "6 fragments [3;3]."))
    #ncbr@assay[cbind(c(1, 3), 3:4)] <- 0L
    #ncbr@assay <- drop0(ncbr@assay)
    expect_equal(removeEmptyConditions(ncbr), ncbrr)
})

test_that("show", {
    expect_output(show(new("NCBSet")),
                  "NCBSet object \\([0-9]\\.[0-9]+ Mb\\)")
    expect_output(show(ncb),
                  paste(c("NCBSet object \\([0-9]\\.[0-9]+ Mb\\)",
                          "- - - Protein data - - -",
                          "Amino acid sequence \\(4\\): ACED ",
                          "- - - Fragment data - - -",
                          "Number of N-terminal fragments: 4",
                          "Number of C-terminal fragments: 3",
                          "Number of N- and C-terminal fragments: 1",
                          "- - - Condition data - - -",
                          "Number of conditions: 2 ",
                          "Number of scans: 5 ",
                          "Condition variables \\(2\\): Scan, Sample",
                          "- - - Assay data - - -",
                          "Size of array: 3x5 \\(53\\.33% != 0\\)",
                          "- - - Processing information - - -",
                          "\\[2017-08-19 15:00:00\\] Data created. "),
                        collapse="\n"))
})

test_that("summary", {
    dc <- data.frame(Fragments=c(2, 3, 1, 1, 1), Total=c(3, 6, 1, 2, 1),
                     Min=c(1, 1, 1, 2, 1), Q1=c(1.25, 1.5, 1, 2, 1),
                     Median=c(1.5, 2, 1, 2, 1), Mean=c(1, 2, 1/3, 2/3, 1/3),
                     Q3=c(1.75, 2.5, 1, 2, 1), Max=c(2, 3, 1, 2, 1))
    dr <- data.frame(Fragments=c(3, 3, 2), Total=c(3, 5, 5), Min=c(1, 1, 2),
                     Q1=c(1, 1.5, 2.25), Median=c(1, 2, 2.5), Mean=c(0.6, 1, 1),
                     Q3=c(1, 2, 2.75), Max=1:3)
    expect_equal(summary(ncb), dc)
    expect_equal(summary(ncb, "conditions"), dc)
    expect_equal(summary(ncb, "bonds"), dr)
})

test_that("validObject", {
    ncbn <- ncb
    ncbn@assay <- ncbn@assay[1,,drop=FALSE]
    expect_error(validObject(ncbn), "Mismatch between fragment data")
    ncbn <- ncb
    rownames(ncbn@assay) <- seq_len(nrow(ncbn@assay))
    expect_error(validObject(ncbn), "Mismatch between fragment names")
    ncbn <- ncb
    ncbn@assay <- ncbn@assay[,1,drop=FALSE]
    expect_error(validObject(ncbn), "Mismatch between condition data")
    expect_true(validObject(ncb))
    ncbn <- ncb
    rownames(ncbn@colData) <- seq_len(nrow(ncbn@colData))
    colnames(ncbn@assay) <- rev(seq_len(ncol(ncbn@assay)))
    expect_error(validObject(ncbn), "Mismatch between condition names")
    ncbn <- ncb
    ncbn@assay@x <- ncb@assay@x + 2L
    expect_error(validObject(ncbn), "invalid values")
})

---
title: "Fragmentation Analysis with topdownr"
author:
- name: Pavel V. Shliaha
  affiliation: Department of Biochemistry and Molecular Biology,
    University of Southern Denmark, Denmark.
- name: Sebastian Gibb
  affiliation: Department of Anesthesiology and Intensive Care,
    University Medicine Greifswald, Germany.
- name: Ole Nørregaard Jensen
  affiliation: Department of Biochemistry and Molecular Biology,
    University of Southern Denmark, Denmark.
package: topdownr
abstract: >
    This vignette describes the fragmentation analysis functionality
    of the `topdownr` package.
output:
    BiocStyle::html_document:
        toc_float: TRUE
        tidy: TRUE
bibliography: topdownr.bib
vignette: >
    %\VignetteIndexEntry{Fragmentation Analysis with topdownr}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteKeywords{Mass Spectrometry, Proteomics, Bioinformatics}
    %\VignetteEncoding{UTF-8}
    %\VignettePackage{topdownr}
---

```{r environment, echo=FALSE, message=FALSE, warning=FALSE}
library("topdownr")
library("topdownrdata")
library("ranger")
library("ggplot2")
library("BiocStyle")
```

# Foreword {-}

`r BiocStyle::Biocpkg("topdownr")` is free and
open-source software. If you use it, please support the project by
citing it in publications:

```{r citation, echo=FALSE, results="asis"}
ct <- format(citation("topdownr"), "textVersion")
cat(gsub("DOI: *(.*)$", "DOI: [\\1](https://doi.org/\\1)", ct), "\n")
```

# Questions and bugs {-}

For bugs, typos, suggestions or other questions, please file an issue
in our tracking system (https://github.com/sgibb/topdownr/issues)
providing as much information as possible, a reproducible example and
the output of `sessionInfo()`.

If you don't have a GitHub account or wish to reach a broader audience
for general questions about proteomics analysis using R, you may want
to use the Bioconductor support site: https://support.bioconductor.org/.

# Introduction/Working with `topdownr`

Load the package.

```{r loadPackage}
library("topdownr")
```

## Importing Files

Some example files are provided in the `topdownrdata` package. For a full
analysis you need a `.fasta` file with the protein sequence, the
`.experiments.csv` files containing the method information, the `.txt` files
containing the scan header information and the `.mzML` files with the
deconvoluted spectra.

```{r listFiles, eval=-1, echo=1, comment=NA}
list.files(topdownrdata::topDownDataPath("myoglobin"))
lapply(
    topdownr:::.listTopDownFiles(
        topdownrdata::topDownDataPath("myoglobin")),
    function(x) {
        c(head(
            file.path(
                "...",
                paste(
                    tail(strsplit(dirname(x), "/")[[1L]], 2),
                    collapse=.Platform$file.sep
                ),
                basename(x)
            ),
            2
        ), "...")
    }
)
```

All these files have to be in a directory. You could import them via
`readTopDownFiles`. This function has some arguments. The most important ones
are the `path` of the directory containing the files,
the protein `modification` (e.g. initiator methionine removal,
`"Met-loss"`), and adducts (e.g. proton transfer often occurs
from c to z-fragment after ETD reaction).

```{r importFiles, warnings=FALSE}
## the mass adduct for a proton
H <- 1.0078250321

myoglobin <- readTopDownFiles(
    ## directory path
    path = topdownrdata::topDownDataPath("myoglobin"),
    ## fragmentation types
    type = c("a", "b", "c", "x", "y", "z"),
    ## adducts (add -H/H to c/z and name
    ## them cmH/zpH (c minus H, z plus H)
    adducts = data.frame(
        mass=c(-H, H),
        to=c("c", "z"),
        name=c("cmH", "zpH")),
    ## initiator methionine removal
    modifications = "Met-loss",
    ## don't use neutral loss
    neutralLoss = NULL,
    ## tolerance for fragment matching
    tolerance = 5e-6,
    ## topdownrdata was generate with an older version of topdownr,
    ## the method files were generated with FilterString identification,
    ## use `conditions = "ScanDescription"` (default) for recent data.
    conditions = "FilterString"
)

myoglobin
```

## The `TopDownSet` Anatomy

The assembled object is an `TopDownSet` object.
Briefly it is composed of three interconnected tables:

1. `rowViews`/*fragment data*: holds the information on the type of fragments,
    their modifications and adducts.
2. `colData`/*condition data*: contains the corresponding fragmentation
    condition for every spectrum.
3. `assayData`: contains the intensity of assigned fragments.

![TopDownSet anatomy, image adopted from [@SummarizedExperiment].](images/TopDownSet.svg)

## Technical Details

This section explains the implementation details of the `TopDownSet` class. It
is not necessary to understand everything written here to use `topdownr` for the
analysis of fragmentation data.

The `TopDownSet` contains the following components: *Fragment data*, *Condition
data*, *Assay data*.

### Fragment data

```{r rowViews}
rowViews(myoglobin)
```

The fragmentation data are represented by an `FragmentViews` object that is an
overloaded `XStringViews` object. It contains one `AAString`
(the protein sequence) and an `IRanges` object that stores the
`start`, `end` (and `width`) values of the fragments.
Additionally it has a `DataFrame` for the `mass`, `type` and `z` information
of each fragment.

### Condition data

```{r colData}
conditionData(myoglobin)[, 1:5]
```

Condition data is a `DataFrame` that contains the combined header information
for each MS run (combined from method (`.experiments.csv` files)/scan header
(`.txt` files) table and metadata from the `.mzML` files).

### Assay data

```{r assayData}
assayData(myoglobin)[206:215, 1:10]
```

Assay data is a `sparseMatrix` from the `Matrix` package
(in detail a `dgCMatrix`) where the rows correspond to the fragments,
the columns to the runs/conditions and the entries to the intensity values.
A `sparseMatrix` is similar to the classic `matrix` in *R* but stores just
the values that are different from zero.

## Subsetting a `TopDownSet`

A `TopDownSet` could be subsetted by the fragment and the condition data.

```{r subsetting}
# select the first 100 fragments
myoglobin[1:100]

# select all "c" fragments
myoglobin["c"]

# select just the 100. "c" fragment
myoglobin["c100"]

# select all "a" and "b" fragments but just the first 100 "c"
myoglobin[c("a", "b", paste0("c", 1:100))]

# select condition/run 1 to 10
myoglobin[, 1:10]

# select all conditions from one file
myoglobin[, myoglobin$File == "myo_1211_ETDReagentTarget_1e+06_1"]

# select all "c" fragments from a single file
myoglobin["c", myoglobin$File == "myo_1211_ETDReagentTarget_1e+06_1"]
```

## Plotting a `TopDownSet`

Each condition represents one spectrum. We could plot a single condition
interactively or all spectra into a `pdf` file
(or any other *R* device that supports multiple pages/plots).

```{r plotting, eval=1:2}
# plot a single condition
plot(myoglobin[, "C0707.30_1.0e+05_1.0e+06_10.00_00_28_3"])
# example to plot the first ten conditions into a pdf
# (not evaluated in the vignette)
pdf("topdown-conditions.pdf", paper="a4r", width=12)
plot(myoglobin[, 1:10])
dev.off()
```

`plot` returns a `list` (an item per condition) of `ggplot` objects which could
further modified or investigated interactively by calling `plotly::ggplotly()`.

# Fragmentation Data Analysis of Myoglobin

We follow the following workflow:

![topdownr workflow](images/workflow/analysis.mmd.png)

We use the example data loaded in
[Importing Files](analysis.html#21_importing_files).

```{r importFiles2, ref.label="import_files", eval=FALSE}
```

The data contains several replicates for each fragmentation condition.
Before aggregation can be performed we need to remove scans with
inadequate injection times and fragments with low intensity or poor
intensity reproducibility.

## Filter Conditions on Injection Times

Injection times should be consistent for a particular *m/z* and particular
AGC target. High or low injection times indicate problems with on-the-flight
AGC calculation or spray instability for a particular scan. Hence the
`topdownr` automatically calculates median injection time for a given *m/z*
and AGC target combination. The user can choose to remove all scans that
deviate more than a certain amount from the corresponding median and/or
choose to keep `N` scans with the lowest deviation from the median for
every condition.

Here we show an example of such filtering and the effect on the distribution of
injection times.

```{r filterInjectionTimes}
injTimeBefore <- colData(myoglobin)
injTimeBefore$Status <- "before filtering"

## filtering on max deviation and just keep the
## 2 technical replicates per condition with the
## lowest deviation
myoglobin <- filterInjectionTime(
    myoglobin,
    maxDeviation = log2(3),
    keepTopN = 2
)

myoglobin

injTimeAfter <- colData(myoglobin)
injTimeAfter$Status <- "after filtering"

injTime <- as.data.frame(rbind(injTimeBefore, injTimeAfter))

## use ggplot for visualisation
library("ggplot2")

ggplot(injTime,
    aes(x = as.factor(AgcTarget),
        y = IonInjectionTimeMs,
        group = AgcTarget)) +
    geom_boxplot() +
    facet_grid(Status ~ Mz)
```

## Filter Fragments on CV

High CV of intensity for a fragment suggests either fragment contamination
by another *m/z* species or problems with deisotoping and we recommend
removing all fragments with CV > 30, as shown below.

```{r filterCv}
myoglobin <- filterCv(myoglobin, threshold=30)
myoglobin
```

## Filter Fragments on Intensity

When optimizing protein fragmentation we also want to focus on the most
intense fragments, hence we recommend removing all low intensity fragments
from analysis.

Low intensity is defined relatively to the most intense observation for
this fragment (i.e. relatively to the maximum value in an `assayData` row).
In the example below all intensity values, which have less than 10%
intensity of the highest intensity to their corresponding fragment
(in their corresponding row) are removed.

```{r filterIntensity}
myoglobin <- filterIntensity(myoglobin, threshold=0.1)
myoglobin
```

## Data Aggregation

The next step of analysis is aggregating technical replicates of fragmentation
conditions (columns of `assayData`).

```{r aggregate}
myoglobin <- aggregate(myoglobin)
myoglobin
```

## Random Forest

To examine which of the features (fragmentation parameters) have the highest
overall impact for a protein we perform random forest machine learning using the
`ranger` [@ranger] `R`-package.

Before we compute some fragmentation statistics
(number of assigned fragments, total assigned intensity, etc.).

```{r randomForest}
library("ranger")

## statistics
head(summary(myoglobin))

## number of fragments
nFragments <- summary(myoglobin)$Fragments

## features of interest
foi <- c(
    "AgcTarget",
    "EtdReagentTarget",
    "EtdActivation",
    "CidActivation",
    "HcdActivation",
    "Charge"
)

rfTable <- as.data.frame(colData(myoglobin)[foi])

## set NA to zero
rfTable[is.na(rfTable)] <- 0

rfTable <- as.data.frame(cbind(
    scale(rfTable),
    Fragments = nFragments
))

featureImportance <- ranger(
    Fragments ~ .,
    data = rfTable,
    importance = "impurity"
)$variable.importance

barplot(
    featureImportance/sum(featureImportance),
    cex.names = 0.7
)
```

The two parameters having the lowest overall impact in the `myoglobin`
dataset across all conditions are ETD reagent target (`EtdReagentTarget`),
CID activation energy (`CidActivation`) and AGC target (`AgcTarget`),
while ETD reaction energy (`EtdActivation`) and HCD activation energy
(`HcdActivation`) demonstrate the highest overall impact.

## Combining Fragmentation Conditions to Maximize Coverage

The purpose of `topdownr` is to investigate how maximum coverage with high
intensity fragments can be achieved with minimal instrument time.
Therefore `topdownr` reports the best combination of fragmentation conditions
(with user specified number of conditions) that covers the highest number of
different bonds.

Different fragmentation methods predominantly generate different types of
fragments (e.g. b and y for HCD and CID, c and z for ETD, a and x for UVPD).

However N-terminal (a, b and c) as well as C-terminal (x, y and z) fragments
originating from the same bond, cover the same number of amino acid sidechains.
Hence different types of N-terminal (a, b and c) or C-terminal (x, y and z)
fragments from the same bond add no extra sequence information.

Before we compute combinations all the fragments are converted to either
N- or C-terminal, as shown in the image below.

![Schema of N-/C-terminal fragments or bidirectional](images/ncb.svg)

In `topdownr` we convert the `TopDownSet` into an `NCBSet` object
(*N*-terminal/*C*-terminal/*B*idirectional).

```{r coerce2NCBSet}
myoglobinNcb <- as(myoglobin, "NCBSet")
myoglobinNcb
```

An `NCBSet` is very similar to a `TopDownSet` but instead of an `FragmentViews`
the `rowViews` are an `XStringViews` for the former. Another difference is that
the `NCBSet` has one row per bond instead one row per fragment. Also the
`assayData` contains no intensity information but a `1` for an *N*-terminal, a
`2` for a *C*-terminal and a `3` for bidirectional fragments.

The `NCBSet` can be used to select the combination of conditions that provide
the best fragment coverage. While computing coverage `topdownr` awards 1 point
for every fragment going from every bond in either *N* or *C* directions.
This means that bonds covered in both directions increase the score of a
condition by 2 points.
For the myoglobin fragmentation example we get the following table for the best
three conditions:

```{r bestConditions}
bestConditions(myoglobinNcb, n=3)
```

## Building a Fragmentation Map

Fragmentation maps allow visualising the type of fragments produced by
fragmentation conditions and their overall distribution along the protein
backbone. It also illustrates how the combination of conditions results in
a cumulative increase in fragment coverage.
Shown below is a fragmentation map for myoglobin *m/z* 707.3, AGC target `1e6`
and ETD reagent target of `1e7` for ETD
(plotting more conditions is not practical for the vignette):

```{r fragmentationMap}
sel <-
    myoglobinNcb$Mz == 707.3 &
    myoglobinNcb$AgcTarget == 1e6 &
    (myoglobinNcb$EtdReagentTarget == 1e7 &
     !is.na(myoglobinNcb$EtdReagentTarget))

myoglobinNcbSub <- myoglobinNcb[, sel]

fragmentationMap(
    myoglobinNcbSub,
    nCombinations = 10,
    labels = seq_len(ncol(myoglobinNcbSub))
)
```

# Session Information

```{r sessionInfo}
sessionInfo()
```

# References

---
title: "Data Generation for topdownr"
author:
- name: Pavel V. Shliaha
  affiliation: Department of Biochemistry and Molecular Biology,
    University of Southern Denmark, Denmark.
- name: Sebastian Gibb
  affiliation: Department of Anesthesiology and Intensive Care,
    University Medicine Greifswald, Germany.
- name: Ole Nørregaard Jensen
  affiliation: Department of Biochemistry and Molecular Biology,
    University of Southern Denmark, Denmark.
package: topdownr
abstract: >
    This vignette describes the setup and the data preparation to create the
    input files needed for the analysis with the functionality the `topdownr`
    package.
output:
  BiocStyle::html_document:
    toc_float: TRUE
    tidy: TRUE
bibliography: topdownr.bib
vignette: >
    %\VignetteIndexEntry{Data Generation for topdownr}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteKeywords{Mass Spectrometry, Proteomics, Bioinformatics}
    %\VignetteEncoding{UTF-8}
    %\VignettePackage{topdownr}
---

```{r environment, echo=FALSE, message=FALSE, warning=FALSE}
library("topdownr")
library("BiocStyle")
```

# Foreword {-}

`r BiocStyle::Biocpkg("topdownr")` is free and
open-source software. If you use it, please support the project by
citing it in publications:

```{r citation, echo=FALSE, results="asis"}
ct <- format(citation("topdownr"), "textVersion")
cat(gsub("DOI: *(.*)$", "DOI: [\\1](https://doi.org/\\1)", ct), "\n")
```

# Questions and bugs {-}

For bugs, typos, suggestions or other questions, please file an issue
in our tracking system (https://github.com/sgibb/topdownr/issues)
providing as much information as possible, a reproducible example and
the output of `sessionInfo()`.

If you don't have a GitHub account or wish to reach a broader audience
for general questions about proteomics analysis using R, you may want
to use the Bioconductor support site: https://support.bioconductor.org/.

# Introduction

## The `topdownr` Data Generation Workflow

<embed src="images/workflow/data-generation.mmd.svg" type="image/svg+xml" />

# Installation of Additional Software

## Setup the Thermo Software

To create methods the user will have to install and modify Orbitrap Fusion
LUMOS workstation first:

1. Request `TribridSeriesWorkstationSetup-v3.2.exe` from Thermo Scientific.
2. Install the workstation by running `TribridSeriesWorkstationSetup-v3.2.exe`.

## Setup XMLMethodChanger

*XMLMethodChanger* is needed to convert the xml methods into `.meth` files. It
could be found at https://github.com/thermofisherlsms/meth-modifications
The user has to download and compile it himself (or request it from Thermo
Scientific as well). You would need at least the *3.2 beta* version.

## Setup Operating System

In order to use *XMLMethodChanger* the operating system has to use the `.` (dot)
as decimal mark and the `,` (comma) as digit group separator (one thousand dot
two should be formated as `1,000.2`).

In *Windows 7* the settings are located at
`Windows Control Panel > Region and Language > Formats`.
Choose *English (USA)* here or use the *Additional settings* button to change it
manually.

## Setup ScanHeadsman

After data aquisition `topdownr` would need the header information from the
`.raw` files.
Therefore the *ScanHeadsman* software is used. It could be
downloaded from https://bitbucket.org/caetera/scanheadsman

It requires Microsoft **.NET 4.5** or later (it is often preinstalled on a
typical modern Windows or could be found in Microsoft's Download Center, e.g.
https://www.microsoft.com/en-us/download/details.aspx?id=30653).
Additionally you would need Thermo's *MS File Reader* which could be downloaded
free of charge (but you have to register) from the Thermo FlexNet website:
https://thermo.flexnetoperations.com/

*ScanHeadsman* was created by Vladimir Gorshkov <vgor@bmb.sdu.dk>.

# Creating Methods

Importantly, *XMLmethodChanger* does not create methods *de novo*, but modifies
pre-existing methods (supplied with *XMLMethodChanger*) using modifications
described in XML files. Thus the whole process of creating user specified
methods consists of 2 parts:

1. Construction of XML files with all possible combination of fragmentation
    parameters (see `topdownr::createExperimentsFragmentOptimisation`,
    and `topdownr::writeMethodXmls` below).
2. Submitting the constructed XML files together with a template
    `.meth` file to *XMLmethodChanger*.

We choose to use targeted MS2 scans (TMS2) as a way to store the
fragmentation parameters.
Each TMS2 is stored in a separate experiment. Experiments do not overlap.

![Method Editor](images/methodeditor-exp-tms.png)

# Data preparation with `topdownr`

Shown below is the process of creating XML files and using them to modify the
*TMS2IndependentTemplateForTD.meth* template file.

```{r writeMethodXml, eval=FALSE}
library("topdownr")

## Create MS1 settings
ms1 <- expandMs1Conditions(
    FirstMass=400,
    LastMass=1200,
    Microscans=as.integer(10)
)

## Set TargetMass
targetMz <- cbind(mz=c(560.6, 700.5, 933.7), z=rep(1, 3))

## Set common settings
common <- list(
    OrbitrapResolution="R120K",
    IsolationWindow=1,
    MaxITTimeInMS=200,
    Microscans=as.integer(40),
    AgcTarget=c(1e5, 5e5, 1e6)
)

## Create settings for different fragmentation conditions
cid <- expandTms2Conditions(
    MassList=targetMz,
    common,
    ActivationType="CID",
    CIDCollisionEnergy=seq(7, 35, 7)
)
hcd <- expandTms2Conditions(
    MassList=targetMz,
    common,
    ActivationType="HCD",
    HCDCollisionEnergy=seq(7, 35, 7)
)
etd <- expandTms2Conditions(
    MassList=targetMz,
    common,
    ActivationType="ETD",
    ETDReactionTime=as.double(1:2)
)
etcid <- expandTms2Conditions(
    MassList=targetMz,
    common,
    ActivationType="ETD",
    ETDReactionTime=as.double(1:2),
    ETDSupplementalActivation="ETciD",
    ETDSupplementalActivationEnergy=as.double(1:2)
)
uvpd <- expandTms2Conditions(
    MassList=targetMz,
    common,
    ActivationType="UVPD"
)

## Create experiments with all combinations of the above settings
## for fragment optimisation
exps <- createExperimentsFragmentOptimisation(
    ms1=ms1, cid, hcd, etd, etcid, uvpd,
    groupBy=c("AgcTarget", "replication"), nMs2perMs1=10, scanDuration=0.5,
    replications=2, randomise=TRUE
)

## Write experiments to xml files
writeMethodXmls(exps=exps)

## Run XMLMethodChanger
runXmlMethodChanger(
    modificationXml=list.files(pattern="^method.*\\.xml$"),
    templateMeth="TMS2IndependentTemplateForTD.meth",
    executable="path\\to\\XmlMethodChanger.exe"
)
```

# Data Acquisition

After setting up direct infusion make sure that MS1 spectrum produces
expected protein mass after deconvolution by *Xtract*.
Shown below is a deconvoluted MS1 spectrum for myoglobin.
The dominant mass corresponds to myoglobin with Met removed.

![Xtract myoglobin](images/xtract-myo.png)

# Data Preparation

Prior to `R` analysis of protein fragmentation data we have to convert the
`.raw` files.

## Extracting Header Information

Some of the information
(SpectrumId, Ion Injection Time (ms), Orbitrap Resolution, targeted Mz,
ETD reaction time,  CID activation and HCD activation) is stored in scan
headers, while other (ETD reagent target and AGC target) is only available
in method table.

You can run *ScanHeadsman* from the commandline
(`ScanHeadsman.exe --noMS --methods:CSV`) or use the function provided by
`topdownr`:

```{r ScanHeadsman, eval=FALSE}
runScanHeadsman(
    path="path\\to\\raw-files",
    executable="path\\to\\ScanHeadsman.exe"
)
```

*ScanHeadsman* will generate a `.txt` (scan header table) and a `.csv` (method
table) file for each `.raw` file.

## Convert .raw files into mzML

The spectra have to be charge state deconvoluted with *Xtract* node in
*Proteome Discoverer 2.1*. The software returns deconvoluted spectra in
mzML format.

![Proteome Discoverer](images/proteomediscoverer.png)

Once a `.csv`, `.txt`, and `.mzML` file for each `.raw` have been produced we
can start the analysis using `topdownr`.
Please see *analysis* vignette (`vignette("analysis", package="topdownr")`) for
an example.

# Session Info

```{r sessioninfo}
sessionInfo()
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/experiment-functions.R
\name{validMs1Settings}
\alias{validMs1Settings}
\alias{validTms2Settings}
\title{List valid MS settings.}
\usage{
validMs1Settings(family = "Calcium", version = "3.2")

validTms2Settings(
  type = c("All", "TMS2", "ETD", "CID", "HCD", "UVPD"),
  family = "Calcium",
  version = "3.2"
)
}
\arguments{
\item{family}{\code{character}, currently just Calcium is supported}

\item{version}{\code{character}, currently 3.1, 3.2 (default), 3.3 are supported}

\item{type}{\code{character}, type of activation.}
}
\value{
\code{matrix} with three columns:
\itemize{
\item name: element name
\item class: expected R class of the value
\item type: MS/ActivationType, e.g. MS1/TMS2/ETD/...
}
}
\description{
These functions list settings for MS1 or TMS2 that are supported by
\emph{Thermo's XmlMethodChanger}.
}
\examples{
validMs1Settings()
validTms2Settings()
validTms2Settings("TMS2")
validTms2Settings("ETD")
validTms2Settings(c("TMS2", "ETD"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/package-deprecated.R
\name{topdownr-deprecated}
\alias{topdownr-deprecated}
\title{Deprecated functions in topdownr}
\description{
These functions are provided for compatibility with older versions
of \sQuote{MyPkg} only, and will be defunct at the next release.
}
\details{
The following functions are deprecated and will be made defunct; use
the replacement indicated below:
\itemize{
\item \code{defaultMs1Settings}: \code{\link[=expandMs1Conditions]{expandMs1Conditions()}} in combination with
\code{\link[=createExperimentsFragmentOptimisation]{createExperimentsFragmentOptimisation()}}
\item \code{defaultMs2Settings}: \code{\link[=expandTms2Conditions]{expandTms2Conditions()}} in combination with
\code{\link[=createExperimentsFragmentOptimisation]{createExperimentsFragmentOptimisation()}}
}
}
\keyword{deprecated}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/experiment-functions.R
\name{createExperimentsFragmentOptimisation}
\alias{createExperimentsFragmentOptimisation}
\title{Create fragment optimisation experiment}
\usage{
createExperimentsFragmentOptimisation(
  ms1,
  ...,
  groupBy = c("AgcTarget", "replication"),
  nMs2perMs1 = 10,
  scanDuration = 0,
  replications = 2,
  randomise = TRUE
)
}
\arguments{
\item{ms1}{\code{data.frame}, MS1 settings.}

\item{...}{further named arguments with \code{data.frame}s containing the TMS2
settings.}

\item{groupBy}{\code{character}, group experiments by columns in the TMS2
\code{data.frame}s. The columns have to be present in all \code{data.frame}s. Each
group will be written to its own XML file.}

\item{nMs2perMs1}{\code{integer}, how many TMS2 scans should be run after a MS1
scan?}

\item{scanDuration}{\code{double}, if greater than zero (e.g. \code{scanDuration=0.5})
the Start/EndTimeMin are overwritten with a duration of \code{scanDuration}. If
\code{scanDuration} is zero (default) Start/EndTimeMin are not overwritten.}

\item{replications}{\code{integer}, number of replications.}

\item{randomise}{\code{logical}, should the TMS2 scan settings randomised?}
}
\value{
\code{list}, able to be written via \code{\link[xml2:as_xml_document]{xml2::as_xml_document()}}
}
\description{
This function is used to create a tree-like \code{list} of
all combinations of a user-given set of MS1 and TMS2 settings for an
fragment optimisation experiment. The list could be written to an
Orbitrap Fusion Lumos method xml file using \code{\link[=writeMethodXmls]{writeMethodXmls()}}.
}
\examples{
## build experiments within R
ms1 <- expandMs1Conditions(
    FirstMass=400,
    LastMass=1200,
    Microscans=as.integer(10)
)

targetMz <- cbind(mz=c(560.6, 700.5, 933.7), z=rep(1, 3))
common <- list(
    OrbitrapResolution="R120K",
    IsolationWindow=1,
    MaxITTimeInMS=200,
    Microscans=as.integer(40),
    AgcTarget=c(1e5, 5e5, 1e6)
)

cid <- expandTms2Conditions(
    MassList=targetMz,
    common,
    ActivationType="CID",
    CIDCollisionEnergy=seq(7, 35, 7)
)
hcd <- expandTms2Conditions(
    MassList=targetMz,
    common,
    ActivationType="HCD",
    HCDCollisionEnergy=seq(7, 35, 7)
)
etd <- expandTms2Conditions(
    MassList=targetMz,
    common,
    ActivationType="ETD",
    ETDReactionTime=as.double(1:2)
)
etcid <- expandTms2Conditions(
    MassList=targetMz,
    common,
    ActivationType="ETD",
    ETDReactionTime=as.double(1:2),
    ETDSupplementalActivation="ETciD",
    ETDSupplementalActivationEnergy=as.double(1:2)
)
uvpd <- expandTms2Conditions(
    MassList=targetMz,
    common,
    ActivationType="UVPD"
)

exps <- createExperimentsFragmentOptimisation(
    ms1=ms1, cid, hcd, etd, etcid, uvpd,
    groupBy=c("AgcTarget", "replication"), nMs2perMs1=10, scanDuration=0.5,
    replications=2, randomise=TRUE
)

## use different settings for CID
cid560 <- expandTms2Conditions(
    MassList=cbind(560.6, 1),
    common,
    ActivationType="CID",
    CIDCollisionEnergy=seq(7, 21, 7)
)
cid700 <- expandTms2Conditions(
    MassList=cbind(700.5, 1),
    common,
    ActivationType="CID",
    CIDCollisionEnergy=seq(21, 35, 7)
)

exps <- createExperimentsFragmentOptimisation(
    ms1=ms1, cid560, cid700,
    groupBy=c("AgcTarget", "replication"), nMs2perMs1=10, scanDuration=0.5,
    replications=2, randomise=TRUE
)

## use a CSV (or excel) file as input
myCsvContent <- "
ActivationType, ETDReactionTime, UVPDActivationTime
UVPD,,1000
ETD,1000,
"
myCsvSettings <- read.csv(text=myCsvContent, stringsAsFactors=FALSE)
myCsvSettings
#   ActivationType ETDReactionTime UVPDActivationTime
# 1           UVPD              NA               1000
# 2            ETD            1000                 NA

exps <- createExperimentsFragmentOptimisation(
    ms1 = data.frame(FirstMass=500, LastMass=1000),
    ## TMS2
    myCsvSettings,
    ## other arguments
    groupBy="ActivationType"
)
}
\seealso{
\code{\link[=writeMethodXmls]{writeMethodXmls()}},
\code{\link[=expandMs1Conditions]{expandMs1Conditions()}},
\code{\link[=expandMs1Conditions]{expandTms2Conditions()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/functions-FragmentViews.R,
%   R/methods-FragmentViews.R
\docType{class}
\name{FragmentViews-class}
\alias{FragmentViews-class}
\alias{FragmentViews}
\alias{combine,FragmentViews,FragmentViews-method}
\alias{combine,FragmentViews-method}
\alias{mz,FragmentViews-method}
\alias{show,FragmentViews-method}
\alias{coerce,FragmentViews,data.frame-method}
\title{The FragmentViews class}
\usage{
FragmentViews(
  sequence,
  mass,
  type,
  z = 1L,
  start = NULL,
  end = NULL,
  width = NULL,
  names = NULL,
  metadata = list()
)

\S4method{combine}{FragmentViews,FragmentViews}(x, y)

\S4method{mz}{FragmentViews}(object, ...)

\S4method{show}{FragmentViews}(object)
}
\arguments{
\item{sequence}{\code{character}/
\link[Biostrings:AAString-class]{Biostrings::AAString},
complete protein/peptide sequence.}

\item{mass}{\code{double},
mass of the fragments, same length as \code{start}/\code{end}/\code{width}.}

\item{type}{\code{character},
type of the fragments, same length as \code{start}/\code{end}/width`.}

\item{z}{\code{integer},
charge of the fragments,
length one or same length as \code{start}/\code{end}/width`.}

\item{start}{\code{integer},
start positions of the fragments. At least two of
\code{start}/\code{end}/width` has to be given.}

\item{end}{\code{integer},
end positions of the fragments. At least two of
\code{start}/\code{end}/width` has to be given.}

\item{width}{\code{integer},
width positions of the fragments. At least two of
\code{start}/\code{end}/width` has to be given.}

\item{names}{\code{character},
names of the fragments, same length as \code{start}/\code{end}/width`.}

\item{metadata}{\code{list}, metadata like modifications.}

\item{object, x, y}{FragmentViews}

\item{\ldots}{arguments passed to internal/other methods.}
}
\value{
An \linkS4class{FragmentViews} object.
}
\description{
The FragmentViews class is a basic container for storing a set of views
(start/end locations) on the same peptides/protein sequence. Additionally
it keeps information about mass, type and charge of the fragments.
}
\details{
FragmentViews extends
\link[Biostrings:XStringViews-class]{Biostrings::XStringViews}.
In short it combines an
\link[IRanges:IRanges-class]{IRanges::IRanges}
object to store start/end
location on a sequence, an
\link[Biostrings:AAString-class]{Biostrings::AAString} object.
}
\section{Functions}{
\itemize{
\item \code{FragmentViews()}: Constructor

In general it is not necessary to call the constructor manually. See
\code{\link[=readTopDownFiles]{readTopDownFiles()}} instead.

}}
\section{Coercion}{


\code{as(object, "data.frame")}: Coerce an
\linkS4class{FragmentViews} object into a \code{data.frame}.
}

\examples{
# Constructor
fv <- FragmentViews("ACE", start=1, width=1:3, names=paste0("b", 1:3),
                    mass=c(72.04439, 232.07504, 361.11763),
                    type="b", z=1)
fv

# Coercion to data.frame
as(fv, "data.frame")
as(fv, "data.frame")
}
\seealso{
\link[Biostrings:XStringViews-class]{Biostrings::XStringViews}
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/methods-NCBSet.R
\docType{class}
\name{NCBSet-class}
\alias{NCBSet-class}
\alias{bestConditions,NCBSet-method}
\alias{bestConditions}
\alias{fragmentationMap,NCBSet-method}
\alias{fragmentationMap}
\alias{show,NCBSet-method}
\alias{summary,NCBSet-method}
\title{The NCBSet class}
\usage{
\S4method{bestConditions}{NCBSet}(
  object,
  n = ncol(object),
  minN = 0L,
  maximise = c("fragments", "bonds"),
  ...
)

\S4method{fragmentationMap}{NCBSet}(
  object,
  nCombinations = 10,
  cumCoverage = TRUE,
  maximise = c("fragments", "bonds"),
  labels = colnames(object),
  alphaIntensity = TRUE,
  ...
)

\S4method{show}{NCBSet}(object)

\S4method{summary}{NCBSet}(object, what = c("conditions", "bonds"), ...)
}
\arguments{
\item{object}{\code{NCBSet}}

\item{n}{\code{integer}, max number of combinations/iterations.}

\item{minN}{\code{integer},
stop if there are less than \code{minN} additional fragments}

\item{maximise}{\code{character}, optimisation targeting for the highest number of
\code{"fragments"} (default) or \code{"bonds"}.}

\item{nCombinations}{\code{integer},
number of combinations to show (0 to avoid plotting them at all).}

\item{cumCoverage}{\code{logical},
if \code{TRUE} (default) cumulative coverage of combinations is shown.}

\item{labels}{\code{character}, overwrite x-axis labels.}

\item{alphaIntensity}{\code{logical}, if \code{TRUE} (default) the alpha level of the
color is used to show the \code{colData(object)$AssignedIntensity}. If \code{FALSE} the
alpha is set to \code{1}.}

\item{what}{\code{character},
specifies whether \code{"conditions"} (columns; default) or
\code{"bonds"} (rows) should be summarized.}

\item{\ldots}{arguments passed to internal/other methods.
added.}
}
\value{
An \linkS4class{NCBSet} object.
}
\description{
The NCBSet class is a container for a top-down proteomics experiment
similar to the \linkS4class{TopDownSet}
but instead of intensity values it just stores the information if a
bond is covered by a N-terminal (encoded as \code{1}),
a C-terminal (encoded as \code{2})
and/or bidirectional fragments (encoded as \code{3}).
}
\section{Methods (by generic)}{
\itemize{
\item \code{bestConditions(NCBSet)}: Best combination of conditions.

Finds the best combination of conditions for highest coverage of fragments or
bonds. If there are two (or more conditions) that would add the same number
of fragments/bonds the one with the highest assigned intensity is used. Use
\code{n} to limit the number of iterations and combinations that should be
returned.
If \code{minN} is set at least \code{minN} fragments have to be added to the
combinations. The function returns a 7-column matrix. The first column
contains the index (\code{Index}) of the condition (column number). The next
columns contain the newly added number of fragments or bonds
(\code{FragmentsAddedToCombination}, \code{BondsAddedToCombination}), the fragments
or bonds in the condition (\code{FragmentsInCondition}, \code{BondsInCondition}), and
the cumulative coverage fragments or bonds (\code{FragmentCoverage},
\code{BondCoverage}).

\item \code{fragmentationMap(NCBSet)}: Plot fragmentation map.

Plots a fragmentation map of the Protein.
Use \code{nCombinations} to add another
plot with \code{nCombinations} combined conditions.
If \code{cumCoverage} is \code{TRUE} (default)
these combinations increase the coverage cumulatively.

\item \code{summary(NCBSet)}: Summary statistics.

Returns a \code{matrix} with some statistics: number of fragments,
total/min/first quartile/median/mean/third quartile/maximum of intensity
values.

}}
\section{Slots}{

\describe{
\item{\code{rowViews}}{\link[Biostrings:XStringViews-class]{Biostrings::XStringViews},
information about bonds (name, start, end, width, sequence),
see \link[Biostrings:XStringViews-class]{Biostrings::XStringViews} for details.}

\item{\code{colData}}{\link[S4Vectors:DataFrame-class]{S4Vectors::DataFrame},
information about the MS2 experiments and the fragmentation conditions.}

\item{\code{assay}}{\link[Matrix:dgCMatrix-class]{Matrix::dgCMatrix},
coverage values of the bonds. The rows correspond to the bonds and the
columns to the condition/run. It just stores values that are different
from zero. If a bond is covered by an N-terminal fragment its encoded
with \code{1}, by an C-terminal fragmentl with \code{2} and
by both fragment types/bidirectional by \code{3} respectively.}

\item{\code{files}}{\code{character}, files that were imported.}

\item{\code{processing}}{\code{character}, log messages.}
}}

\examples{
## Example data
data(tds, package="topdownr")

## Aggregate technical replicates
tds <- aggregate(tds)

## Coercion into an NCBSet object
ncb <- as(tds, "NCBSet")

ncb

head(summary(ncb))

# Accessing slots
rowViews(ncb)
colData(ncb)
head(assayData(ncb))

# Accessing colData
ncb$Mz

# Subsetting

# First 100 bonds
ncb[1:100]

# Just bond 152
ncb["bond152"]

# Condition 1 to 10
ncb[, 1:10]

# Plot fragmentation map
fragmentationMap(ncb)
}
\seealso{
\itemize{
\item An \code{NCBSet} is generated from an \linkS4class{TopDownSet} object.
\item \link[Biostrings:XStringViews-class]{Biostrings::XStringViews}
for the row view interface.
\item \link[Matrix:dgCMatrix-class]{Matrix::dgCMatrix}
for technical details about the coverage storage.
}
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/experiment-functions.R
\name{expandMs1Conditions}
\alias{expandMs1Conditions}
\alias{expandTms2Conditions}
\title{Expand MS Conditions}
\usage{
expandMs1Conditions(..., family = "Calcium", version = "3.2")

expandTms2Conditions(
  ActivationType = c("CID", "HCD", "ETD", "UVPD"),
  ...,
  MassList = NULL,
  family = "Calcium",
  version = "3.2"
)
}
\arguments{
\item{...}{further named arguments, used to create the combination of
conditions.}

\item{family}{\code{character}, currently just Calcium is supported}

\item{version}{\code{character}, currently 3.1, 3.2 (default), 3.3 are supported}

\item{ActivationType}{\code{character}, \emph{ActivationType} for TMS2,
either CID, HCD, ETD, or UVPD.}

\item{MassList}{\code{matrix}, 2 columns (mass, z) for targeted mass list,
or \code{NULL} (default) to not overwrite targeted mass.}
}
\value{
\code{data.frame} with all possible combinations of conditions/settings.
}
\description{
Create a \code{data.frame} of all possible combinations of the given arguments.
It ensures that just arguments are applied that yield a valid
MethodModification.xml file.
}
\examples{
expandMs1Conditions(FirstMass=100, LastMass=400)
expandTms2Conditions(
     ActivationType="CID",
     OrbitrapResolution="R120K",
     IsolationWindow=1,
     MaxITTimeInMS=200,
     Microscans=as.integer(40),
     AgcTarget=c(1e5, 5e5, 1e6),
     CIDCollisionEnergy=c(NA, seq(7, 35, 7)),
     MassList=cbind(mz=c(560.6, 700.5, 933.7), z=rep(1, 3))
)
}
\seealso{
\code{\link[=validMs1Settings]{validMs1Settings()}}

\code{\link[=validTms2Settings]{validTms2Settings()}}, \code{\link[=expand.grid]{expand.grid()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/functions-TopDownSet.R
\name{readTopDownFiles}
\alias{readTopDownFiles}
\title{Read top-down files.}
\usage{
readTopDownFiles(
  path,
  pattern = ".*",
  type = c("a", "b", "c", "x", "y", "z"),
  modifications = c("Carbamidomethyl", "Acetyl", "Met-loss"),
  customModifications = data.frame(),
  adducts = data.frame(),
  neutralLoss = PSMatch::defaultNeutralLoss(),
  sequenceOrder = c("original", "random", "inverse"),
  tolerance = 5e-06,
  redundantIonMatch = c("remove", "closest"),
  redundantFragmentMatch = c("remove", "closest"),
  dropNonInformativeColumns = TRUE,
  sampleColumns = c("Mz", "AgcTarget", "EtdReagentTarget", "EtdActivation",
    "CidActivation", "HcdActivation", "UvpdActivation"),
  conditions = "ScanDescription",
  verbose = interactive()
)
}
\arguments{
\item{path}{\code{character},
path to directory that contains the top-down files.}

\item{pattern}{\code{character},
a filename pattern, the default \verb{.*} means all files.}

\item{type}{\code{character},
type of fragments, currently \emph{a-c} and \emph{x-z} are
supported, see
\code{\link[PSMatch:calculateFragments]{PSMatch::calculateFragments()}}
for details.}

\item{modifications}{\code{character},
unimod names of modifications that should be applied.
Currenlty just \emph{Acetyl} (Unimod:1 but just protein N-term),
\emph{Carbamidomethyl} (Unimod:4) and
\emph{Met-loss} (Unimod:765) are supported.
\emph{Met-loss} removes M
(if followed by A, C, G, P, S, T, or V;
(see also
http://www.unimod.org/modifications_view.php?editid1=1,
http://www.unimod.org/modifications_view.php?editid1=4, and
http://www.unimod.org/modifications_view.php?editid1=765 for details)).
Use \code{NULL} to disable all modifications.}

\item{customModifications}{\code{data.frame},
with 4 columns, namely: mass, name, location, variable, see details section.}

\item{adducts}{\code{data.frame},
with 3 columns, namely: mass, name, to, see details section.}

\item{neutralLoss}{\code{list},
neutral loss that should be applied, see
\code{\link[PSMatch:calculateFragments]{PSMatch::calculateFragments()}} and
\code{\link[PSMatch:calculateFragments]{PSMatch::defaultNeutralLoss()}}
for details.}

\item{sequenceOrder}{\code{character},
order of the sequence before fragment calculation and matching is done.
\code{"original"} doesn't change anything.
\code{"inverse"} reverse the sequence and
\code{"random"} arranges the amino acid sequence at random.}

\item{tolerance}{\code{double},
tolerance in \emph{ppm} that is used to match the
theoretical fragments with the observed ones.}

\item{redundantIonMatch}{\code{character}, a mz could be matched to one, two or
more fragments. If it is matched against more than one fragment the match
could be \code{"remove"}d or the match to the \code{"closest"} fragment could be
chosen.}

\item{redundantFragmentMatch}{\code{character}, one or more mz could be matched to
the same fragment, these matches could be \code{"remove"}d or the match to the
\code{"closest"} mz is chosen.}

\item{dropNonInformativeColumns}{logical,
should columns with just one identical value across all runs be removed?}

\item{sampleColumns}{\code{character},
column names of the \code{\link[=colData]{colData()}}
used to define a sample (technical replicate). This is used to add the
\code{Sample} column (used for easier aggregation, etc.).}

\item{conditions}{\code{character}/\code{numeric}, one of:
\itemize{
\item \code{"ScanDescription"} (default): create condition IDs based on the given
"Scan Description" parameter (set automatically by
\code{\link[=createExperimentsFragmentOptimisation]{createExperimentsFragmentOptimisation()}}).
\item \code{"FilterString"}: create condition IDs based on mass labels in
the \emph{FilterString} column (included for backward-compatibilty, used
in \code{\link[=writeMethodXmls]{writeMethodXmls()}} prior version 1.5.2 in Dec 2018).
\item A single \code{numeric} value giving the number of conditions.
}}

\item{verbose}{\code{logical}, verbose output?}
}
\value{
A \code{TopDownSet} object.
}
\description{
It creates an \linkS4class{TopDownSet} object and is its only constructor.
}
\details{
\code{readTopDownFiles} reads and processes all top-down files, namely:
\itemize{
\item \code{.fasta} (protein sequence)
\item \code{.mzML} (spectra)
\item \code{.experiments.csv} (method/fragmentation conditions)
\item \code{.txt} (scan header information)
}

\code{customModifications}: additional to the provided unimod modifications
available through the \code{modifications} argument \code{customModifications} allow to
apply user-definied modifications to the output of
\code{\link[PSMatch:calculateFragments]{PSMatch::calculateFragments()}}.
The \code{customModifications} argument takes a
\code{data.frame} with the \code{mass} to add, the \code{name} of the modification, the
location (could be the position of the amino acid or "N-term"/"C-term"),
whether the modification is always seen (\code{variable=FALSE}) or both, the
modified and unmodified amino acid are present (\code{variable=TRUE}), e.g.
for Activation (which is available via \code{modification="Acetyl"})
\code{data.frame(mass=42.010565, name="Acetyl", location="N-term", variable=FALSE)}
or variable one (that could be present or not):
\code{data.frame(mass=365.132, name="Custom", location=10, variable=TRUE)}

If the \code{customModifications} \code{data.frame} contains multiple columns the
modifications are applied from row one to the last row one each time.

\code{adducts}: \emph{Thermo's Xtract}
allows some mistakes in deisotoping, mostly it
allows \verb{+/- C13-C12} and \verb{+/- H+}.
The \code{adducts} argument takes a
\code{data.frame} with the \code{mass} to add, the \code{name}
that should assign to these
new fragments and an information \code{to}
whom the modification should be
applied, e.g. for \verb{H+} on \code{z},
\code{data.frame(mass=1.008, name="zpH", to="z")}.

\emph{Please note:} The \code{adducts} are added to the output of
\code{\link[PSMatch:calculateFragments]{PSMatch::calculateFragments()}}.
That has some limitations, e.g.
neutral loss calculation could not be done in
\link{topdownr-package}.
If neutral loss should be applied on adducts you have to create
additional rows, e.g.:
\code{data.frame(mass=c(1.008, 1.008), name=c("cpH", "cpH_"), to=c("c", "c_"))}.
}
\examples{
if (require("topdownrdata")) {
    # add H+ to z and no neutral loss of water
    tds <- readTopDownFiles(
        topdownrdata::topDownDataPath("myoglobin"),
        ## Use an artifical pattern to load just the fasta
        ## file and files from m/z == 1211, ETD reagent
        ## target 1e6 and first replicate to keep runtime
        ## of the example short
        pattern=".*fasta.gz$|1211_.*1e6_1",
        adducts=data.frame(mass=1.008, name="zpH", to="z"),
        neutralLoss=PSMatch::defaultNeutralLoss(
            disableWaterLoss=c("Cterm", "D", "E", "S", "T")),
        tolerance=25e-6
   )
}
}
\seealso{
\code{\link[PSMatch:calculateFragments]{PSMatch::calculateFragments()}},
\code{\link[PSMatch:calculateFragments]{PSMatch::defaultNeutralLoss()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/methods-AbstractTopDownSet.R
\docType{class}
\name{AbstractTopDownSet-class}
\alias{AbstractTopDownSet-class}
\alias{[,AbstractTopDownSet,ANY,ANY,ANY-method}
\alias{[[,AbstractTopDownSet,ANY,missing-method}
\alias{[[,AbstractTopDownSet,ANY,missing,-method}
\alias{[[<-,AbstractTopDownSet,ANY,missing-method}
\alias{[[<-,AbstractTopDownSet,ANY,missing,-method}
\alias{$,AbstractTopDownSet-method}
\alias{$<-,AbstractTopDownSet-method}
\alias{assayData,AbstractTopDownSet-method}
\alias{colData,AbstractTopDownSet-method}
\alias{colData}
\alias{colData<-,AbstractTopDownSet-method}
\alias{colData<-}
\alias{combine,AbstractTopDownSet,AbstractTopDownSet-method}
\alias{combine}
\alias{conditionData,AbstractTopDownSet-method}
\alias{conditionData}
\alias{conditionData<-,AbstractTopDownSet-method}
\alias{conditionData<-}
\alias{conditionNames,AbstractTopDownSet-method}
\alias{conditionNames}
\alias{dim,AbstractTopDownSet-method}
\alias{dimnames,AbstractTopDownSet-method}
\alias{removeEmptyConditions,AbstractTopDownSet-method}
\alias{removeEmptyConditions}
\alias{rowViews,AbstractTopDownSet-method}
\alias{rowViews}
\alias{show,AbstractTopDownSet-method}
\alias{summary,AbstractTopDownSet-method}
\alias{updateConditionNames,AbstractTopDownSet-method}
\alias{updateConditionNames}
\alias{updateMedianInjectionTime,AbstractTopDownSet-method}
\alias{updateMedianInjectionTime}
\alias{updateMedianInjectionTime,TopDownSet-method}
\title{The AbstractTopDownSet class}
\usage{
\S4method{[}{AbstractTopDownSet,ANY,ANY,ANY}(x, i, j, ..., drop = FALSE)

\S4method{[[}{AbstractTopDownSet,ANY,missing}(x, i, j, ...)

\S4method{[[}{AbstractTopDownSet,ANY,missing}(x, i, j, ...) <- value

\S4method{$}{AbstractTopDownSet}(x, name)

\S4method{$}{AbstractTopDownSet}(x, name) <- value

\S4method{assayData}{AbstractTopDownSet}(object)

\S4method{colData}{AbstractTopDownSet}(object)

\S4method{colData}{AbstractTopDownSet}(object, ...) <- value

\S4method{combine}{AbstractTopDownSet,AbstractTopDownSet}(x, y)

\S4method{conditionData}{AbstractTopDownSet}(object, ...)

\S4method{conditionData}{AbstractTopDownSet}(object, ...) <- value

\S4method{conditionNames}{AbstractTopDownSet}(object)

\S4method{dim}{AbstractTopDownSet}(x)

\S4method{dimnames}{AbstractTopDownSet}(x)

\S4method{removeEmptyConditions}{AbstractTopDownSet}(object)

\S4method{rowViews}{AbstractTopDownSet}(object, ...)

\S4method{show}{AbstractTopDownSet}(object)

\S4method{summary}{AbstractTopDownSet}(object, what = c("rows", "columns"), ...)

\S4method{updateConditionNames}{AbstractTopDownSet}(
  object,
  sampleColumns = c("Mz", "AgcTarget", "EtdReagentTarget", "EtdActivation",
    "CidActivation", "HcdActivation", "UvpdActivation"),
  verbose = interactive()
)

\S4method{updateMedianInjectionTime}{AbstractTopDownSet}(
  object,
  by = list(Mz = object$Mz, AgcTarget = object$AgcTarget)
)
}
\arguments{
\item{i, j}{\code{numeric}, \code{logical} or \code{character},
indices specifying elements to extract or replace.}

\item{drop}{\code{logical}, currently ignored.}

\item{value}{replacment value.}

\item{name}{\code{character} name of an (non)existing column in \code{colData}.}

\item{object, x}{\code{AbstractTopDownSet}}

\item{y}{\code{AbstractTopDownSet}}

\item{what}{\code{character},
specifies whether \code{"rows"} or \code{"columns"} should be summarized.}

\item{sampleColumns}{\code{character},
column names of the \code{\link[=colData]{colData()}}
used to define a sample (technical replicate). This is used to add the
\code{Sample} column (used for easier aggregation, etc.).}

\item{verbose}{\code{logical}, verbose output?}

\item{by}{\code{list}, grouping information.}

\item{\ldots}{arguments passed to internal/other methods.}
}
\value{
This is an \emph{Abstract/VIRTUAL} class
to provide a common interface for
\linkS4class{TopDownSet} and \linkS4class{NCBSet}.
It is not possible to create an \code{AbstractTopDownSet} object.
}
\description{
\emph{Abstract/VIRTUAL} parent class for
\linkS4class{TopDownSet} and \linkS4class{NCBSet} to provide common interface.
}
\details{
This class just provides a common interface. It is not intended for direct
use by the user. Please see \linkS4class{TopDownSet} for an example usage of its
child class.
}
\section{Methods (by generic)}{
\itemize{
\item \code{x[i}: Subset operator.

For \code{i} \code{numeric}, \code{logical} or \code{character} vectors or empty
(missing) or \code{NULL} are supported.
Subsetting is done on the fragment/bond (row) level.
\code{character} indices could be names
(e.g. \code{c("a1", "b1", "c1", "c2", "c3")})
or types (e.g. \code{c("c", "x")}) of the fragments for
\linkS4class{TopDownSet} objects,
or names of the bonds (e.g. \code{c("bond001")}) for
\linkS4class{NCBSet} objects. \cr
\code{j} could be a \code{numeric} or \code{logical} vector
and subsetting is done on the condition/run (column) level.

\item \code{x[[i}: Subset operator.

\code{i} could be a \code{numeric} or \code{logical} vector and
subsetting is done on the condition/run (column) level.

\item \code{`[[`(x = AbstractTopDownSet, i = ANY, j = missing) <- value}: Setter for a column in the \code{colData} slot.

The \verb{[[<-} operator is used to add/replace
a single column of the \code{colData} \code{DataFrame}.

\item \code{$}: Accessor for columns in the \code{colData} slot.

The \code{$} simplifies the accession of a single column
of the \code{colData}.
It is identical to the \code{[[} operator.

\item \code{`$`(AbstractTopDownSet) <- value}: Setter for a column in the \code{colData} slot.

The \verb{$<-} operator is used to add/replace a single column
of the \code{colData} \code{DataFrame}.
It is identical to the \verb{[[<-} operator.

\item \code{assayData(AbstractTopDownSet)}: Accessor for the \code{assay} slot.

Returns a \link[Matrix:dgCMatrix-class]{Matrix::dgCMatrix} that stores the
intensity/coverage information of \linkS4class{AbstractTopDownSet}
object.

\item \code{colData(AbstractTopDownSet)}: Accessor for the \code{colData} slot.

Returns a \link[S4Vectors:DataFrame-class]{S4Vectors::DataFrame} that stores
metadata for the conditons/runs (columns) of the
\linkS4class{AbstractTopDownSet} object.

\item \code{colData(AbstractTopDownSet) <- value}: Setter for the \code{colData} slot.

Replaces metadata for the conditons/runs (columns) of the
\linkS4class{AbstractTopDownSet} object.

\item \code{combine(x = AbstractTopDownSet, y = AbstractTopDownSet)}: Combine \code{AbstractTopDownSet} objects.

\code{combine} allows to combine two or more \code{AbstractTopDownSet} objects.
Please note that it uses the default
\code{sampleColumns} to define technical replicates (see \code{\link[=readTopDownFiles]{readTopDownFiles()}}).and
the default \code{by} argument to group ion injection times for the calculation of
the median time (see \code{\link[=updateMedianInjectionTime]{updateMedianInjectionTime()}}). Both could be modified
after \code{combine} by calling \code{\link[=updateConditionNames]{updateConditionNames()}} (with modified
\code{sampleColumns} argument) and \code{\link[=updateMedianInjectionTime]{updateMedianInjectionTime()}} (with modified
\code{by} argument).

\item \code{conditionData(AbstractTopDownSet)}: Accessor for the \code{colData} slot.

An alias for \code{colData}.

\item \code{conditionData(AbstractTopDownSet) <- value}: Setter for the \code{colData} slot.

An alias for \verb{colData<-}.

\item \code{conditionNames(AbstractTopDownSet)}: Accessor for condition names.

Returns a \code{character} with names for the conditions/runs (columns).

\item \code{dim(AbstractTopDownSet)}: Accessor for dimensions.

Returns a \code{numeric} with number of fragments/bonds (rows) and
conditions/runs (columns).

\item \code{dimnames(AbstractTopDownSet)}: Accessor for dimension names.

Returns a \code{list} with names for the fragments/bonds (rows) and for the
conditions/runs (columns).

\item \code{removeEmptyConditions(AbstractTopDownSet)}: Remove empty conditions/runs.

Removes conditions/runs (columns) without any intensity/coverage
information from the \linkS4class{AbstractTopDownSet} object.
It returns a modified \linkS4class{AbstractTopDownSet} object.

\item \code{rowViews(AbstractTopDownSet)}: Accessor for the \code{rowViews} slot.

Depending on the implementation it returns an
\linkS4class{FragmentViews} object for
\linkS4class{TopDownSet} objects
or an \link[Biostrings:XStringViews-class]{Biostrings::XStringViews} object for
\linkS4class{NCBSet} objects.

\item \code{summary(AbstractTopDownSet)}: Summary statistics.

Returns a \code{matrix} with some statistics: number of fragments,
total/min/first quartile/median/mean/third quartile/maximum of intensity
values.

\item \code{updateConditionNames(AbstractTopDownSet)}: Update condition names.

Updates condition names based on \code{sampleColumns} from
\code{conditionData}/\code{colData}. Columns with just identical entries are ignored.
This method will create/update the \code{colData(object)$Sample} column that
identifies technical replicates and could be used in other methods.

\item \code{updateMedianInjectionTime(AbstractTopDownSet)}: Update median ion injection times.

Recalculates median ion injection times by a user given grouping variable
(default: Mz, AgcTarget). This is useful if you acquire new data and the ion
injection time differs across the runs. Use the \code{by} argument to provide a
\code{list}/\code{data.frame} of grouping variables, e.g.
\code{by=colData(object)[, c("Mz", "AgcTarget", "File")]}.

}}
\section{Slots}{

\describe{
\item{\code{rowViews}}{\link[Biostrings:XStringViews-class]{Biostrings::XStringViews},
information about fragments/bonds (name, type, sequence, mass, charge),
see \link[Biostrings:XStringViews-class]{Biostrings::XStringViews} and
\linkS4class{FragmentViews} for details.}

\item{\code{colData}}{\link[S4Vectors:DataFrame-class]{S4Vectors::DataFrame},
information about the MS2 experiments and the fragmentation conditions.}

\item{\code{assay}}{\link[Matrix:dgCMatrix-class]{Matrix::dgCMatrix},
intensity/coverage values of the fragments/bonds.
The rows correspond to the fragments/bonds and the
columns to the condition/run. It just stores values that are
different from zero.}

\item{\code{files}}{\code{character}, files that were imported.}

\item{\code{processing}}{\code{character}, log messages.}
}}

\examples{
## Because AbstractTopDownSet is a VIRTUAL class we could not create any
## object of it. Here we demonstrate the usage with an TopDownSet that
## implements the AbstractTopDownSet interface. See `?"TopDownSet-class"` for
## more details an further examples.

## Example data
data(tds, package="topdownr")

tds

head(summary(tds))

# Accessing slots
rowViews(tds)
colData(tds)
head(assayData(tds))

# Accessing colData
tds$Mz
tds$FilterString

# Subsetting

# First 100 fragments
tds[1:100]

# All c fragments
tds["c"]

# Just c 152
tds["c152"]

# Condition 1 to 10
tds[, 1:10]
}
\seealso{
\itemize{
\item \linkS4class{TopDownSet} and \linkS4class{NCBSet}
which both implement/use this interface.
These manual pages also provide some example code.
\item \linkS4class{FragmentViews}
(and \link[Biostrings:XStringViews-class]{Biostrings::XStringViews})
for the row view interface.
\item \link[Matrix:dgCMatrix-class]{Matrix::dgCMatrix}
for technical details about the intensity/coverage storage.
}
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/windows.R
\name{createTngFusionMethFiles}
\alias{createTngFusionMethFiles}
\alias{runXmlMethodChanger}
\alias{runScanHeadsman}
\title{Windows specific functions.}
\usage{
createTngFusionMethFiles(
  template,
  xml = list.files(pattern = ".*\\\\.xml$"),
  executable = "XmlMethodChanger.exe",
  verbose = interactive()
)

runXmlMethodChanger(
  template,
  xml = list.files(pattern = ".*\\\\.xml$"),
  executable = "XmlMethodChanger.exe",
  verbose = interactive()
)

runScanHeadsman(path = ".", executable = "ScanHeadsman.exe")
}
\arguments{
\item{template}{\code{character}, path to template \code{.meth} file.}

\item{xml}{\code{character}, vector of path to \code{.xml} files.}

\item{executable}{\code{character}, path to the \code{XmlMethodChanger.exe} or
\code{ScanHeadsman.exe} executable.}

\item{verbose}{\code{logical}, if \code{TRUE} a progress bar is shown.}

\item{path}{\code{character},
path to the directory containing the \code{.raw} files.}
}
\value{
Nothing. Used for its side effects.
}
\description{
The functions \code{runXmlMethodChanger} and \code{runScanHeadsman} call
\code{XmlMethodChanger.exe} and \code{ScanHeadsman.exe}
with the corresponding arguments.
This only work on Windows (maybe on Linux + wine as well but that was never
tested).
}
\details{
\code{runXmlMethodChanger} applies ‘XmlMethodChanger.exe’ on all given XML files
generated with \code{\link[=writeMethodXmls]{writeMethodXmls()}}
to create \code{.meth} files from a template.

\code{runScanHeadsman} calls \code{ScanHeadsman.exe}
on a given directory containing \code{.raw} files.
\code{ScanHeadsman.exe} extracts the method and scan header data
into \code{.experiments.csv} and \code{.txt} files, respectively.
}
\examples{
\dontrun{
runXmlMethodChanger(templateMeth="TMS2IndependentTemplate240Extended.meth",
                    modificationXml=list.files(pattern="^method.*\\\\.xml$"),
                    executable="..\\\\XmlMethodChanger.exe")
}
\dontrun{
runScanHeadsman("raw", executable="..\\\\ScanHeadsman.exe")
}
}
\references{
XmlMethodChanger source code:
https://github.com/thermofisherlsms/meth-modifications/

ScanHeadsman source code:
https://bitbucket.org/caetera/scanheadsman
}
\seealso{
\code{\link[=writeMethodXmls]{writeMethodXmls()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/package.R
\docType{package}
\name{topdownr-package}
\alias{topdownr}
\alias{topdownr-package}
\title{Investigation of Fragmentation Conditions in Top-Down Proteomics}
\description{
The topdownr package allows automatic and systemic investigation of
fragment conditions. It creates Thermo Orbitrap Fusion Lumos method files
to test hundreds of fragmentation conditions. Additionally it provides
functions to analyse and process the generated MS data and determine the
best conditions to maximise overall fragment coverage.
}
\details{
The usage of the topdownr package is demonstrated in the following vignettes:
\itemize{
\item Generate .meth files prior data acquisition for the Thermo Orbitrap Fusion
Lumos MS devise: \code{vignette("data-generation", package="topdownr")}.
\item How to analyse top-down fragmenation data:
\code{vignette("analysis", package="topdownr")}
}
}
\references{
\url{https://codeberg.org/sgibb/topdownr/}
}
\seealso{
Useful links:
\itemize{
  \item \url{https://codeberg.org/sgibb/topdownr/}
  \item Report bugs at \url{https://codeberg.org/sgibb/topdownr/issues/}
}

}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de},
Pavel Shliaha \email{pavels@bmb.sdu.dk},
Ole Nørregaard Jensen \email{jenseno@bmb.sdu.dk}
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/method-xml.R
\name{writeMethodXmls}
\alias{writeMethodXmls}
\title{Create Orbitrap Fusion Lumos method.xml files.}
\usage{
writeMethodXmls(exps, pattern = "method-\%s.xml", verbose = interactive())
}
\arguments{
\item{exps}{\code{list}, generated by e.g.
\code{\link[=createExperimentsFragmentOptimisation]{createExperimentsFragmentOptimisation()}}}

\item{pattern}{\code{character}, file name pattern for the method.xml files.}

\item{verbose}{\code{logical}, verbose output?}
}
\description{
This function is used to create Orbitrap Fusion Lumos method files from
a tree-like \code{list} experiment generated by e.g.
\code{\link[=createExperimentsFragmentOptimisation]{createExperimentsFragmentOptimisation()}}.
}
\details{
\itemize{
\item \code{exps}: a named tree-like \code{list} object generated by e.g.
\code{\link[=createExperimentsFragmentOptimisation]{createExperimentsFragmentOptimisation()}}. Its names are used as filename.
\item \code{pattern}: The file name pattern used to name different method files.
It must contain a \code{"\%s"} that is replaced by the conditions defined in
\code{groupBy}.
}

\strong{DEFUNCT} options:
\itemize{
\item \code{ms1Settings}:
A \code{list} of MS1 settings. This has to be a named \code{list}.
Valid MS1 settings are:
\code{c("FirstMass", "LastMass", "Microscans", "MaxITTimeInMS", "AgcTarget")}
\item \code{ms2Settings}:
A \code{list} of MS2 settings. This has to be a named \code{list}.
Valid MS2 settings are:
\code{c("ActivationType", "IsolationWindow", "EnableMultiplexIons", "EnableMSXIds", "MaxNoOfMultiplexIons", "OrbitrapResolution", "AgcTarget", "MinAgcTarget", "MaxITTimeInMS", "Microscans", "ETDReactionTime", "ETDReagentTarget", "MaximumETDReagentInjectionTime", "UseInternalCalibratedETD", "ETDSupplementalActivationEnergy", "ETDSupplementalActivation")}
\item \code{groupBy}: The \code{groupBy} parameter is used to split methods into
different files. Valid entries are all settings that could be used in
\code{ms2Settings} and \code{"replication"}.
\item \code{massLabeling}: The Orbitrap Fusion devices seems not to respect the
start and end times of the runs given in the method.xml files. That's why it
is nearly impossible to identify the run with its conditions based on the
timings. If \code{massLabeling} is \code{TRUE} (default) the mass values given
in \code{mz} are rounded to the first decimal place and the second to fourth
decimal place is used as numeric identifier.
}
}
\examples{
ms1 <- expandMs1Conditions(FirstMass=400, LastMass=1200, Microscans=as.integer(10))

targetMz <- cbind(mz=c(560.6, 700.5, 933.7), z=rep(1, 3))
common <- list(
    OrbitrapResolution="R120K",
    IsolationWindow=1,
    MaxITTimeInMS=200,
    Microscans=as.integer(40),
    AgcTarget=c(1e5, 5e5, 1e6)
)
cid <- expandTms2Conditions(
    MassList=targetMz,
    common,
    ActivationType="CID",
    CIDCollisionEnergy=seq(7, 35, 7)
)
hcd <- expandTms2Conditions(
    MassList=targetMz,
    common,
    ActivationType="HCD",
    HCDCollisionEnergy=seq(7, 35, 7)
)
etd <- expandTms2Conditions(
    MassList=targetMz,
    common,
    ActivationType="ETD",
    ETDReagentTarget=c(1e6, 5e6, 1e7),
    ETDReactionTime=c(2.5, 5, 10, 15, 30, 50),
    ETDSupplementalActivation=c("None", "ETciD", "EThcD"),
    ETDSupplementalActivationEnergy=seq(7, 35, 7)
)
exps <- createExperimentsFragmentOptimisation(ms1=ms1, cid, hcd, etd,
    groupBy=c("AgcTarget", "replication"), nMs2perMs1=10, scanDuration=0.5,
    replications=2, randomise=TRUE
)
writeMethodXmls(exps=exps)
}
\seealso{
\code{\link[=createExperimentsFragmentOptimisation]{createExperimentsFragmentOptimisation()}}
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}, Pavel V. Shliaha
\email{pavels@bmb.sdu.dk}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tds.R
\docType{data}
\name{tds}
\alias{tds}
\title{TopDownSet Example Data}
\format{
A \linkS4class{TopDownSet}
with 14901 fragments (1949 rows, 351 columns).
}
\source{
Subset taken from the
\link[topdownrdata:topdownrdata-package]{topdownrdata::topdownrdata-package}
package.
}
\usage{
tds
}
\description{
An example data set for \code{topdownr}. It is just a subset of the myoglobin
dataset available in
\link[topdownrdata:topdownrdata-package]{topdownrdata::topdownrdata-package}.
}
\details{
It was created as
follows:

\if{html}{\out{<div class="sourceCode">}}\preformatted{tds <- readTopDownFiles(
   topdownrdata::topDownDataPath("myoglobin"),
   ## Use an artifical pattern to load just the fasta
   ## file and files from m/z == 1211, ETD reagent
   ## target 1e6 and first replicate to keep runtime
   ## of the example short
   pattern=".*fasta.gz$|1211_.*1e6_1",
   adducts=data.frame(mass=1.008, name="zpH", to="z"),
   neutralLoss=PSMatch::defaultNeutralLoss(
       disableWaterLoss=c("Cterm", "D", "E", "S", "T")),
   tolerance=25e-6)
}\if{html}{\out{</div>}}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/methods-TopDownSet.R
\docType{class}
\name{TopDownSet-class}
\alias{TopDownSet-class}
\alias{aggregate,TopDownSet-method}
\alias{combine,TopDownSet,TopDownSet-method}
\alias{filterCv,TopDownSet-method}
\alias{filterCv}
\alias{filterInjectionTime,TopDownSet-method}
\alias{filterInjectionTime}
\alias{filterIntensity,TopDownSet-method}
\alias{filterIntensity}
\alias{filterNonReplicatedFragments,TopDownSet-method}
\alias{filterNonReplicatedFragments}
\alias{normalize,TopDownSet-method}
\alias{plot,TopDownSet,missing-method}
\alias{show,TopDownSet-method}
\alias{summary,TopDownSet-method}
\alias{coerce,TopDownSet,MSnSet-method}
\alias{coerce,TopDownSet,NCBSet-method}
\title{The TopDownSet class}
\usage{
\S4method{aggregate}{TopDownSet}(x, by = x$Sample, ...)

\S4method{combine}{TopDownSet,TopDownSet}(x, y)

\S4method{filterCv}{TopDownSet}(object, threshold, by = object$Sample, ...)

\S4method{filterInjectionTime}{TopDownSet}(
  object,
  maxDeviation = log2(3),
  keepTopN = 2,
  by = object$Sample,
  ...
)

\S4method{filterIntensity}{TopDownSet}(object, threshold, relative = TRUE, ...)

\S4method{filterNonReplicatedFragments}{TopDownSet}(object, minN = 2, by = object$Sample, ...)

\S4method{normalize}{TopDownSet}(object, method = "TIC", ...)

\S4method{plot}{TopDownSet,missing}(x, y, ..., verbose = interactive())

\S4method{show}{TopDownSet}(object)

\S4method{summary}{TopDownSet}(object, what = c("conditions", "fragments"), ...)
}
\arguments{
\item{x, object}{\code{TopDownSet}}

\item{by}{\code{list},
grouping variable, in general it refers to technical}

\item{y}{\code{missing}, not used.}

\item{threshold}{\code{double}, threshold variable.}

\item{maxDeviation}{\code{double},
maximal allowed deviation in the \code{log2}
injection time in ms in comparison to the median ion injection time.}

\item{keepTopN}{\code{integer}, how many technical replicates should be kept?}

\item{relative}{\code{logical},
if relative is \code{TRUE} all fragments with
intensity below \code{threshold * max(intensity)}
per fragment are removed,
otherwise all fragments below \code{threshold} are removed.}

\item{minN}{\code{numeric},
if less than \code{minN} of a fragment are found across
technical replicates it is removed.}

\item{method}{\code{character},
normalisation method, currently just \code{"TIC"}
for \emph{T}otal \emph{I}on \emph{C}urrent
normalisation of the scans/conditions (column-wise normalisation)
is supported.}

\item{verbose}{\code{logical}, verbose output?}

\item{what}{\code{character},
specifies whether \code{"conditions"} (columns; default)
or \code{"fragments"} (rows) should be summarized.}

\item{\ldots}{arguments passed to internal/other methods.
replicates (that's why the default is the
\code{"Sample"} column in \code{colData}).}
}
\value{
An \linkS4class{TopDownSet} object.
}
\description{
The TopDownSet class is a container for a whole top-down proteomics
experiment.
}
\details{
See \code{vignette("analysis", package="topdownr")}
for a detailed example how to work with
\code{TopDownSet} objects.
}
\section{Methods (by generic)}{
\itemize{
\item \code{aggregate(TopDownSet)}: Aggregate conditions/runs.

Aggregates conditions/runs (columns) in an
\linkS4class{TopDownSet} object
\code{by} a
user-given value (default is the
\code{"Sample"} column of \code{colData}
which has the same value for technical replicates).
It combines intensity values and numeric metadata of the grouped
conditions/runs (columns) by \code{mean} and returns a reduced
\linkS4class{TopDownSet} object.

\item \code{combine(x = TopDownSet, y = TopDownSet)}: Combine \code{TopDownSet} objects.

\code{combine} allows to combine two or more \code{TopDownSet} objects.
Please note that it uses the default
\code{sampleColumns} to define technical replicates (see \code{\link[=readTopDownFiles]{readTopDownFiles()}}).and
the default \code{by} argument to group ion injection times for the calculation of
the median time (see \code{\link[=updateMedianInjectionTime]{updateMedianInjectionTime()}}). Both could be modified
after \code{combine} by calling \code{\link[=updateConditionNames]{updateConditionNames()}} (with modified
\code{sampleColumns} argument) and \code{\link[=updateMedianInjectionTime]{updateMedianInjectionTime()}} (with modified
\code{by} argument).

\item \code{filterCv(TopDownSet)}: Filter by CV.

Filtering is done by coefficient of variation across technical replicates
(defined by the \code{by} argument).
All fragments below a given \code{threshold}
are removed. The \code{threshold} is the maximal allowed CV in percent
(\code{sd/mean * 100 < threshold}).

\item \code{filterInjectionTime(TopDownSet)}: Filter by ion injection time.

Filtering is done by maximal allowed deviation and just the technical
\code{keepTopN} replicates with the lowest deviation from the median ion
injection time are kept.

\item \code{filterIntensity(TopDownSet)}: Filter by intensity.

Filtering is done by removing all fragments that are below a given
(absolute/relative) intensity \code{threshold}.

\item \code{filterNonReplicatedFragments(TopDownSet)}: Filter by non-replicated fragments.

Filtering is done by removing all fragments that don't replicate across
technical replicates.

\item \code{normalize(TopDownSet)}: Normalise.

Applies \emph{T}otal \emph{I}on \emph{C}urrent normalisation to a
\linkS4class{TopDownSet} object.
The normalisation ist done per scans/conditions (column-wise normalisation).

\item \code{plot(x = TopDownSet, y = missing)}: Plotting.

Plots an \linkS4class{TopDownSet} object. The function returns a \code{list}
of \code{ggplot} objects (one item per condtion).
Use \code{pdf} or another non-interactive device to plot the list of \code{ggplot}
objects (see example section).

\item \code{summary(TopDownSet)}: Summary statistics.

Returns a \code{matrix}
with some statistics: number of fragments,
total/min/first quartile/median/mean/third quartile/maximum of
intensity values.

}}
\section{Slots}{

\describe{
\item{\code{rowViews}}{\linkS4class{FragmentViews},
information about fragments (name, type, sequence, mass, charge), see
\linkS4class{FragmentViews} for details.}

\item{\code{colData}}{\link[S4Vectors:DataFrame-class]{S4Vectors::DataFrame},
information about the MS2 experiments and the fragmentation conditions.}

\item{\code{assay}}{\link[Matrix:dgCMatrix-class]{Matrix::dgCMatrix},
intensity values of the fragments. The
rows correspond to the fragments and the columns to the condition/run. It
just stores values that are different from zero.}

\item{\code{files}}{\code{character}, files that were imported.}

\item{\code{tolerance}}{\code{double},
tolerance in \emph{ppm} that were used for matching the
experimental mz values to the theoretical fragments.}

\item{\code{redundantMatching}}{\code{character}, matching strategies for redundant
ion/fragment matches. See \code{redundantIonMatch} and
\code{redundantFragmentMatch} in \code{\link[=readTopDownFiles]{readTopDownFiles()}} for details.}

\item{\code{processing}}{\code{character}, log messages.}
}}

\section{Coercion}{


`as(object, "MSnSet"): Coerce an \linkS4class{TopDownSet} object into an
\link[MSnbase:MSnSet-class]{MSnbase::MSnSet} object.



`as(object, "NCBSet"): Coerce an \linkS4class{TopDownSet} object into an
\linkS4class{NCBSet} object.
}

\examples{
## Example data
data(tds, package="topdownr")

tds

head(summary(tds))

# Accessing slots
rowViews(tds)
colData(tds)
head(assayData(tds))

# Accessing colData
tds$Mz
tds$FilterString

# Subsetting

# First 100 fragments
tds[1:100]

# All c fragments
tds["c"]

# Just c 152
tds["c152"]

# Condition 1 to 10
tds[, 1:10]

# Filtering
# Filter all intensities that don't have at least 10 \% of the highest
# intensity per fragment.
tds <- filterIntensity(tds, threshold=0.1)

# Filter all conditions with a CV above 30 \% (across technical replicates)
tds <- filterCv(tds, threshold=30)

# Filter all conditions with a large deviation in injection time
tds <- filterInjectionTime(tds, maxDeviation=log2(3), keepTopN=2)

# Filter all conditions where fragments don't replicate
tds <- filterNonReplicatedFragments(tds)

# Normalise by TIC
tds <- normalize(tds)

# Aggregate technical replicates
tds <- aggregate(tds)

head(summary(tds))

# Coercion
as(tds, "NCBSet")

if (require("MSnbase")) {
    as(tds, "MSnSet")
}
\dontrun{
# plot a single condition
# pseudo-code (replace topdownset with your object)
plot(topdownset[,1])

# plot the whole object
pdf("topdown-spectra.pdf", paper="a4r", width=12)
# pseudo-code (replace topdownset with your object)
plot(topdownset)
dev.off()
}
}
\seealso{
\itemize{
\item \linkS4class{FragmentViews}
for the row view interface.
\item \link[Matrix:dgCMatrix-class]{Matrix::dgCMatrix}
for technical details about the intensity storage.
\item \code{?vignette("analysis", package="topdownr")}
for a full documented example of an analysis using \code{topdownr}.
}
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}
